2025-12-11  Automatically generated  <bug-mailutils@gnu.org>

	HEAD b6254c496de66346cd4e7c5a9ced188d86adee2a.

2025-12-11  Sergey Poznyakoff  <gray@gnu.org>

	Version 3.21.

2025-10-27  Sergey Poznyakoff  <gray@gnu.org>

	New commands for string expansion: localuser and detail.

2025-10-12  Sergey Poznyakoff  <gray@gnu.org>

	Fix algorithm of reading recipient addresses from the message
	headers.

	* doc/texinfo/mailutils.texi: Document changes.
	* libproto/mailer/mailbox.c (remote_mbox_append_message):
	Remove parameter handling. This is done by the mailer. This way
	it closely corresponds to the documentation. In the long run it
	will be reimplemented in mailbox, so it can be extended on
	other mailer types as well.
	* libproto/mailer/smtp.c: Handle additional URL parameters:
	ehlo, domain, strip-domain, read-recipients, and
	recipient-headers.
	* libproto/mailer/tests/.gitignore: Update.
	* libproto/mailer/tests/Makefile.am: Add new tests.
	* libproto/mailer/tests/mboxapnd.at: New file.
	* libproto/mailer/tests/mboxapnd.c: New file.
	* libproto/mailer/tests/smtp-url.at: New file.
	* libproto/mailer/tests/sends.c: Recipient names in command
	line are optional.
	* libproto/mailer/tests/seqsend.at: New tests.
	* libproto/mailer/tests/testsuite.at (SEND_CHECK): New macro.
	Include the smtp-url.at test.

2025-10-11  Sergey Poznyakoff  <gray@gnu.org>

	Version 3.20.93.

2025-10-11  Sergey Poznyakoff  <gray@gnu.org>

	Bugfix.

	* libmu_sieve/extensions/Makefile.am: Build uidnew only if
	MU_COND_DBM condition is set.

2025-10-10  Sergey Poznyakoff  <gray@gnu.org>

	Fix bug in mu_address_dup.

	* libmailutils/address/address.c (mu_address_dup): Duplicate
	entire address structure.

2025-10-08  Sergey Poznyakoff  <gray@gnu.org>

	Make sure help output uses the correct translation domain.

	When outputting help (both for command line usage and for
	configuration file syntax), care should be taken to use proper
	translation domain: "mailutils" for entities defined in
	libmailutils and associated libraries (so called "canned
	entries"), and application domain for the entries defined in
	the application.

	This fixes a long-standing bug, originally reported by Rafael
	Fontenelle in:
	https://mail.gnu.org.ua/mailman/listarchive/bug-mailfromd/2018-
	04/msg00027.html

	* include/mailutils/cfg.h (struct mu_cfg_section): New field:
	domain.
	(struct mu_cfg_cont): Likewise.
	(mu_cfg_section_add_params_ext): New proto.
	(mu_cfg_section_add_params): Rewrite as alternative entrypoint
	to the above.
	(mu_create_canned_section_ext,mu_create_canned_param_ext): New
	proto.
	(mu_create_canned_section,mu_create_canned_param): Rewrite as
	alternative entrypoints to the above.
	(mu_config_container_register_section)
	(mu_config_root_register_section)
	(mu_config_register_plain_section): Change prototype; add new
	argument: domain.
	* include/mailutils/cli.h (struct mu_cli_capa): New field:
	domain.
	(struct mu_cli_setup): Likewise.
	* include/mailutils/opt.h (struct mu_option): New field:
	opt_domain.
	(MU_OPTION_GROUP_EXT): New macro. 
	* libmailutils/cfg/driver.c (mu_create_canned_section_ext): New
	function. Creates a canned section and assigns it a translation
	domain.
	(mu_create_canned_param_ext): New function. Same for canned
	parameter.
	(dup_container): Preserve domain.
	(mu_cfg_section_add_params_ext): New function. Adds parameters
	with the given translation domain.
	(mu_config_container_register_section): Change signature; take
	translation domain as additional argument.
	(mu_config_root_register_section): Likewise.
	(mu_config_register_plain_section): Likewise.
	* libmailutils/cfg/format.c (format_param,format_section): Take
	translation domain as arugment.
	(format_container): Pass container translation domain as
	argument to underlying functions. 
	* libmailutils/cli/capa.c (mu_cli_capa_register): Pass on the
	domain.
	(capa_extend): Pass domain to mu_config_root_register_section.
	* libmailutils/cli/cli.c: Explicitly initialize the opt_domain
	field in canned options.
	* libmailutils/opt/opt.c: Likewise.
	* libmailutils/cli/stdcapa.c: Explicitly initialize the
	opt_domain field in canned options and domain in
	mu_cli_std_capa entries.
	* libmailutils/opt/help.c: Use correct translation domain when
	outputting help. 
	* libmailutils/auth/mu_auth.c: Use
	mu_config_root_register_section to ensure correct translation
	domain.
	* libmu_auth/radius.c (mu_cli_capa_radius): Explicitly
	initialize domain.
	* lib/manlock.c: Use mu_create_canned_section_ext and
	mu_cfg_section_add_params_ext to ensure correct translation
	domain.
	* lib/tcpwrap.c: Likewise.
	* libmailutils/cli/acl.c: Likewise.
	* libmailutils/server/msrv.c: Likewise.
	* libmu_auth/tlsconf.c: Likewise.
	* libmu_sieve/conf.c: Explicitly initialize the opt_domain
	field in canned options and domain in mu_cli_std_capa entries. 
	* NEWS: Document the change.

2025-10-08  Sergey Poznyakoff  <gray@gnu.org>

	Fix stupid typo.

2025-10-08  Sergey Poznyakoff  <gray@gnu.org>

	Mark translatable strings.

2025-10-06  Sergey Poznyakoff  <gray@gnu.org>

	Fix commit de6f346600.

	The change in quote handling in mu_str_expand caused grief in
	SQL authentication: the SQL queries in getpwnam or getpass
	statements could contain SQL expressions involving quoted
	strings, and these quotes would have been removed during
	variable expansion. To prevent this, introduce new expansion
	functions which allow the caller to specify whether unquoting
	is necessary.

	* include/mailutils/cstr.h (mu_str_expand_unquote)
	(mu_str_vexpand_unquote): New protos.
	(mu_str_expand): Rewrite as an inline wrapper over
	mu_str_expand_unquote.
	* libmailutils/string/expvar.c (mu_str_expand_unquote)
	(mu_str_vexpand_unquote): New functions.
	(mu_str_vexpand): Rewrite as an entry point to
	mu_str_vexpand_unquote.
	* libmu_auth/ldap.c (fill_auth_data): Use mu_str_expand_unquote
	and request unquoting.

2025-10-04  Sergey Poznyakoff  <gray@gnu.org>

	Fix memory leaks in sieve library.

	* libmu_sieve/environment.c (mu_sieve_set_environ): Set the
	destroy_item function.
	* libmu_sieve/registry.c (regunload): Free the argument.
	(mu_i_sv_registry_add): Use malloc instead of mu_sieve_malloc.
	* libmu_sieve/sieve-gram.y: Free identifiers returned by the
	lexer.
	(node_replace): Handle mu_sieve_node_allof and
	mu_sieve_node_anyof. Free repl. Fix freeing copy.
	(mu_sieve_machine_destroy): Free exenv.
	* libmu_sieve/sieve-lex.l (TAG): Allocate in sieve machine
	memory pool.
	* libproto/maildir/folder.c (subdir_exists): Free allocated
	memory.

2025-10-03  Sergey Poznyakoff  <gray@gnu.org>

	Fix some diagnostic messages.

2025-10-01  Sergey Poznyakoff  <gray@gnu.org>

	Version 3.20.92.

2025-09-27  Sergey Poznyakoff  <gray@gnu.org>

	Remove unsupported gnulib module.

2025-09-27  Sergey Poznyakoff  <gray@gnu.org>

	Remove unsupported file.

	* mu-aux/mailutils.spec.in: Remove.
	* configure.ac: Likewise.
	* mu-aux/Makefile.am: Likewise.

2025-09-27  Sergey Poznyakoff  <gray@gnu.org>

	Rewrite mu_umaxtostr interface.

	* lib/mu_umaxtostr.c: Use fixed-size buffer space.
	(mu_umaxtostr_n): New function.
	* lib/mu_umaxtostr.h (MU_UMAXTOSTR_IDX_MAX): New constant.
	(mu_umaxtostr_n): New proto.
	(mu_umaxtostr): Remove. Add an inline declaration with that
	name. Notice, that both the return type and signature change. 
	* imap4d/fetch.c: Fix/replace calls to mu_umaxtostr.
	* imap4d/preauth.c: Likewise.
	* imap4d/search.c: Likewise.
	* mail/from.c: Likewise.
	* mh/burst.c: Likewise.
	* mh/comp.c: Likewise.
	* mh/compcommon.c: Likewise.
	* mh/folder.c: Likewise.
	* mh/mboxprop.c: Likewise.
	* mh/mh_init.c: Likewise.
	* mh/mhn.c: Likewise.
	* mh/mhpath.c: Likewise.
	* mh/pick.c: Likewise.
	* mh/repl.c: Likewise.
	* mh/send.c: Likewise.
	* mh/show.c: Likewise.
	* mh/sortm.c: Likewise.
	* mh/whatnowenv.c: Likewise.
	* pop3d/bulletin.c: Likewise.
	* pop3d/capa.c: Likewise.
	* pop3d/dele.c: Likewise.
	* pop3d/list.c: Likewise.
	* pop3d/stat.c: Likewise.
	* pop3d/uidl.c: Likewise.
	* pop3d/user.c: Likewise.

2025-09-27  Sergey Poznyakoff  <gray@gnu.org>

	Bugfix.

	* libmailutils/string/quotename.c (mu_quotename_n): Fix range
	checking.

2025-09-26  Sergey Poznyakoff  <gray@gnu.org>

	Further cleanup in diagnostics.

	Use mu_quotename to include file names and similar strings into
	diagnostic messages. Consistently use single-quotes wherever
	applicable.

2025-09-26  Sergey Poznyakoff  <gray@gnu.org>

	New functions: mu_quotename_n and mu_quotename.

	* include/mailutils/cstr.h (mu_c_str_escape_length)
	(mu_c_str_escape_buf, mu_c_str_escape_mem)
	(mu_quotename_n): New protos.
	(mu_quotename_n): New function. (MU_QUOTENAME_IDX_MAX)
	(MU_QUOTENAME_SIZE_MAX): New macros.
	* libmailutils/string/cstrescape.c (mu_c_str_escape_length)
	(mu_c_str_escape_buf,mu_c_str_escape_mem): New functions.
	(mu_c_str_escape): Rewrite.
	* libmailutils/string/quotename.c: New file.
	* libmailutils/string/Makefile.am: Add new file.

2025-09-25  Sergey Poznyakoff  <gray@gnu.org>

	Prefer mu_diag_funcall to diagnose unqualified system failures.

2025-09-24  Sergey Poznyakoff  <gray@gnu.org>

	Minor fix in mda.

	* mda/lib/script.c (mda_filter_message): Create homedir first,
	then switch to user privileges.

2025-09-24  Sergey Poznyakoff  <gray@gnu.org>

	Reword some diagnostics; more translators' comments.

2025-09-24  Sergey Poznyakoff  <gray@gnu.org>

	Fix some messages; add comments to translators.

2025-09-24  Sergey Poznyakoff  <gray@gnu.org>

	Fix in mda testsuite.

	* mda/tests/mda.inc (MDA_OPTIONS): Always use --no-config.

2025-09-24  Sergey Poznyakoff  <gray@gnu.org>

	One more fix.

2025-09-24  Sergey Poznyakoff  <gray@gnu.org>

	Bugfix.

	* libmu_sieve/actions.c (sieve_action_fileinto): Bail out if
	unable to create output mailbox.

2025-09-23  Sergey Poznyakoff  <gray@gnu.org>

	Version 3.20.91.

2025-09-23  Sergey Poznyakoff  <gray@gnu.org>

	Fix some typos; update POTFILES.in.

2025-09-23  Sergey Poznyakoff  <gray@gnu.org>

	Introduce homedir configuration statement.

	The new statement is used by imap4d and mda family.

	* libmailutils/cli/stdcapa.c (mu_homedir_assert): New function.
	(mu_cli_std_capa): Declare new capability: "homedir".
	* include/mailutils/util.h (mu_homedir_create)
	(mu_homedir_mode): New externs.
	(mu_homedir_assert): New proto.
	* libmailutils/base/interdir.c (mkinterdir): Qualify as static. 
	* imap4d/imap4d.c (capa): Add "homedir". Rewrite handlers for
	create-home-dir and home-dir-mode statements. Mark both as
	deprecated.
	(imap4d_session_setup0): Use mu_homedir_assert.
	(imap4d_check_home_dir): Remove.
	* imap4d/imap4d.h (imap4d_check_home_dir): Remove.
	* mda/lib/script.c (mda_filter_message): Use mu_homedir_assert.
	* mda/lmtpd/lmtpd.c (capa): Use "homedir".
	* mda/mda/mda.c: Likewise.
	* mda/putmail/putmail.c: Likewise. 
	* doc/texinfo/programs.texi: Document changes.
	* doc/texinfo/programs/imap4d.texi: Likewise.
	* doc/texinfo/programs/lmtpd.texi: Likewise.
	* doc/texinfo/programs/mda.texi: Likewise.
	* doc/texinfo/programs/putmail.texi: Likewise.
	* NEWS: Likewise.

2025-09-23  Sergey Poznyakoff  <gray@gnu.org>

	Minor fixes.

	* libmailutils/cfg/driver.c (mu_cfg_field_map): Emit a
	deprecation warning if string is used as an argument.
	* libmailutils/string/strlst.c (mu_string_split): Escape all
	delimiter characters.

2025-09-23  Sergey Poznyakoff  <gray@gnu.org>

	Document changes in de6f346600.

2025-09-19  Sergey Poznyakoff  <gray@gnu.org>

	Minor change.

	* libmu_sieve/util.c (mu_sieve_error): Turn on MU_LOGMODE_LOCUS
	mode.

2025-09-19  Sergey Poznyakoff  <gray@gnu.org>

	sieve: fix sigsegv on referencing ${0}

	* libmu_sieve/variables.c (mu_i_sv_expand_variables): Fix NULL
	dereference.

2025-09-19  Sergey Poznyakoff  <gray@gnu.org>

	Bugfix.

	* libmu_sieve/sieve-gram.y (mu_sieve_machine_destroy): Unload
	registry after destroying memory_pool. This fixes possible
	coredumps in cases when loaded modules have registered cleanup
	routines in the pool.

2025-09-18  Sergey Poznyakoff  <gray@gnu.org>

	Bugfixes.

	* include/mailutils/wordsplit.h: Rename new symbols (follow-up
	to b8604cd3a5).
	* libmailutils/mailbox/folder.c (mu_folder_enumerate):
	Initialize scn with zeros.
	* libmailutils/string/strlst.c (mu_string_split): \ escapes
	itself and double quote.

2025-09-18  Sergey Poznyakoff  <gray@gnu.org>

	ldap auth: allow for non-attribute data in field map.

	* libmailutils/string/expvar.c (mu_str_expand): Handle single
	and double quotes in the input.
	* libmu_auth/ldap.c (_construct_attr_array): Select as
	attribute names only those values that start with a letter.
	Don't strdup returned values.
	(_mu_entry_to_auth_data): Rename to
	_mu_ldap_entry_to_auth_data. Rewrite, to allow field map to
	contain non-attribute data.
	* NEWS: Document changes.

2025-09-18  Sergey Poznyakoff  <gray@gnu.org>

	Cleanup.

	* include/mailutils/util.h (mutil_parse_field_map): Remove.
	* libmailutils/base/mutil.c (mutil_parse_field_map): Remove
	unused function.
	* libmailutils/mimetypes/grammar.y (yyprint): Remove unused
	function.

2025-09-18  Sergey Poznyakoff  <gray@gnu.org>

	Minor fix * libmailutils/base/amd.c (amd_open): Check for
	directory only if stat succeeded.

2025-09-17  Sergey Poznyakoff  <gray@gnu.org>

	Version 3.20.90.

2025-09-17  Sergey Poznyakoff  <gray@gnu.org>

	Upgrade wordsplit to 29cebfb4df.

2025-09-17  Sergey Poznyakoff  <gray@gnu.org>

	Minor fix.

	* libmailutils/string/strlst.c (mu_string_split): Allow for
	escaped delimiters.

2025-09-17  Sergey Poznyakoff  <gray@gnu.org>

	Follow-up to 017aea889b.

	* libmailutils/base/amd.c (amd_open): Create intermediate
	directories, if required.

2025-09-17  Sergey Poznyakoff  <gray@gnu.org>

	Optionally create intermediate directories when creating fs
	objects.

	* include/mailutils/stream.h (MU_STREAM_INTERDIR): New flag.
	* include/mailutils/util.h (mu_mkinterdir)
	(mu_filename_split): New proto.
	(mu_file_basename): New function.
	* libmailutils/base/filename.c (mu_filename_split): New
	function.
	* libmailutils/base/Makefile.am: Add interdir.c
	* libmailutils/base/interdir.c: New file.
	* libmailutils/base/amd.c (amd_open): Reset umask to 0 when
	creating directory.
	* libmailutils/base/permstr.c (mu_parse_stream_perm_string):
	Bugfix.
	* libmailutils/mailbox/fsfolder.c (_fsfolder_open): Create
	intermediate directories if MU_STREAM_INTERDIR is specified.
	* libmailutils/stream/file_stream.c (fd_open): Reset umask to 0
	when opening/creating file. Try mu_mkinterdir to fix ENOENT
	error, if MU_STREAM_INTERDIR flag is set.
	* libmu_sieve/actions.c (fileinto): New tag ":interdir" enables
	creating intermediate directories when opening mailbox.
	(perms_tag_checker): Bugfix: resolve string value.
	* sieve/tests/Makefile.am: Add new tests.
	* sieve/tests/action.at: Remove fileinto: tested separately.
	* sieve/tests/fileinto.at: New testcase.
	* sieve/tests/testsuite.at: Include new test.
	* testsuite/spool/sieve.mbox: Remove extra space.

2025-09-16  Sergey Poznyakoff  <gray@gnu.org>

	Minor fix (testsuite)

2025-09-16  Sergey Poznyakoff  <gray@gnu.org>

	libmu_sieve: bugfixes.

	* include/mailutils/sieve.h (mu_sieve_registry_clone): New
	proto.
	* libmu_sieve/registry.c (mu_sieve_registry_clone): New
	function.
	* libmu_sieve/sieve-gram.y (optimize_x_of): Handle case of
	single argument.
	(dump_node_x_of): Fix output.
	(node_replace): Preserve next nodes.
	(regdup): Use mu_sieve_registry_clone.
	(mu_sieve_machine_clone): Correctly initialize clone's state.
	(mu_sieve_machine_reset): Reset idspace and its counters.
	* libmu_sieve/sieve-priv.h (mu_i_sv_registry_add): New proto.
	* libproto/maildir/tests/isynccreat.at: Don't rely on GNU find
	features.
	* libproto/maildir/tests/isyncwrite.at: Likewise.

2025-07-30  Sergey Poznyakoff  <gray@gnu.org>

	Version 3.20.

2025-07-18  Sergey Poznyakoff  <gray@gnu.org>

	Fix in IMAP SEARCH.

	The UID SEARCH command incorrectly treated message range
	argument as UIDs instead of as message sequence numbers.

	* imap4d/search.c (parse_simple_key): The UID prefix does not
	affect the handling of sequence numbers.
	* imap4d/tests/search.at: Check if UID SEARCH handles sequence
	argument properly.

2025-06-14  Sergey Poznyakoff  <gray@gnu.org>

	Version 3.19.90.

	* configure.ac: Raise version number.
	* NEWS: Document the uidnew test.
	* doc/texinfo/sieve.texi: Likewise.

2025-06-14  Sergey Poznyakoff  <gray@gnu.org>

	New sieve test: uidnew.

	* libmu_sieve/extensions/uidnew.c: New file.
	* libmu_sieve/extensions/Makefile.am: Build uidnew.la 
	* libmailutils/tests/url.at: Test handling of "~" when
	MU_URL_PARSE_LOCAL flag is set.
	* libmailutils/url/create.c (_mu_url_ctx_parse_path) If
	MU_URL_PARSE_LOCAL flag is set, expand tilde in the pathname.
	(_mu_url_ctx_parse_host): Tilde pertains to path, not to the
	host.

2025-06-12  Sergey Poznyakoff  <gray@gnu.org>

	maildir: add compatibility tests.

	* libproto/maildir/maildir.c (isync_meta_update): Handle
	unexistent .uidvalidity file.
	* libproto/maildir/tests/Makefile.am: Add new tests.
	* libproto/maildir/tests/testsuite.at: Likewsise.
	* libproto/maildir/tests/isynccreat.at: New file.
	* libproto/maildir/tests/isyncread.at: New file.
	* libproto/maildir/tests/isyncwrite.at: New file.
	* libproto/maildir/tests/attfixup.at: Add copyleft header.
	* libproto/maildir/tests/uidfixup.at: Likewise.
	* libproto/maildir/tests/autodetect.at: Add autotest mode
	marker.
	* libproto/maildir/tests/notify.at: Likewise.

2025-06-12  Sergey Poznyakoff  <gray@gnu.org>

	maildir: create old-fashion delivery IDs in comparibility mode.

	Use URL parameters to explicitly set compatibility mode:

	 detect - detect the mode automatically (default);
	 none, mu - mailutils mode (modern delivery ids);
	 isync - isync mode (old-fashioned delivery ids). 
	* libmailutils/url/expand.c (mu_url_expand_path): Silently
	ignore unrecognized parameters.
	* libproto/maildir/maildir.c (maildir_open): Check URL
	parameters for compatibility mode settings.
	(maildir_scan_unlocked): Set compatibility mode to none, if not
	determined after mailbox scanning (that means an empty
	mailbox).
	(maildir_uniq_create): Rewrite. Create old-fashion delivery
	ids, if in isync compatibility mode. Insert random part id (R)
	when in normal mode.

2025-06-11  Sergey Poznyakoff  <gray@gnu.org>

	Improve maildir compatibility mode.

	* libproto/maildir/maildir.c (maildir_scan_unlocked)
	(maildir_msg_finish_delivery): Update isync .uidvalidity file.
	* include/mailutils/sys/amd.h (amd_get_uidvalidity): New proto.
	* libmailutils/base/amd.c (amd_get_uidvalidity): Make external.

2025-06-09  Sergey Poznyakoff  <gray@gnu.org>

	imap: recognize MU_ATTRIBUTE_SEEN.

	* libproto/imap/select.c (_mu_imap_collect_flags): Unless
	MU_ATTRIBUTE_RECENT is set, raise MU_ATTRIBUTE_SEEN.

2025-06-09  Sergey Poznyakoff  <gray@gnu.org>

	imap: avoid needless rescanning of mailboxes.

	* libproto/imap/mailbox.c (_imap_mbx_scan): Return immediately
	if the mailbox is up to date. All uses updated.
	(_imap_mbx_open): Don't scan the mailbox.

2025-06-09  Sergey Poznyakoff  <gray@gnu.org>

	Minor change.

	* libproto/imap/mailbox.c (_imap_mbx_scan): Do notification
	loop only if observable is defined.

2025-06-08  Sergey Poznyakoff  <gray@gnu.org>

	movemail: support uidnext synchronization mode.

	* doc/texinfo/programs/movemail.texi: Document changes.
	* NEWS: Likewise. 
	* movemail/movemail.c: Remove the --reverse option. The
	--max-messages option counts latest messages. New options:
	 --sync=mode sets the synchronization mode (all, uidnext,
	uidl).
	 --sync-dir=dir sets the directory for storing synchronization
	metadata.
	 --uidl now a synonim for --sync=uidl 
	* include/mailutils/mailbox.h (mu_mailbox_get_iterator_at): New
	proto.
	(mu_mailbox_get_iterator): Rewrite as inline function.
	* include/mailutils/sys/imap.h
	(_mu_imap_list_nth_element_is_string)
	(_mu_imap_list_nth_element_is_string_ci)
	(_mu_imap_list_at): Change the type of the position argument to
	size_t.
	* libmailutils/mailbox/mbxitr.c (struct mailbox_iterator): New
	fields: start, stop.
	(mbx_first): Start from itr->start.
	(mbx_finished_p): If stop is set, stop after returning the
	corresponding message.
	(mu_mailbox_get_iterator_at): New function. Returns iterator
	between two given message numbers or UIDs.
	* libproto/imap/mailbox.c (_imap_mbx_get_message): Initialize
	the _get_uid method.
	* libproto/imap/resplist.c (_mu_imap_list_at): Change the type
	of the position argument to size_t. If negative, count position
	from the end of the list. (_mu_imap_list_nth_element_is_string)
	(_mu_imap_list_nth_element_is_string_ci): Change the type of
	the position argument to size_t.
	* libproto/imap/resproc.c (parse_response_code): Fix list
	parsing.
	* libproto/maildir/maildir.c (maildir_create): Reset uidnext.
	(maildir_create): Reset uidnext.
	(maildir_scan0): Scan mailboxes opened for appends as well.
	* libproto/pop/mailbox.c (pop_get_message): Implement the
	_get_uidl method.

2025-06-07  Sergey Poznyakoff  <gray@gnu.org>

	maildir: compatibility mode with old-fashioned delivery
	identifiers.

	In particular, this provides compatibility with mailboxes
	created by isync.

	* include/mailutils/sys/amd.h (amd_update_uidvalidity): New
	proto.
	(MU_AMD_F_SCANNING): New flag.
	* libmailutils/base/amd.c (_amd_prop_create): Set the ro field
	in accordance with the mailbox open flags.
	(_amd_scan0): Avoid recursion. Set MU_AMD_F_INIT_SCAN bit on
	return.
	(amd_update_uidvalidity): New function.
	(amd_update_uidnext): Do nothing if current and proposed values
	are equal.
	* libproto/maildir/maildir.c (MAILDIR_COMPAT_DETECT)
	(MAILDIR_COMPAT_NONE, MAILDIR_COMPAT_ISYNC): New constants.
	(_maildir_data): New fields: compat and cur_uid. Replace
	needs_uid_fixup with update_uidvalidity.
	(struct _maildir_message): New fields: tv, pid, ndlv, flags.
	(reset_uid): Initialize cur_uid.
	(parse_delivery_id): New function.
	(maildir_open): Early attempt to determine MAILDIR_COMPAT_ISYNC
	maildir: if the .uidvalidity exists and its first two lines are
	unsigned integers (uidvalidity and last used uid).
	(maildir_message_alloc): Parse the delivery identifier and
	determine compatibility mode (unless already set), based on
	whether uppercase "U" is used to store the UID.
	(maildir_subdir_scan): Take additional argument indicating
	whether it is the initial mailbox scan. If so, check for
	duplicates (message names that compare equal).
	(maildir_message_fixup): Take the update flag as argument.
	Rewrite the UID fixup logic.
	(maildir_scan_unlocked): Change message incorporation logic.
	Messages in new are assigned explicit UIDs now.
	(string_buffer_format_message_name): Depending on compatibility
	mode, use lower or uppercase "u" attribute.
	(maildir_new_message_name): Store UID in the message name both
	in cur and new.
	(maildir_msg_finish_delivery): Ditto.
	(maildir_message_cmp): Rewrite using parsed out delivery ids.
	(maildir_chattr_msg,maildir_msg_init): Parse delivery id. 
	* mh/sortm.c (sort): Reset uidvalidity after reopening the
	mailbox in read-write mode (see the change to _amd_prop_create,
	above).
	* testsuite/mbop.c: New operation: echo.

2025-06-06  Sergey Poznyakoff  <gray@gnu.org>

	Fix possible NULL pointer dereference.

	* libmailutils/base/assoc.c (mu_assoc_shift): Fix typo in
	conditional.

2025-05-28  Sergey Poznyakoff  <gray@gnu.org>

	Fix coredump in mail.

	* mail/alias.c (alias_expand): Handle NULL argument.

2025-03-24  Jordi Mallach  <jordi@mallach.net>

	Fix missing format arguments for builds with -Wformat-security.

	libmailutils/diag/debug.c (mu_debug_format_spec): Add missing
	"%s" to printf to avoid triggering -Wformat-security.

2025-03-24  Sergey Poznyakoff  <gray@gnu.org>

	Minor fix.

2025-03-22  Sergey Poznyakoff  <gray@gnu.org>

	Version 3.19.

2025-02-26  Sergey Poznyakoff  <gray@gnu.org>

	filters: revise buffer requirements on returning
	mu_filter_more(in|out)put.

2025-02-22  Sergey Poznyakoff  <gray@gnu.org>

	mail: allow for part spec after any message designator (., ^,
	etc).

	* mail/msgset.y (DELIM): New token.
	(yylex): Generate DELIM token when advancing to the next
	argument.
	(msgset production): change syntax using delim nonterminal.
	(msgexpr): Allow for optional delimiter after ! and { and
	before }.
	(msgspec): Allow for leading dot: "dec .2.1" meaning the same
	as "dec ..2.1", i.e. decode subpart 2.1 of the current message.
	(msg): Accept part specifiers after ^ (-), and $ (+).

2025-01-23  orbea  <orbea@riseup.net>

	libproto tests: link using the libtool archives.

	When using slibtool the build fails when it doesn't find
	-lmu_tesh. This can be solved by linking internal dependencies
	with the generated libtool archive (.la) file.

2025-01-07  Sergey Poznyakoff  <gray@gnu.org>

	Fix testsuite (mda & mail) to work with arbitrary default
	mailbox type.

	* mail/testsuite/lib/mail.exp (default_mail_start): Force mbox
	mailbox type.
	* mda/mda/tests/forward.at: Likewise.
	* mda/mda/tests/mda.at: Likewise.
	* mda/tests/mda.sh (dumpmail): Handle only mbox.

2025-01-03  Sergey Poznyakoff  <gray@gnu.org>

	Update doc/texinfo/html.init for use with Texinfo > 6.8.

2025-01-03  Sergey Poznyakoff  <gray@gnu.org>

	Version 3.18.

2025-01-02  Sergey Poznyakoff  <gray@gnu.org>

	Update copyleft statements.

2024-12-31  Sergey Poznyakoff  <gray@gnu.org>

	Require the latest libtool; fix a distcheck failure.

	* configure.ac (AM_INIT_AUTOMAKE): Switch strictness from gnits
	to gnu. Gnits is equivalent to "gnu readme-alpha check-news
	std-options". Among these, std-options causes grief when make
	distcheck is run on a system with a previous mailutils version
	installed, if one of the shared libraries of that version (most
	often, libmuaux.so) are not entirely compatible with those of
	the version being checked. Std-options inserts a Makefile goal
	that runs each installed binary with --help and --version
	option. During make distcheck, that binary will be the one
	installed to the _inst subdirectory. It will expect shared
	libraries from the version of Mailutils it comes from, but the
	runtime loader will link it to the ones installed on the system
	(this is somewhat similar to the effects described in
	https://gray.gnu.org.ua/public/ltbug, although not directly
	related to libtool). Thus, the binary might fail to start, e.g.
	if it doesn't encounter a symbol in the library. To avoid this,
	the "gnits" strictness is replaced with "gnu readme-alpha
	check-news".
	(LT_PREREQ): Require version 2.5.4, which fixes bugs described
	in the link above.
	* bootstrap.conf (bootstrap_epilogue): Remove.
	* patches/ltmain.sh-2.4.6.patch: Remove.
	* patches/ltmain.sh-2.4.7.patch: Remove.

2024-10-30  Sergey Poznyakoff  <gray@gnu.org>

	Various bugfixes.

	* imap4d/namespace.c (namespace_translate_name): Fix use after
	free.
	* imap4d/tests/testclient.c: Increase static buffer size.
	* libmailutils/base/removefile.c (check_parent_access): Fix use
	after free.
	* libmailutils/mailbox/mailbox.c (mu_mailbox_destroy):
	Likewise.
	* libmailutils/mailer/mailer.c (mu_mailer_destroy): Likewise.
	* libmailutils/server/acl.c (mu_acl_destroy): Assign NULL to
	the argument location.
	* mh/mh_format.c (mh_fvm_destroy): Likewise.
	* libmailutils/wordsplit: Pull new version.
	* libmailutils/tests/Makefile.am: Fix rules for building wsp.
	* libmailutils/tests/mailcap.at: Change expected strings.
	* libmu_auth/virtual.c: Remove unused variables.
	* mh/mh_init.c (mh_find_file): Fix argument to mu_diag_output.
	* pop3d/apop.c: Remove unused variables.

2024-10-30  Sergey Poznyakoff  <gray@gnu.org>

	Bugfix.

	* libmu_scm/mu_scm.c (format_table): Fix typo. Patch by Timothy
	Sample.

2024-10-10  Don Stokes  <don@nz.net>

	Bugfix in mu_utc_offset.

	This fixes incorrect handling of time zones with the offset of
	more than 12 hours out from UTC, e.g. NZ daylight time.

	* libmailutils/datetime/utcoff.c: Use the day of the month to
	account for day changes.

2024-09-02  Sergey Poznyakoff  <gray@gnu.org>

	Update FSF address.

2024-09-01  Sergey Poznyakoff  <gray@gnu.org>

	Bugfix in stream ioctl.

	* libmailutils/stream/memory_stream.c (_memory_ioctl): Fix
	improperly used parameter.
	* libmailutils/stream/tcp.c (_tcp_ioctl): Handle
	MU_IOCTL_TRANSPORT_BUFFER.

2024-08-26  Sergey Poznyakoff  <gray@gnu.org>

	Minor change.

	* libmailutils/cidr/fromstr.c (mu_cidr_from_string): Mask out
	extra address bits to obtain first IP of the range.
	* libmailutils/tests/strtoc.c: Test this.

2024-07-17  Sergey Poznyakoff  <gray@gnu.org>

	Complement 5380651f84a1e00c5b8ffa27f27851c3cd97981c.

	* libmu_sieve/tests.c (retrieve_envelope): Apply same error
	translation as in retrieve_address.

2024-06-26  Sergey Poznyakoff  <gray@gnu.org>

	Bugfix.

	* libmu_sieve/load.c (load_module): Produce correct diagnostics
	if "init" not found".

2024-06-26  Sergey Poznyakoff  <gray@gnu.org>

	sieve pipe action: handle error return from mu_stream_close.

2024-06-23  Sergey Poznyakoff  <gray@gnu.org>

	sieve: don't bail out on malformed email addresses.

	* libmu_sieve/tests.c: Handle MU_ERR_EMPTY_ADDRESS as missing
	email address (MU_ERR_NOENT).

2024-06-17  Sergey Poznyakoff  <gray@gnu.org>

	Version 3.17.90.

	* NEWS: Update version numger.
	* configure.ac: Likewise.
	* gnulib.modules: Use gettext-h instead of gettext.
	* libmailutils/filter/Makefile.am: Remove unneeded -I option.

2024-06-17  Sergey Poznyakoff  <gray@gnu.org>

	Makefile.am's: Remove erroneous -I options.

2024-06-13  Sergey Poznyakoff  <gray@gnu.org>

	manual: discuss configuration files used by the mail utility.

2024-06-13  Sergey Poznyakoff  <gray@gnu.org>

	mail: several improvements in the variables interface.

	* include/mailutils/filter.h (mu_iconv_fallback_name): New
	proto.
	* libmailutils/filter/decode.c (mu_iconv_fallback_name): New
	function.
	* mail/mail.c: Use mailvar_init_variables to initialize
	variables that depend on mailutils settings and/or current
	environment.
	* mail/mail.h (mailvar_init_variables): New proto.
	* mail/mailvar.c (mailvar_symbol): New field: init. Provide
	initialization functions for variables that need it.
	(mailvar_init_variables): New function.
	(mail_variable): Sort output lexicographically.

2024-06-13  Sergey Poznyakoff  <gray@gnu.org>

	Bugfix in mu_get_host_name.

	* libmailutils/base/hostname.c (mu_get_host_name): Initialize
	hints.

2024-06-13  Sergey Poznyakoff  <gray@gnu.org>

	mail: use the mailer capability.

2024-06-12  Sergey Poznyakoff  <gray@gnu.org>

	Provide a debugging category shortcut "all".

	* doc/texinfo/programs.texi: Document the "all"
	pseudo-category.
	* include/mailutils/debug.h (mu_debug_category_match): New
	proto.
	(mu_debug_level_p): Rewrite as inline function.
	(MU_DEBUG_FORMAT_DEFAULT,MU_DEBUG_FORMAT_SHOWUNSET)
	(MU_DEBUG_FORMAT_COMPRESS,MU_DEBUG_FORMAT_SORT): New macros.
	(mu_debug_category_from_string)
	(mu_debug_level_from_string): New protos.
	* libmailutils/diag/debug.c: Change handling of the isset
	field.
	(mu_debug_category_match): Don't check isset.
	(mu_debug_get_category_level): Likewise.
	(mu_debug_enable_category)
	(mu_debug_disable_category): Apply to all categories if
	catn==0.
	(mu_debug_category_from_string): New function.
	(mu_debug_level_from_string): Remove static qualifier.
	(mu_debug_format_spec): Change semantics of the last argument.
	It is a bitmask of:
	 - MU_DEBUG_FORMAT_SHOWUNSET include unset categories;
	 - MU_DEBUG_FORMAT_COMPRESS try to compress output by using the
	"all"
	 shortcut;
	 - MU_DEBUG_FORMAT_SORT sort categories alphabetically;
	* libmailutils/tests/debugspec.at: Add new tests.
	* libmailutils/tests/debugspec.c: New options: -compress,
	-sort, -quiet. Take an optional list of category.level pairs.
	Print enable status (true/false) for each of them.

2024-06-11  Sergey Poznyakoff  <gray@gnu.org>

	Minor fix in mhn and related tests.

	* mh/mhn.c (store_handler): When piping the output, make sure
	to flush stdout beforhand.
	* mh/tests/mhed: Don't create file named "-".
	* mh/tests/mhn.at: Fix expected output.

2024-06-11  Sergey Poznyakoff  <gray@gnu.org>

	Change handling of libtool bugs.

	* bootstrap.conf (bootstrap_epilogue): Patch installed version
	of ltmain.sh.
	* mu-aux/ltmain.sh: Remove.
	* patches/README: New file.
	* patches/ltmain.sh-2.4.6.patch: New file.
	* patches/ltmain.sh-2.4.7.patch: New file.

2024-03-22  Sergey Poznyakoff  <gray@gnu.org>

	Fix typo in mailutils dbm dump example.

2024-03-22  Sergey Poznyakoff  <gray@gnu.org>

	Mention nmh scan -file option when discussing MH implementation
	differences.

2024-03-22  Sergey Poznyakoff  <gray@gnu.org>

	Fix ehlo command in the smtp client.

	The bug spotted by Christophe Deleuze in
	https://savannah.gnu.org/patch/?10439

	* libproto/mailer/smtp_capa.c (mu_smtp_capa_test): Issue ehlo
	only when in the corresponding state. Return MU_ERR_NOENT if
	the requested capability is not found, including the case when
	the capability array is null because of one-line ehlo response
	or because plain SMTP is in use.
	* libproto/mailer/smtp_capa_itr.c (mu_smtp_capa_iterator):
	Likewise.
	* libproto/mailer/smtp_ehlo.c (mu_smtp_ehlo): Fail if not in
	the MU_SMTP_EHLO state. Set MU_SMTP_MAIL on success.
	* libproto/mailer/smtp_gsasl.c (_mu_smtp_gsasl_auth): Reset
	stat to MU_SMTP_EHLO.
	* libproto/mailer/smtp_starttls.c (mu_smtp_starttls): Likewise.

2024-01-06  Sergey Poznyakoff  <gray@gnu.org>

	Version 3.17.

2024-01-06  Sergey Poznyakoff  <gray@gnu.org>

	Update copyright years.

2024-01-06  Sergey Poznyakoff  <gray@gnu.org>

	New dbm function: mu_dbm_break.

	This function deallocates resources allocated by
	mu_dbm_firstkey function. It should be used when breaking from
	a loop iterating over all keys in the database.

	* include/mailutils/dbm.h (mu_dbm_impl): New field: _dbm_break
	(mu_dbm_break): New function.
	* libmu_dbm/break.c: New file.
	* libmu_dbm/Makefile.am (libmu_dbm_la_SOURCES): Add break.c
	* libmu_dbm/berkeley.c (_bdb_close): Close cursor, if
	available.
	(_bdb_break): New method.
	* libmu_dbm/gdbm.c (_gdbm_break): New method.

2023-06-09  Sergey Poznyakoff  <gray@gnu.org>

	Add missing includes.

2023-05-24  Sergey Poznyakoff  <gray@gnu.org>

	Fix definition of -P option in movemail.

2023-05-09  Sergey Poznyakoff  <gray@gnu.org>

	Fix global timeout and transcript statements in pop3d and
	imap4d.

	* include/mailutils/server.h (mu_m_server_config_default_fp):
	New data type.
	(mu_m_server_set_config_default): New prototype.
	* libmailutils/server/msrv.c (_mu_m_server): New field:
	config_default.
	(mu_m_server_set_config_default): New function.
	(mu_m_server_listen): If config_default is initialized, call it
	to initialize the pconf structure. 
	* imap4d/imap4d.c (imap4d_connection): Don't reset idle_timeout
	and imap4d_transcript.
	(imap4d_config_default): New function.
	(main): Initialize the server's config_default function. 
	* pop3d/apop.c (apop_ok): New function.
	* pop3d/pop3d.c (pop3d_mainloop): Don't include timestamp in
	the banner greeting if APOP database is not available.
	(pop3d_config_default): New function.
	(main): Initialize the server's config_default function.
	* pop3d/pop3d.h (apop_ok): New prototype.

2023-05-07  Sergey Poznyakoff  <gray@gnu.org>

	Improve file safety checking routine.

	* libmailutils/base/filesafety.c (mu_file_safety_check): Accept
	symbolic links. Fix memory leak.

2023-05-07  Sergey Poznyakoff  <gray@gnu.org>

	pop3d, imap4d: global tls-mode is used only when the mode to
	use cannot be determined otherwise.

2023-05-04  Sergey Poznyakoff  <gray@gnu.org>

	pop3d, imap4d: if not set explicitly, derive tls mode from the
	port used.

	* NEWS: Version 3.16.90
	* configure.ac: Likewise.
	* imap4d/imap4d.c (main): Use PORT_IMAP4 constant.
	* imap4d/imap4d.h (PORT_IMAP4,PORT_IMAP4S): New defines.
	* imap4d/starttls.c (starttls_server_check): Derive the tls
	mode from the port used or from the global tls mode.
	* include/mailutils/sockaddr.h (mu_sockaddr_get_port): New
	proto.
	* libmailutils/sockaddr/Makefile.am: Add port.c
	* libmailutils/sockaddr/port.c: New file.
	* mu/libexec/shell.c (readline): Minor change.
	* pop3d/cmd.c (stls_server_check): Derive the tls mode from the
	port used or from the global tls mode.
	* pop3d/pop3d.c (main): Use PORT_POP3 constant.
	* pop3d/pop3d.h (PORT_POP3, PORT_POP3S): New defines.

2023-05-03  Sergey Poznyakoff  <gray@gnu.org>

	Bugfix in mu tool.

	* mu/libexec/shell.c [!WITH_READLINE] (readline): Remove static
	qualifiers.

2023-05-01  Sergey Poznyakoff  <gray@gnu.org>

	Version 3.16.

2023-05-01  Sergey Poznyakoff  <gray@gnu.org>

	Remove leftover uses of gethostby* functions.

	* configure.ac: Remove check for gethostbyname
	* include/mailutils/util.h: Fix comment.
	* imap4d/util.c: Use getaddrinfo.
	* libmailutils/base/hostname.c: Likewise.
	* libmailutils/sockaddr/fromnode.c: Likewise.
	* libmu_auth/virtual.c: Use getnameinfo.

2023-05-01  Sergey Poznyakoff  <gray@gnu.org>

	Minor fixes.

	* NEWS: Update.
	* libmu_scm/tests/testsuite.at: Fix improper use of AT_TESTED.
	* maint/release.mk (GNUPLOAD): New variable.
	* configure.ac: New maintainer option --with-gnupload.

2023-04-30  Sergey Poznyakoff  <gray@gnu.org>

	Switch to newer autotools.

	* configure.ac: Require autoconf 2.71, automake 1.16.2 Don't
	use obsolete macros. Drop support for Berkeley DB 2.
	* gint: Upgrade.
	* gnulib: Upgrade.
	* am/db2.m4: Remove. Support for bdb2 withdrawn.
	* libmu_dbm/berkeley.c: Drop support for bdb2.
	* am/config_paths.m4: Don't use obsolete autoconf macros.
	* am/debug.m4: Likewise.
	* am/enable.m4: Likewise.
	* am/gsasl.m4: Likewise.
	* am/gssapi.m4: Likewise.
	* am/ipv6.m4: Likewise.
	* am/tls.m4: Likewise.
	* mail/mail.h (mailvar_value): Rename bool to boolean to avoid
	eventual conflicts. All uses changed.
	* comsat/comsat.c: Remove the uses of RETSIGTYPE.
	* examples/echosrv.c: Likewise.
	* imap4d/bye.c: Likewise.
	* imap4d/imap4d.c: Likewise.
	* imap4d/imap4d.h: Likewise.
	* imap4d/signal.c: Likewise.
	* lib/muaux.h: Likewise.
	* lib/signal.c: Likewise.
	* libmailutils/mailer/progmailer.c: Likewise.
	* libmailutils/server/msrv.c: Likewise.
	* libmu_sieve/extensions/spamd.c: Likewise.
	* mh/mhn.c: Likewise.
	* mh/prompter-tty.c: Likewise.
	* mh/sortm.c: Likewise.
	* pop3d/pop3d.h: Likewise.
	* pop3d/signal.c: Likewise.

2023-02-21  Sergey Poznyakoff  <gray@gnu.org>

	Fix coredump in mail.

	Patch proposed by Dave Love <Dave.Love@manchester.ac.uk>

	* mail/util.c (util_get_charset): Check if charset is not NULL
	before strdup'ing it.

2023-01-22  Sergey Poznyakoff  <gray@gnu.org>

	Update copyright years.

2022-12-27  Sergey Poznyakoff  <gray@gnu.org>

	Various fixes.

	* NEWS: Document changes.
	* configure.ac: Version 3.15.90
	* libmailutils/stdstream/strerr.c (mu_stdstream_strerr_setup):
	Don't destroy mu_strerr unconditionally, use mu_stream_unref.
	* frm/common.c (format_field_align): Initialize local variable.
	* lib/mailcap.c (mime_context_get_temp_file): Issue diagnostics
	on error.
	(expand_string): Return -1 if the temp file creation fails.
	(create_filter,run_test,run_mailcap): Improve error checking.
	* libmailutils/base/fgetpwent.c (mu_fgetpwent_r): Fix use of
	uninitialized variables.
	* libmailutils/mailbox/msgqlines.c (mu_message_quick_lines):
	Likewise.
	* libmailutils/mime/mimeitr.c (itrdup): Initialize the
	allocated value with zeroes.
	* libmailutils/stream/prog_stream.c (start_program_filter):
	Improve error checking.
	* libmailutils/tests/t-streamshift.c: Use typecasts when
	printing mu_off_t values.
	* libmailutils/url/set-service.c (mu_url_set_service):
	Initialize port.
	* libproto/imap/fetch.c (_fill_response): Fix possible use of
	uninitialized variable.
	* libproto/maildir/maildir.c (maildir_message_name_parse):
	Initialize endval.
	* libproto/mailer/prog.c (url_to_argv): Translate wordsplit
	error code to the mailutils one.
	* libproto/mbox/message.c (env_to_stream): Make sure ref->date
	is null-terminated.
	* libproto/pop/pop3_response.c (mu_pop3_get_response): Don't
	check for non-null receiver before calling mu_cpystr: it copes
	with the case by itself.
	* libproto/pop/pop3_top.c (mu_pop3_top): Always initialize
	status.
	* mail/escape.c (escape_help): Likewise.
	* mail/util.c (util_do_command): Remove unnecessaty
	conditional. Upon successful return from mu_vasnprintf cmd is
	guaranteed to have a non- null value.
	* mda/lib/script.c (mda_filter_message): Bail out if changing
	to the user dir fails.
	* mh/mhn.c (com_send): Fix allowed user responses.
	* mu/libexec/smtp.c (next_name_from_file): Fix the use of
	uninitialized variables.

2022-09-16  Sergey Poznyakoff  <gray@gnu.org>

	Fix handling of overflowing lines in wordwrap streams.

	* libmailutils/stream/wordwrap.c (mu_wordwrap_stream): New
	field: overflow.
	(line_not_empty): New auxiliary function.
	(_wordwrap_flush_line,_wordwrap_write)
	(_wordwrap_flush): Handle line overflow.
	* libmailutils/tests/wordwrap03.at: More tests.

2022-09-14  Sergey Poznyakoff  <gray@gnu.org>

	tlsfdstr: fix error handling.

	* libmu_auth/tlsfdstr.c (_tlsfd_done): Don't close borrowed
	descriptors.
	(mu_tlsfd_stream_create): Avoid both fds being closed on error.

2022-07-18  Sergey Poznyakoff  <gray@gnu.org>

	Bugfix.

	* libmailutils/base/mutil.c (mutil_parse_field_map): Fix an
	attempt to free a memory area that hasn't been allocated. Not
	so critical: the bug would be hit only if mu_assoc_install
	failed (which means out of memory condition).

2022-07-03  Sergey Poznyakoff  <gray@gnu.org>

	Fix mh/folder -pack=1 on an empty mailbox.

	* mh/folder.c (action_pack): Return immediately if the mailbox
	is empty.

2022-05-08  Sergey Poznyakoff  <gray@gnu.org>

	Modify .gitignore.

2022-05-08  Sergey Poznyakoff  <gray@gnu.org>

	rdcache_size: return MU_ERR_INFO_UNAVAILABLE if unable to get
	transport stream size.

	This addresses the problem mentioned in the previous commit.

	* libmailutils/stream/rdcache_stream.c (rdcache_size): Return
	MU_ERR_INFO_UNAVAILABLE if mu_stream_size returns EAGAIN,
	EINTR, ENOSYS, or EINPROGRESS.
	* libmailutils/stream/stream.c (mu_stream_seterr): Handle
	MU_ERR_INFO_UNAVAILABLE same way as ENOSYS et al.
	* libmailutils/stream/streamcpy.c (mu_stream_copy_wcb): Same
	handling for: EAGAIN, EINTR, ENOSYS, EINPROGRESS, and
	MU_ERR_INFO_UNAVAILABLE.
	* mh/msgchk.c (checkmail): Likewise.

2022-05-08  Sergey Poznyakoff  <gray@gnu.org>

	rdcache: fix stream size computation.

	Until now, read cache stream incorrectly updated its size when
	it should not. This happened when the stream had cached some
	data, then had been rewound and a read operation performed on
	it.

	* libmailutils/stream/rdcache_stream.c
	(mu_rdcache_stream_max_memory_size): Remove unused global.
	(rdcache_read): Fix stream size computation.
	(rdcache_size): Return cached size only if EOF was hit on
	transport stream, otherwise return its size. This means that
	depending on whether the stream was already cached or not, the
	call to mu_stream_size on rdcache stream may return ENOSYS or
	success.
	* libmailutils/tests/t-rdcache.c: New test program.
	* libmailutils/tests/Makefile.am: Build t-rdcache.
	* libmailutils/tests/testsuite.at: Run t-rdcache.

2022-05-02  Sergey Poznyakoff  <gray@gnu.org>

	Accomodate tests for differences in wc outputs on various
	systems.

	* libproto/mbox/tests/append.at: Strip leading whitespace from
	the wc output.
	* libproto/mbox/tests/lastmsg.at: Likewise.
	* mda/mda/tests/forward.at: Likewise.

2022-04-17  Sergey Poznyakoff  <gray@gnu.org>

	Version 3.15.

	* NEWS: Raise version number
	* configure.ac: Raise version number. Increase shared library
	current interface number.

2022-04-13  Sergey Poznyakoff  <gray@gnu.org>

	Minor fix (imap4d)

	* imap4d/imap4d.c (namespace_section_parser): Return error on
	invalid or empty namespace name.

2022-04-06  Sergey Poznyakoff  <gray@gnu.org>

	Document message part syntax for the mail command.

2022-04-06  Sergey Poznyakoff  <gray@gnu.org>

	mail: error out if a message part is given to the command that
	doesn't support parts.

	* mail/mail.h (MSG_ALLOWPART): New flag.
	* mail/msgset.y: Allow message parts only if MSG_ALLOWPART is
	set. Rewrite as a reentrant parser.
	* mail/decode.c: Allow message parts in sets.
	* mail/write.c: Likewise.

2022-02-18  Sergey Poznyakoff  <gray@gnu.org>

	Fix GSASL stream initialization in imap4d.

	* imap4d/auth_gsasl.c (auth_gsasl): Initialize stream[1],
	unless set after return from ioctl.
	* libmailutils/stream/fltstream.c (filter_ctl): If both streams
	are supplied for MU_IOCTL_OP_SET, combine them into an iostream
	prior to setting the transport pointer.

2022-02-18  Sergey Poznyakoff  <gray@gnu.org>

	imap4d: fix test mode detection.

	* imap4d/imap4d.c (test_mode): Three-state. Initialize to
	"undef".
	(imap4d_mainloop): Don't alter test_mode here.
	(main): Detect test_mode value unless already set earlier.

2022-02-18  Sergey Poznyakoff  <gray@gnu.org>

	Minor change in msrv signal handling.

	* libmailutils/server/msrv.c (set_signal): Catch errors.
	(_mu_m_server.sigtab): Increase size by one. Slot 0 is not
	used.
	(mu_m_server_begin,mu_m_server_restore_signals): Enumerate
	signals starting from 1.

2022-02-12  Sergey Poznyakoff  <gray@gnu.org>

	Minor change in MH testcase.

	* mh/tests/fmtcomp.at (unclosed control): Reflect changed
	wording in parsers produced by bison 3.8.2

2022-02-09  Sergey Poznyakoff  <gray@gnu.org>

	mbox format: preserve trailing newlines in body.

	* libmailutils/stream/streamcpy.c (mu_stream_copy_nl): Append
	an extra \n only unless the last character in stream is a
	newline. Always append an empty line at the end.
	* libproto/mbox/message.c (mboxrd_message_copy_with_uid): use
	regular mu_stream_copy, instead of mu_stream_copy_nl. 
	* mda/tests/input.msg: Remove empty line at the end.
	* mda/lmtpd/tests/lmtpd.at: Ensure expout ends with an empty
	line.
	* mda/mda/tests/forward.at: Likewise.
	* mda/mda/tests/mda.at: Likewise.
	* mda/putmail/tests/putmail.at: Likewise.

2022-02-08  Sergey Poznyakoff  <gray@gnu.org>

	Document changes.

2022-02-08  Sergey Poznyakoff  <gray@gnu.org>

	Bugfix in _fromrd_encoder.

	See 451ca485. Patch by Kurt Hackenberg.

2022-02-08  Sergey Poznyakoff  <gray@gnu.org>

	Normalize test mbox mailboxes.

2022-02-08  Sergey Poznyakoff  <gray@gnu.org>

	mbox format: don't count terminating empty line as part of
	message.

	* configure.ac: Version 3.14.90
	* NEWS: Version 3.14.90 
	* libproto/mbox/mboxrd.c (scan_message_finalize): Take
	decrement value (n) without additional corrections. All uses
	changed.
	(mailbox_append_message): Fix padding.
	* libproto/mbox/message.c (_msg_stream_setup)
	(mboxrd_message_body_scan,_msg_body_setup): Don't count
	terminating empty line as part of the message body. 
	* libproto/mbox/tests/lastmsg.at: New test.
	* libproto/mbox/tests/Makefile.am: Add new files.
	* libproto/mbox/tests/testsuite.at: Likewise.
	* libproto/mbox/tests/append.at: Test appending to partially
	terminated mailboxes. 
	* libproto/mbox/tests/body.at: Fix expected octet and line
	counts.
	* libproto/mbox/tests/attr.at: Likewise.
	* libproto/mbox/tests/autodetect.at: Likewise.
	* libproto/mbox/tests/count.at: Likewise.
	* libproto/mbox/tests/env.at: Likewise.
	* libproto/mbox/tests/notify.at: Likewise.
	* libproto/mbox/tests/qget.at: Likewise.
	* comsat/tests/testsuite.at: Likewise.
	* imap4d/tests/IDEF0956.at: Likewise.
	* imap4d/tests/fetch.at: Likewise.
	* libmu_scm/tests/mailbox-append-message.at: Likewise.
	* libmu_scm/tests/mailbox-expunge.at: Likewise.
	* libmu_scm/tests/mailbox-get-message.at: Likewise.
	* libmu_scm/tests/mailbox-iterate.at: Likewise.
	* libtests/mime.at: Likewise.
	* mail/tests/align.at: Likewise.
	* mail/tests/hold.at: Likewise.
	* mail/tests/nohome.at: Likewise.
	* mail/testsuite/mail/Followup.exp
	* mail/testsuite/mail/Reply.exp
	* mail/testsuite/mail/folder.exp
	* mail/testsuite/mail/followup.exp
	* mail/testsuite/mail/read.exp
	* mail/testsuite/mail/reply.exp
	* mail/testsuite/mail/tag.exp
	* mail/testsuite/mail/z.exp
	* pop3d/testsuite/pop3d/read.exp
	* readmsg/tests/all.at: Likewise.
	* readmsg/tests/hdr.at: Likewise.
	* readmsg/tests/nohdr.at: Likewise.
	* readmsg/tests/twomsg.at: Likewise.
	* readmsg/tests/weed.at: Likewise.
	* sieve/tests/redirect.at: Likewise.
	* sieve/tests/reject.at: Likewise.

2022-02-08  Sergey Poznyakoff  <gray@gnu.org>

	Fix mu_stream_read with NULL as 4th argument.

	If called with NULL as its fourth argument (size_t *pread), the
	function should return error if unable to read the requested
	number of bytes.

	* libmailutils/stream/stream.c (mu_stream_read): If pread is
	NULL and less than the requested number of bytes has been read,
	return MU_ERR_READ.
	* libmailutils/tests/t-streamshift.c (stream_verify): Fix size
	calculation.

2022-01-28  Sergey Poznyakoff  <gray@gnu.org>

	Improve performance of the Sieve fileinto action.

	* include/mailutils/assoc.h (MU_ASSOC_LRU): New flag.
	(mu_assoc_pop, mu_assoc_shift): Change signature: second
	argument is char **.
	* libmailutils/base/assoc.c (mu_assoc_install_ref2): Maintain
	LRU ordering, if so requested. mu_assoc_pop, mu_assoc_shift):
	Change type of the second argument to char **. Unless it is
	NULL, store there a copy of the key. 
	* libmu_sieve/sieve-priv.h (mu_sieve_machine): New member:
	mailboxes.
	* libmu_sieve/actions.c (sieve_action_fileinto): Maintain a
	table of output mailboxes. Keep each mailbox open for as long
	as possible. If running out of open files, close the least
	recently used mailbox and retry.
	* libmu_sieve/sieve-gram.y (mu_sieve_machine_destroy): Destroy
	the mailbox table.

2022-01-28  Sergey Poznyakoff  <gray@gnu.org>

	Improve efficiency of operations on flat mailboxes in append
	mode.

	Until now both mboxrd and dotmail preferred mmap over
	unistd-based I/O. This improved performance when reading and
	updating mailboxes, but deteriorated it when operating in
	append mode. To improve performance in append mode, a new
	function (mu_mailbox_stream_create) is introduced, which
	selects the underlying stream for the mailbox file based on the
	requested open mode and the currentstatus of the file itself.
	Both mboxrd and dotmail use this function to initialize mailbox
	stream.

	* include/mailutils/stream.h (mu_mailbox_stream_create): New
	proto.
	* libmailutils/stream/Makefile.am (libstream_la_SOURCES): Add
	mailbox_stream.c
	* libmailutils/stream/mailbox_stream.c: New file.
	* libproto/dotmail/dotmail.c (dotmail_mailbox_init_stream): Use
	mu_mailbox_stream_create.
	* libproto/mbox/mboxrd.c (mboxrd_mailbox_init_stream):
	Likewise.

2022-01-24  Sergey Poznyakoff  <gray@gnu.org>

	Bugfix in mboxrd decoder.

	* libmailutils/filter/fromrd.c (_fromrd_decoder): Don't switch
	state if '\n' is received while in S_BOL state.

2022-01-21  Sergey Poznyakoff  <gray@gnu.org>

	Bugfix in quoted-printable decoder.

	Bug reported by Kurt Hackenberg, see:
	https://lists.gnu.org/archive/html/bug-mailutils/2022-01/msg000
	01.html

	* libmailutils/filter/qpflt.c (_qp_decoder): Fix calculation of
	the number of consumed input characters.

2022-01-21  Sergey Poznyakoff  <gray@gnu.org>

	Bugfix in mboxrd library.

	* libproto/mbox/mboxrd.c (mboxrd_tracker_sync): If mailbox
	becomes empty, reset all uid-related fields. It is especially
	important to reset x_imapbase_len, otherwise expunging all
	messages in the mailbox followed by appending a new message
	would cause mboxrd_flush_unlocked in line 1670 to overwrite a
	random fragment of the newly created message.

2022-01-21  Sergey Poznyakoff  <gray@gnu.org>

	Minor fix in dotmail.

	* libproto/dotmail/dotmail.c (dotmail_mailbox_init_stream):
	Don't retry opening the file if it mu_mapfile_stream_create
	returned ENOENT, i.e. file does not exist and MU_STREAM_CREAT
	was not specified. Use same flags in both attempts.
	(dotmail_open): Check return from dotmail_mailbox_init_stream.
	(dotmail_tracker_sync): If mailbox becomes empty, reset all
	uid-related fields to 0.

2022-01-17  Sergey Poznyakoff  <gray@gnu.org>

	Fix EOF check with flex >= 2.6.1.

2022-01-02  Sergey Poznyakoff  <gray@gnu.org>

	Version 3.14.

2022-01-02  Sergey Poznyakoff  <gray@gnu.org>

	Update copyright year.

2021-12-07  Sergey Poznyakoff  <gray@gnu.org>

	amd: Rewrite message scanner.

	* include/mailutils/sys/amd.h (_amd_message) <header_size>: New
	member.
	(MU_AMD_DASHDELIM): New flag.
	* libmailutils/base/amd.c (_amd_message_save): Optionally save
	dash delimiter line (useful for MH).
	(_amd_message_save): Initialize header_size.
	(amd_scan_message): Rewrite as a state mashine. Support
	MH-style dash-line delimiters between header and body.
	(amd_message_stream_open): Close stream on failure.
	(amd_header_fill): Use header_size instead of body_start.
	* libproto/mh/mh.c (_mailbox_mh_init): Set MU_AMD_DASHDELIM
	capability.

2021-12-05  Sergey Poznyakoff  <gray@gnu.org>

	Update NEWS.

2021-12-05  Sergey Poznyakoff  <gray@gnu.org>

	amd: use Return-Path and Received headers to save envelope
	information.

	* libmailutils/base/amd.c (_amd_tempstream): New function.
	(_amd_tempfile, _amd_delim): Removed.
	(_amd_message_save): Rewrite using mailutils stream functions.
	Use mu_stream_stat_buffer to count octets and lines. Use
	Return-Path and Received headers to save envelope information.
	* libproto/maildir/tests/append.at: Update expected headers.
	* libproto/mh/tests/append.at: Likewise.
	* mh/tests/pick.at (pick-component, pick-component-or): Use
	mbox2dir -e to create the mailstore. Use --Return-Path option
	for tests.
	* testsuite/mbox2dir.c: New option -e. Rewrite message copying
	routines.

2021-12-05  Sergey Poznyakoff  <gray@gnu.org>

	Improve message append API.

	The new API allows for specifying envelope and attributes
	(status) for the message being appended.

	* include/mailutils/attribute.h (MU_STATUS_BUF_SIZE): Order
	flags lexicographically.
	* include/mailutils/imap.h (mu_imap_append_stream_size)
	(mu_imap_append_stream)
	(mu_imap_append_message): Take envelope and attribute as
	arguments, instead of struct tm, mu_timezone, and flags.
	* include/mailutils/mailbox.h (mu_mailbox_append_message_ext):
	New proto.
	* include/mailutils/sys/amd.h (_amd_data): Change prototype of
	msg_finish_delivery: take additional mu_attribute_t argument.
	* include/mailutils/sys/mailbox.h (_mu_mailbox): Change
	prototype of _append_message: take mu_envelope_t and
	mu_attribute_t as additional arguments.
	* libmailutils/base/amd.c (_amd_message_save): Take
	mu_envelope_t argument.
	(amd_append_message): Take mu_envelope_t and mu_attribute_t
	arguments. Use them to alter message envelope and status.
	* libmailutils/mailbox/attribute.c (mu_attribute_unset_flags):
	Check return from mu_attribute_get_flags.
	(flagtrans): Order alphabetically.
	* libmailutils/mailbox/mailbox.c
	(mu_mailbox_append_message_ext): New function.
	(mu_mailbox_append_message): Rewrite as an alternative entry
	point to mu_mailbox_append_message_ext.
	* libmailutils/mailbox/msgenv.c (message_envelope_date): Give
	MU_HEADER_ENV_DATE higher priority than MU_HEADER_RECEIVED.
	(message_envelope_sender): Give X-Envelope-Sender higher
	priority than Return-Path.
	* libmailutils/stream/message_stream.c
	(mu_message_from_stream_with_envelope): Initialize attribute
	from MU_HEADER_STATUS. 
	* testsuite/mbop.c (mbop_append): Options -attr, -sender, and
	-date can be used to alter message attributes and envelope. 
	* libproto/dotmail/dotmail.c (mailbox_append_message)
	(dotmail_append_message): Take mu_envelope_t and mu_attribute_t
	arguments. Use them to alter message envelope and status.
	* libproto/dotmail/tests/append.at: Test modifying envelope and
	attributes during append.
	* libproto/dotmail/tests/testsuite.at: Force TZ=0. 
	* libproto/imap/appmsg.c (mu_imap_append_message): Take
	mu_envelope_t and mu_attribute_t as arguments.
	* libproto/imap/appstr.c (mu_imap_append_stream): Likewise.
	* libproto/imap/appstrsiz.c (mu_imap_append_stream_size):
	Likewise. Use mu_attribute_t to set message flags and
	mu_envelope_t to set its delivery date. Note, that sender is
	not yet affected.
	* libproto/imap/mailbox.c (_imap_mbx_append_message): Take
	mu_envelope_t and mu_attribute_t as arguments. Use them to
	alter message envelope and status, via mu_imap_append_message.
	Altering envelope is done by amd.c 
	* libproto/maildir/maildir.c (maildir_msg_finish_delivery):
	Take additional mu_attribute_t argument. Use it to alter
	message flags. Change msg->file_name if needed.
	* libproto/maildir/tests/append.at: Test modifying envelope and
	attributes during append. 
	* libproto/mailer/mailbox.c (remote_mbox_append_message): Take
	mu_envelope_t and mu_attribute_t as arguments. Use
	mu_envelope_t to set sender address. mu_attribute_t is ignored,
	as SMTP does not transfer message attributes. 
	* libproto/mbox/mboxrd.c (mailbox_append_message)
	(mboxrd_append_message): Take mu_envelope_t and mu_attribute_t
	as arguments. Use them to alter message envelope and status.
	* libproto/mbox/tests/append.at: Test modifying envelope and
	attributes during append. 
	* libproto/mh/tests/append.at: Test modifying envelope and
	attributes during append. 
	* mail/copy.c (append_to_mailbox): Preserve message status when
	appending.
	* mail/quit.c (mail_mbox_commit): Preserve message status when
	storing it to MBOX.
	* mail/tests/hold.at: Test whether message status is preserved.
	* mu/libexec/imap.c (com_append): Rewrite using the new
	mu_imap_append_stream call.

2021-11-25  Sergey Poznyakoff  <gray@gnu.org>

	Version 3.13.91.

2021-11-25  Sergey Poznyakoff  <gray@gnu.org>

	Bugfixes.

	* imap4d/idle.c (imap4d_idle): Catch eof
	* libmu_auth/tlsfdstr.c: Add missing include.

2021-11-20  Sergey Poznyakoff  <gray@gnu.org>

	Fix typos.

2021-11-19  Sergey Poznyakoff  <gray@gnu.org>

	Fix a corner case in mu_make_file_name_suf.

	If dir is '/' (optionally followed by another '/'), copy it
	verbatim.

	* libmailutils/string/mkfilename.c (mu_make_file_name_suf):

2021-11-19  Sergey Poznyakoff  <gray@gnu.org>

	Forgotten to add with 22ceaddfb8.

2021-11-19  Sergey Poznyakoff  <gray@gnu.org>

	Fix memory and fd leak in maildir and amd.

	* libmailutils/base/amd.c (amd_expunge): Close and destroy the
	associated message stream.
	* libproto/maildir/maildir.c (maildir_close): Fix erroneously
	reverted condition.

2021-11-13  Sergey Poznyakoff  <gray@gnu.org>

	mail: implement the unread command.

	* mail/unread.c: New file.
	* mail/Makefile.am: Add unread.c
	* mail/mail.h (mail_unread): New proto.
	* mail/table.c: New command "unread" ("U"). 
	* doc/texinfo/programs/mail.texi: Document the unread command.
	* NEWS: Likewise.

2021-11-03  Sergey Poznyakoff  <gray@gnu.org>

	Free allocated memory on exit.

	See also 91d35ab2ee.

	* include/mailutils/cfg.h (mu_cfg_section): New members:
	ident_storage and label_storage.
	* libmailutils/cfg/driver.c (mu_config_destroy_container): Free
	the storage allocated for ident and label. Do this onlyw if the
	decreased refcount hits zero.
	(mu_config_container_register_section): Assign allocated
	strings to ident_storage and label_storage.
	(mu_config_root_register_section): Register an onexit routine
	for freeing the allocated memory.
	* libmailutils/cli/capa.c (capa_free): Register an onexit
	routine for freeing the allocated memory.
	* libmailutils/opt/progname.c (mu_set_program_name): Likewise.

2021-11-03  Sergey Poznyakoff  <gray@gnu.org>

	Minor change.

	* libmailutils/stdstream/basestr.c (std_log_bootstrap): Mark
	stream as open.

2021-11-03  Sergey Poznyakoff  <gray@gnu.org>

	Free some allocated memory on exit.

	This eliminates certain "memory leaks", that have little (if
	any) practical importance, bu make leak detection tools overly
	vociferous.

	* libmailutils/base/monitor.c (static_monitor_dealloc): New
	function.
	(mu_monitor_rdlock, mu_monitor_wrlock): Install
	static_monitor_dealloc as onexit handler.
	* libmailutils/filter/filter.c (filter_dealloc): New function:
	deallocate filter_list.
	(mu_filter_get_list): Install filter_dealloc as onexit handler.
	* libmailutils/locus/ident.c (nametab_dealloc): New function.
	(mu_ident_ref): Install nametab_dealloc as onexit handler.
	* libmailutils/stdstream/basestr.c (std_log_bootstrap): Unref
	transport after setting it up to log stream.
	(stdstream_flushall): Call mu_stream_destroy instead of
	mu_stream_flush.

2021-11-03  Sergey Poznyakoff  <gray@gnu.org>

	Move mimetypes support into the library.

	* configure.ac: Build libmailutils/mimetypes/Makefile
	* include/mailutils/Makefile.am: New header mimetypes.h
	* mimeview/mimeview.h: moved from include/mailutils/mimetypes.h
	* include/mailutils/sys/Makefile.am: Add mimetypes.h
	* include/mailutils/sys/mimetypes.h: New file.
	* include/mailutils.h: Include mailutils/mimetypes.h
	* libmailutils/Makefile.am: Build mimetypes.
	* libmailutils/mimetypes/.gitignore: New file.
	* libmailutils/mimetypes/eval.c: New file.
	* libmailutils/mimetypes/grammar.y: Moved from
	mimeview/grammar.y
	* libmailutils/mimetypes/lexer.l: Moved from mimeview/lexer.l.
	* libmailutils/diag/debcat: Add mimetypes.
	* mimeview/Makefile.am: Update.
	* mimeview/tests/testsuite.at: Change debug level. 
	* include/mailutils/stream.h (mu_fd_stream_create): filename is
	const.
	* libmailutils/stream/file_stream.c: Likewise.

2021-11-02  Sergey Poznyakoff  <gray@gnu.org>

	Mimeview: redo the API; rewrite as reentrant scanner/parser.

	* include/mailutils/yyloc.h: Formatting change.
	* mimeview/grammar.y: Rewrite as a reentrant parser.
	* mimeview/lexer.l: Rewrite as a reentrant scanner. Use flex
	interface to bison.
	* mimeview/mimeview.c: Use new API.
	* mimeview/mimeview.h: Remove most prototypes. (mimetypes_open,
	mu_mimetypes_close) (mu_mimetypes_stream_type,
	mu_mimetypes_file_type)
	(mu_mimetypes_fd_type): New API.
	* mimeview/tests/testsuite.at (multiple error recovery): Fix
	expected location of error recovery.

2021-11-01  Sergey Poznyakoff  <gray@gnu.org>

	Minor fix in mimeview/grammar.y.

2021-11-01  Sergey Poznyakoff  <gray@gnu.org>

	Require GNU bison and flex.

	* am/bison.m4: Use AC_PATH_PROG.
	* am/flex.m4: Likewise.
	* configure.ac: Remove MU_YLWRAP.
	* include/mailutils/yyloc.h (YYLTYPE): Remove. This needs be
	defined in each grammar source individually.
	* mu-aux/Makefile.am: Remove gylwrap.
	* mu-aux/gylwrap: Remove. 
	* libmailutils/cfg/Makefile.am: Rewrite rules for building
	grammars and lexers.
	* libmailutils/datetime/Makefile.am: Likewise.
	* libmu_sieve/Makefile.am: Likewise.
	* mail/Makefile.am: Likewise.
	* mh/Makefile.am: Likewise.
	* mimeview/Makefile.am: Likewise. 
	* libmailutils/cfg/gylwrap.conf: Remove.
	* libmailutils/datetime/gylwrap.conf: Remove.
	* libmu_sieve/gylwrap.conf: Remove.
	* mh/gylwrap.conf: Remove.
	* mimeview/gylwrap.conf: Remove. 
	* libmailutils/cfg/lexer.l: Use %option prefix
	* libmu_sieve/sieve-lex.l: Likewise.
	* mh/mh_alias_lex.l: Likewise.
	* mimeview/lexer.l: Likewise. 
	* libmailutils/cfg/parser.y: Use api.prefix and %code requires.
	* libmailutils/datetime/parsedate.y: Likewise.
	* mh/mh_alias_gram.y: Likewise.
	* mh/mh_fmtgram.y: Likewise.
	* mh/pick-gram.y: Likewise.
	* libmu_sieve/sieve-gram.y: Likewise.
	* mimeview/grammar.y: Likewise. 
	* testsuite/lib/mailutils.exp (mu_create_config): Fix source
	location.

2021-09-30  Sergey Poznyakoff  <gray@gnu.org>

	Fix timezone calculation (see
	https://savannah.gnu.org/bugs/?61239)

	* libmailutils/datetime/utcoff.c (mu_utc_offset): Fix the
	timezone correction.

2021-08-27  Sergey Poznyakoff  <gray@gnu.org>

	Bugfix.

	* libmailutils/stream/stream.c (mu_stream_timed_getdelim): If
	buffer points to NULL, assume size = 0.

2021-08-27  Sergey Poznyakoff  <gray@gnu.org>

	Bugfix.

	* imap4d/io.c (imap4d_init_tls_server): Fix inverted condition.
	* pop3d/extra.c (pop3d_init_tls_server): Likewise.

2021-08-26  Sergey Poznyakoff  <gray@gnu.org>

	Test TLS streams.

	* configure.ac: Configure test directory in libmu_auth
	* libmu_auth/Makefile.am: Likewise.
	* libmu_auth/tests/.gitignore: New file.
	* libmu_auth/tests/Makefile.am: New file.
	* libmu_auth/tests/atlocal.in: New file.
	* libmu_auth/tests/genfile.c: New file.
	* libmu_auth/tests/testsuite.at: New file.
	* libmu_auth/tests/tls.at: New file.
	* libmu_auth/tests/tlscpy.c: New file. 
	* pop3d/cmd.c: Fix typo.

2021-08-25  Sergey Poznyakoff  <gray@gnu.org>

	Version 3.13.90.

2021-08-25  Sergey Poznyakoff  <gray@gnu.org>

	New function: mu_starttls.

	* libmu_auth/tlsfdstr.c (mu_tlsfd_stream_create): Accept
	conf==NULL.
	(mu_starttls): New function.
	* include/mailutils/tls.h (mu_starttls): New proto. 
	* include/mailutils/imapio.h (mu_imapio_get_transport)
	(mu_imapio_set_transport): New functions.
	* libmailutils/imapio/transport.c (mu_imapio_get_transport)
	(mu_imapio_set_transport): New functions.
	* libmailutils/stream/iostream.c (mu_iostream_create): Accept
	NULL out stream.
	* libmailutils/stream/tcp.c: Support MU_IOCTL_FD
	(_tcp_instance): New member fd_borrowed.
	(_tcp_close): Don't close fd if fd_borrowed is set.
	(_tcp_ioctl): Handle MU_IOCTL_FD.
	* libmailutils/stream/xscript-stream.c (_xscript_ctl): Accept
	pstr[1] == NULL.
	* libmu_auth/notls.c (mu_tlsfd_stream_create)
	(mu_tlsfd_stream2_convert)
	(mu_starttls): New placeholders. 
	* libproto/imap/folder.c (_mu_imap_folder_open): Use
	mu_tlsfd_stream_convert. Fix stream leak.
	* libproto/imap/starttls.c (mu_imap_starttls): Use mu_starttls.
	* libproto/mailer/smtp.c (smtp_open): Use
	mu_tlsfd_stream_convert.
	* libproto/mailer/smtp_starttls.c (mu_smtp_starttls): Use
	mu_starttls.
	* libproto/pop/pop3_stls.c (mu_pop3_stls): Likewise.
	* libproto/pop/mailbox.c (pop_open): Use
	mu_tlsfd_stream_convert. Fix stream leak.
	* mu/libexec/imap.c (com_connect): Use mu_tlsfd_stream_convert.
	Fix stream leak.
	* mu/libexec/pop.c: Likewise.
	* mu/libexec/smtp.c: Likewise. 
	* imap4d/io.c (imap4d_init_tls_server): Use mu_starttls.
	* pop3d/extra.c: Likewise.

2021-08-25  Sergey Poznyakoff  <gray@gnu.org>

	New function mu_tlsfd_stream2_convert.

	* libmu_auth/tlsfdstr.c (mu_tlsfd_stream_create): Remove last
	argument. All uses changed.
	(mu_tlsfd_stream2_convert): New function.
	* include/mailutils/tls.h (mu_tlsfd_stream_create): Change
	signature (flags removed).
	(mu_tlsfd_stream2_convert): New proto.
	(mu_tlsfd_stream_convert): New inline function.
	* libmailutils/diag/errors (MU_ERR_TRANSPORT_GET)
	(MU_ERR_TRANSPORT_SET): New error codes.
	* imap4d/io.c (imap4d_init_tls_server): Use
	mu_tlsfd_stream2_convert.
	* pop3d/extra.c (pop3d_init_tls_server): Use
	mu_tlsfd_stream2_convert.

2021-08-25  Sergey Poznyakoff  <gray@gnu.org>

	Use timed I/O and fd-based TLS for pop3d.

2021-08-24  Sergey Poznyakoff  <gray@gnu.org>

	Intermediate streams: propagate _MU_STR_EVENT_CLRFLAG to the
	underlying transport.

	* libmailutils/stream/fltstream.c: Propagate mu_stream_clearerr
	to the transport stream.
	* libmailutils/stream/iostream.c: Likewise.
	* libmu_auth/tls.c: Likewise.
	* libmu_auth/tlsiostr.c: Likewise.
	* libmu_auth/tlsfdstr.c (_tlsfd_read, _tlsfd_write): Translate
	GNUTLS_E_TIMEDOUT to MU_ERR_TIMEOUT.
	* imap4d/bye.c (imap4d_bye_command): Clear stream error on
	ERR_TIMEOUT. ---

2021-08-24  Sergey Poznyakoff  <gray@gnu.org>

	Attempt to simplify TLS streams.

	* libmu_auth/tlsfdstr.c: New TLS stream implementation.
	* include/mailutils/tls.h (mu_tls_config): New field:
	handshake_timeout.
	(mu_tlsfd_stream_create): New proto.
	* libmu_auth/Makefile.am: Compile tlsfdstr.c
	* libmu_auth/tlsconf.c (tls_canned_param): New configuration
	statement: tls.handshake_timeout
	* doc/texinfo/programs.texi: Document the tls.handshake-timeout
	statement.
	* imap4d/io.c (io_setio, imap4d_init_tls_server): Use
	mu_tlsfd_stream_create.
	* imap4d/starttls.c (global_tls_conf): Initialize
	handshake_timeout.

2021-08-23  Sergey Poznyakoff  <gray@gnu.org>

	Fix handling of MU_IOCTL_SUBSTREAM in iostream.

	* libmailutils/stream/iostream.c (_iostream_ctl): Fix handling
	of MU_IOCTL_SUBSTREAM (get/set) requests.
	* imap4d/io.c (io_setio): Unreference the source stream.
	(imap4d_init_tls_server): Fix reference decrement for
	tlsstream.
	* pop3d/extra.c (pop3d_setio): Unreference the source stream.
	(pop3d_init_tls_server): Fix reference decrement for tlsstream.

2021-08-21  Sergey Poznyakoff  <gray@gnu.org>

	imap4d: Set timeouts for I/O operations during handshake.

	* imap4d/io.c (io_setio): Set I/O timeout for pull functions
	during the handshake.
	* libmu_auth/tls.c: Fix debugging output.
	* libmu_auth/tlsiostr.c (_tls_io_read): Improve error
	diagnostics.

2021-08-21  Sergey Poznyakoff  <gray@gnu.org>

	imap4d: switch to timed stream I/O.

	* imap4d/idle.c (imap4d_idle): Use mu_stream_timed_getline.
	* imap4d/imap4d.c (imap4d_mainloop): Remove use of
	io_wait_input.
	* imap4d/imap4d.h (io_wait_input): Remove.
	* imap4d/io.c (io_wait_input): Remove.
	(io_getline): Rewrite using mu_stream_timed_getline.
	(imap4d_tokbuf_getline): Likewise.
	(check_input_err): Handle MU_ERR_TIMEOUT.

2021-08-21  Sergey Poznyakoff  <gray@gnu.org>

	Implement "timed" versions of the stream read-up-to-delimiter
	operations.

	* include/mailutils/stream.h (MU_IOCTL_TIMEOUT): New ioctl
	code.
	(mu_stream_timed_readdelim,mu_stream_timed_readline): New
	protos.
	(mu_stream_readdelim,mu_stream_readline,mu_stream_getdelim)
	(mu_stream_getline): Rewrite as inline functions.
	* include/mailutils/datetime.h (mu_timeval_cmp, mu_timeval_add)
	(mu_timeval_sub): New inline functions for operations over
	struct timeval.
	* include/mailutils/sys/file_stream.h (_mu_file_stream): New
	member: io_timeout.
	* libmailutils/diag/errors (MU_ERR_TIMEOUT, MU_ERR_SET_TIMEOUT)
	(MU_ERR_WRITE, MU_ERR_TLS): New error codes.
	* libmailutils/stream/file_stream.c (fd_read,fd_write): Take
	into account I/O timeout.
	(fd_ioctl): Handle MU_IOCTL_TIMEOUT.
	* libmailutils/stream/stream.c (mu_stream_timed_readdelim)
	(mu_stream_timed_readline): New functions.
	* libmu_auth/tls.c (_tls_open): Special handling for time-out
	errors.
	* libmailutils/stream/iostream.c (_iostream_ctl): Pass
	MU_IOCTL_TIMEOUT to the transport stream.

2021-08-19  Sergey Poznyakoff  <gray@gnu.org>

	Provide program name for mu shell utilities.

	* mu/libexec/imap.c (main): Set program name.
	* mu/libexec/pop.c: Likewise.
	* mu/libexec/smtp.c: Likewise.

2021-08-05  Sergey Poznyakoff  <gray@gnu.org>

	Version 3.13.

2021-07-27  Sergey Poznyakoff  <gray@gnu.org>

	Prefer User-Agent header over X-Mailer.

	* NEWS: Update.
	* doc/texinfo/programs/mail.texi: Update.
	* include/mailutils/header.h (MU_HEADER_USER_AGENT): New
	define.
	* mail/mail.c (default_setup): Set useragent
	* mail/mail.h (mailvar_name_useragent): New define.
	* mail/mailline.c (header_generator): Add MU_HEADER_USER_AGENT.
	* mail/mailvar.c: Mew variable: "useragent". Retain "xmailer"
	as an alias.
	* mail/send.c (mail_compose_send): Add the User-Agent header if
	the "useragent" variable is set.
	* libmailutils/tests/hdrcpy.at: Use User-Agent instead of
	X-Mailer.
	* mail/tests/send.at: Likewise.
	* mail/tests/sendbyname.at: Likewise.
	* mail/tests/sendrec.at: Likewise.
	* mail/testsuite/mail/Followup.exp: Likewise.
	* mail/testsuite/mail/Reply.exp: Likewise.
	* mail/testsuite/mail/reply.exp: Likewise.
	* mail/testsuite/mail/send.exp: Likewise.
	* mh/repl.c: Likewise.
	* mh/send.c: New .mtstailor vareiable "user-agent".

2021-07-27  Sergey Poznyakoff  <gray@gnu.org>

	Rewrite tests for interactive mail features in expect.

	After 4befcfd015 interpolation escapes can't be tested using
	autotest. Move them to DejaGNU testsuite.

	* mail/tests/Followup.at: Remove.
	* mail/tests/Reply.at: Remove.
	* mail/tests/followup.at: Remove.
	* mail/tests/reply.at: Remove.
	* mail/tests/Makefile.am: Remove these tests.
	* mail/tests/testsuite.at: Likewise.
	* mail/.gitignore: Fix the entry for mail. 
	* mail/testsuite/mail/Followup.exp: New test.
	* mail/testsuite/mail/Reply.exp: New test.
	* mail/testsuite/mail/followup.exp: New test.
	* mail/testsuite/mail/reply.exp: New test.
	* mail/testsuite/mail/DISTFILES: Add these files.
	* mail/testsuite/lib/mail.exp (mail_version): Don't print the
	version number.
	* mail/testsuite/mail/write.exp: Preserve current working
	directory.

2021-07-19  Sergey Poznyakoff  <gray@gnu.org>

	Fix in quoted-printable decoder.

	* libmailutils/filter/qpflt.c (_qp_decoder): Accept soft line
	breaks (RFC 2045, 6.7, page 19)

2021-07-19  Sergey Poznyakoff  <gray@gnu.org>

	mail: disable compose escapes in non-interctive mode.

	* NEWS: Document changes.
	* doc/texinfo/programs/mail.texi: Document changes.
	* mail/send.c (mail_compose_send): Recognize escapes only in
	interactive mode.

2021-07-16  Sergey Poznyakoff  <gray@gnu.org>

	Rename the FROMRB filter to FROMRD.

	Old name is retained as an alias.

2021-07-15  Sergey Poznyakoff  <gray@gnu.org>

	Fix stream reference bug in mu_filter_stream_create.

	If the mu_filter_xcode_t function failed in mu_filter_init
	request, mu_filter_stream_create would leave the transport
	reference counter incremented by one.

	* libmailutils/stream/fltstream.c (mu_filter_stream_create): On
	failure, decrement reference counter of transport stream.
	* libmailutils/tests/fltcnt.c: Test for the above bug as well.

2021-07-15  Sergey Poznyakoff  <gray@gnu.org>

	Fix stream reference bug in mu_filter_chain_create family
	functions.

	This change affects the following two functions:
	mu_filter_chain_create, mu_filter_chain_create_pred. In
	previous versions, if these functions failed to create the
	requested filter chain, they decremented reference counter of
	their transport (input stream) argument.

	This change restores the proper behavior:

	 - On success, reference counter is incremented by 1.
	 - On error, reference counter doesn't change. 
	* libmailutils/filter/fltchain.c (_add_next_link): Make sure
	the transport reference counter does not change.
	* libmailutils/tests/Makefile.am: Add new auxiliary program and
	test case.
	* libmailutils/tests/fltcnt.at: New file.
	* libmailutils/tests/fltcnt.c: New file.
	* libmailutils/tests/testsuite.at: Include new test.

2021-07-14  Sergey Poznyakoff  <gray@gnu.org>

	Minor change.

	* libmailutils/stream/streamref.c
	(mu_streamref_create_abridged):Don't reposition the underlying
	stream to beginning.

2021-07-13  Sergey Poznyakoff  <gray@gnu.org>

	Bugfixes.

	* libproto/imap/fetch.c (_fill_response): Tolerate NIL date
	field.
	* libproto/imap/mailbox.c (__imap_msg_get_stream): Seek to the
	end, instead of computing stream size.
	* libproto/mbox/mboxrd.c (mailbox_append_message): If all
	methods of determining envelope size fail, assume epoch instead
	of bailing out.

2021-06-11  Sergey Poznyakoff  <gray@gnu.org>

	mail: fix descriptions of command arguments in help output.

2021-06-11  Sergey Poznyakoff  <gray@gnu.org>

	fix mail '| cat >/tmp/save'

	* mail/send.c (msg_to_pipe): Run command via shell.

2021-06-11  Sergey Poznyakoff  <gray@gnu.org>

	Fix handling of MIME messages that have only one part.

	* libmailutils/mime/mime.c (_mime_part_size): Fix handling of
	one part MIME messages. Don't touch psize memory in case of
	error.
	(_mime_body_stream_read): Fix handling of one part MIME
	messages. Previous implementation used to add an extra newline
	at the end.
	* mh/tests/mhn.at: Reflect the above changes.
	* sieve/tests/vacation.at: Reflect the above changes.

2021-06-11  Sergey Poznyakoff  <gray@gnu.org>

	Fix typo.

	* mail/util.c (util_outfilename): Remove extra closing
	parenthesis.

2021-06-10  Sergey Poznyakoff  <gray@gnu.org>

	Update docs; improve mailx compatibility mode.

	* doc/texinfo/programs/mail.texi (Saving and Recording): New
	section.
	* mail/mailvar.c: Make sure escape is a single character.
	* mail/util.c (util_outfilename): In mailx compatibility mode,
	assume outfilename_local.

2021-06-10  Sergey Poznyakoff  <gray@gnu.org>

	Fix memory leaks (mboxrd and mail)

	* libproto/mbox/mboxrd.c (mboxrd_rescan_unlocked): Free buf.
	(mboxrd_detect): Destroy str when no longer needed.
	* mail/copy.c (mail_copy0): Free allocated memory. Create file
	in cwd if util_outfolder_name return NULL.
	* mail/exit.c (mail_exit): Destroy mbox.
	* mail/util.c (util_range_msg): Use msgset_free instead of
	plain free.

2021-06-10  Sergey Poznyakoff  <gray@gnu.org>

	Provide several ways of creating the outgoing file name.

	Several mail commands store message in a file named by its
	recipient (or sender) in the "folder" directory (these commands
	are: Copy, Save, Mail, followup, Followup). As per POSIX, the
	local part of the email address serves as the file name. There
	may be cases, however, when using the entire email would be
	preferable.

	This commit introduces new mail variable "outfilename" that
	controls how the file name is generated. Its default value is
	"local", which means use the email local part. Other possible
	values are: "email", to save messages in a file named by entire
	email, and "domain", to save them in a file named by domain
	part of the email.

	* NEWS: Document changes.
	* doc/texinfo/programs/mail.texi: Document changes.
	* mail/mail.c (default_setup): Set outfilename=local.
	* mail/mail.h (mailvar_name_outfilename): New define.
	(outfilename_mode): New extern.
	(util_outfilename): New proto.
	* mail/mailvar.c: New variable: "outfilename".
	* mail/send.c (mail_compose_send): Use util_outfilename to form
	outgoing file name.
	* mail/util.c (outfilename_mode): New global.
	(util_outfilename): New function.
	(util_message_sender): Use util_outfilename.

2021-06-09  Sergey Poznyakoff  <gray@gnu.org>

	mail: implement the fullnames variable.

	* NEWS: Document changes.
	* doc/texinfo/programs/mail.texi: Likewise.
	* mail/mail.c (default_setup): Set fullnames.
	* mail/mail.h (mailvar_name_fullnames): New define.
	* mail/mailvar.c (fullnames): New variable.
	* mail/reply.c (compose_remove_personal): New function.
	(respond_msg,respond_all): Call compose_remove_personal if
	fullnames is not set.

2021-06-09  Sergey Poznyakoff  <gray@gnu.org>

	Add tests for mail send/reply/followup commands.

	* mail/mail.c (main): Fix exit status in send mode.
	* mail/tests/Makefile.am: Add new tests.
	* mail/tests/testsuite.at: Likewise.
	* mail/tests/atlocal.in (MAILER): New variable.
	* mail/tests/Followup.at: New file.
	* mail/tests/Reply.at: New file.
	* mail/tests/followup.at: New file.
	* mail/tests/reply.at: New file.
	* mail/tests/send.at: New file.
	* mail/tests/sendbyname.at: New file.
	* mail/tests/sendrec.at: New file.

2021-06-09  Sergey Poznyakoff  <gray@gnu.org>

	mail: fix semantics of mail sending and saving commands.

	* NEWS: Document changes.
	* doc/texinfo/programs/mail.texi: Document changes.
	* mail/Makefile.am (mail_SOURCES): Remove followup.c
	* mail/followup.c: Remove.
	* mail/mail.c: Fix the -F option. Rewrite send mode by calling
	mail_send directly.
	* mail/mail.h (mailvar_name_byname): Remove.
	(mail_send0): Rename to mail_compose_send. All uses changed.
	(util_message_sender): New function.
	* mail/mailvar.c (mailvar_tab): Remove the "byname" variable.
	"outfolder": Accept string and boolean values.
	(print_descr): Handle hard newlines.
	(mailvar_get): Use mailvar_type_whatever to test whether a
	variable is set, regardless of its type.
	* mail/reply.c: Rewrite to match POSIX standard. This affects
	the following commands: "reply", "Reply", "followup",
	"Followup".
	* mail/send.c (compose_header_set): Use util_merge_addresses
	when operating on address headers.
	(send_message): In mailx compatibility mode, assume the
	sendmail:// scheme.
	(mail_send0): Rename to mail_compose_send. Add Date header
	before saving the message, to make sure
	mu_mailbox_append_message won't bail out.
	* mail/table.c: New command: "Mail".
	* mail/testsuite/mail/send.exp: Fix expected output.
	* mail/testsuite/mail/write.exp: Likewise.
	* mail/util.c (util_message_sender): New function.
	(util_get_sender): Rewrite using util_message_sender.
	(util_outfolder_name,util_save_outgoing): Rewrite from scratch,
	Ensure mailx compatibility,
	* mail/write.c (mail_write): Don't use outfolder. 
	* testsuite/mockmail.c: Support -i and -v options.
	* testsuite/mockmail.at: Unset MAIL_DUMP when testing.

2021-06-08  Sergey Poznyakoff  <gray@gnu.org>

	Bugfix.

	* libproto/mbox/mboxrd.c (mailbox_append_message): Don't
	overwrite the error code.

2021-06-07  Sergey Poznyakoff  <gray@gnu.org>

	mail: Add a Date: header before sending the message.

	* mail/send.c (message_add_date): New function.
	(mail_send0): Call message_add_date before sending the message.

2021-06-06  Sergey Poznyakoff  <gray@gnu.org>

	mail: revamp parsing of adresses in send mode.

	In particular, this fixes parsing of addresses with comma in
	the local part.

	* include/mailutils/address.h (MU_ADDRESS_HINT_INITIALIZER):
	New define.
	* libmailutils/address/addrstream.c (mu_stream_format_address):
	Format local user names without surrounding angle quotes.
	* mail/mail.h (util_header_expand): Rename to
	util_header_expand_aliases. All uses changed.
	(util_address_expand_aliases): New function.
	* mail/send.c (compose_header_set): Expand aliases if
	inplacealiases is set. Avoid useless recursion.
	* mail/util.c (send_message): Create addresses via
	mu_address_create_hint to avoid appending local domain to the
	unqualified user names.
	(mail_send0): Likewise.
	(util_address_expand_aliases): New function.
	(util_header_expand): Rename to util_header_expand_aliases. Use
	util_address_expand_aliases and regular address parsing
	functions instead of wordsplit. Unwrap header values.

2021-05-25  Sergey Poznyakoff  <gray@gnu.org>

	Test IMAP folder scanning.

	* imap4d/imap4d.c (prefix_section_parser): Use
	namespace_encode_delim.
	* imap4d/imap4d.h (namespace_decode_delim)
	(namespace_encode_delim): New protos.
	* imap4d/list.c (list_ref): Convert delimiters in the wcard to
	/.
	* imap4d/namespace.c (namespace_decode_delim)
	(namespace_encode_delim): New functions. 
	* imap4d/tests/testclient.c: New auxiliary program.
	* imap4d/tests/.gitignore: Add testclient.
	* imap4d/tests/Makefile.am: Add new tests
	* imap4d/tests/atlocal.in: Include libproto/imap/tests in the
	PATH.
	* imap4d/tests/clt_list.at: New file.
	* imap4d/tests/list.at: Test delimiter translation.
	* imap4d/tests/testsuite.at: Add new tests. 
	* libproto/imap/tests/imapfolder.c: Sort the resulting lists.
	Use quoting on output.

2021-05-25  Sergey Poznyakoff  <gray@gnu.org>

	imap4d LIST: discern between implementation-defined and
	required behavior.

	* imap4d/list.c (match_pfx): Return true if ref is "pfx/",
	where / stands for a namespace delimiter.
	* imap4d/namespace.c (prefix_translate_name): namespace prefix
	is required to end with a delimiter.
	* imap4d/tests/list.at: Make sure all reference arguments that
	refer to directories end in a hierarchy delimiter.

2021-05-23  Sergey Poznyakoff  <gray@gnu.org>

	fix memory leak in folder scanner.

	* libmailutils/mailbox/folder.c (mu_folder_enumerate): Set the
	destroy_item function on the created list.
	* libmailutils/mailbox/fsfolder.c (list_helper): Free the resp
	structure when it is no longer needed.

2021-05-23  Sergey Poznyakoff  <gray@gnu.org>

	Fix the previous commit: take into account "" mailbox names.

	* libproto/imap/folder.c (_mu_imap_folder_separator): Use empty
	mailbox name to get the hierarchy delimiter.
	* libproto/imap/genlist.c: Take into account eventual hierarchy
	delimiter queries.

2021-05-22  Sergey Poznyakoff  <gray@gnu.org>

	folder scan returns mailbox names without the leading directory
	prefix.

	For example, suppose folder /foo/bar contains mailboxes a, b,
	and c. Then scanning the mu_folder_t object for '/foo' will
	return 'bar/a', 'bar/b', and 'bar/c'. Scanning the mu_folder_t
	for '/foo/bar'

	 will return 'a', 'b', and 'c', and so on. 
	* libmailutils/string/mkfilename.c (mu_make_file_name_suf):
	Reasonable handling of corner cases. Document its behavior. 
	* libmailutils/mailbox/fsfolder.c (struct folder_scan_data):
	New member: prefix_len
	(list_helper): Return the portion of the file name after the
	base directory prefix.
	(_fsfolder_list): Initialize sdata.prefix_len.
	* libmailutils/tests/fsfolder.c: Remove prefix handling code.
	* libmailutils/tests/fsfolder00.at: Change expectations.
	* libmailutils/tests/fsfolder02.at: Likewise.
	* libmailutils/tests/fsfolder03.at: Likewise.
	* libmailutils/tests/fsfolder04.at: Likewise. 
	* include/mailutils/sys/imap.h (struct _mu_imap): New members:
	separator and prefix_len.
	* libproto/imap/folder.c (_mu_imap_folder_separator): New
	function.
	(_mu_imap_folder_pathname): New function.
	(_mu_imap_folder_list): Prefix the original refname with the
	base directory of the folder.
	(_mu_imap_folder_lsub,_mu_imap_folder_subscribe)
	(_mu_imap_folder_unsubscribe,_mu_imap_folder_delete)
	(_mu_imap_folder_rename): Adjust input mailbox names.
	* libproto/imap/genlist.c (list_untagged_handler): Return the
	portion of the file name after the base directory prefix.
	* libproto/imap/tests/imapfolder.c: Minor change.

	Update for changed folder behavior 
	* imap4d/list.c (struct refinfo): Replace dirlen with delim - a
	character to be inserted between the original reference and
	mailbox name.
	(list_fun): Insert delimiter, if required.
	(list_ref): Set refinfo.delim, unless the reference prefix
	already ends with a delimiter or is the same as the namespace
	prefix.

	Mail 'folders' command: add support for remote folders. 
	* mail/folders.c: Handle remote folders correctly.
	* mail/mail.h (util_get_folder): New proto.
	* mail/mailline.c (struct filegen): Remove path_len.
	(new_folder): Rename to util_get_folder and move to util.c
	(filegen_init): Initialize prefix_len from the argument.
	* mail/util.c (util_get_folder): New function.

2021-05-21  Sergey Poznyakoff  <gray@gnu.org>

	Bugfix in mu_list_clear.

	The bug affected imap client code, in particular.

	* libmailutils/list/clear.c (mu_list_clear): Reset list item
	count.

2021-05-01  Sergey Poznyakoff  <gray@gnu.org>

	Revise the mailbox locking functions.

	The locker is created by the following call:

	 mu_locker_create_ext(&locker, filename, &hints);

	The last arguments points to a structure mu_locker_hints_t,
	which defines the settings for the locker. NULL value implies
	default. Settings of an existing locker can be modified using
	the following call: 
	 mu_locker_modify(locker, &hints);

	Current settings can be examined using mu_locker_get_hints.

	The functions mu_locker_destroy, mu_locker_lock_mode,
	mu_locker_lock, mu_locker_touchlock, mu_locker_unlock, and
	mu_locker_remove_lock remained unchanged. Rest of functions is
	deprecated, but retained for a couple of releases for the sake
	of backward compatibility.

	Constants (locker types, flags, etc) are also revisited.

	This commit also fixes a bug in mu_spawnvp function, which was
	discovered when testing external lockers. 
	* include/mailutils/locker.h: Major rewrite.
	(MU_LOCKER_DEFAULT_EXPIRE_TIME) (MU_LOCKER_DEFAULT_RETRY_COUNT)
	(MU_LOCKER_DEFAULT_RETRY_SLEEP)
	(MU_LOCKER_DEFAULT_EXT_LOCKER): New defines.
	(mu_locker_hints_t): New data type. (MU_LOCKER_FLAG_RETRY)
	(MU_LOCKER_FLAG_EXPIRE_TIME) (MU_LOCKER_FLAG_CHECK_PID)
	(MU_LOCKER_FLAG_TYPE,MU_LOCKER_FLAGS_ALL): New defines.
	(mu_locker_create_ext, mu_locker_modify)
	(mu_locker_get_hints): New functions.
	(mu_locker_create,mu_locker_set_default_flags)
	(mu_locker_set_default_retry_timeout)
	(mu_locker_set_default_retry_count)
	(mu_locker_set_default_expire_timeout)
	(mu_locker_set_default_external_program)
	(mu_locker_set_flags,mu_locker_mod_flags)
	(mu_locker_set_expire_time,mu_locker_set_retries)
	(mu_locker_set_retry_sleep,mu_locker_set_external)
	(mu_locker_get_flags,mu_locker_get_expire_time)
	(mu_locker_get_retries,mu_locker_get_retry_sleep): Mark as
	deprecated.
	* libmailutils/base/locker.c: Rewrite.
	* libmailutils/cli/stdcapa.c: New locking statements: type and
	retry-sleep. retry-timeout is deprecated. 
	* libmailutils/tests/lck.c: Use new locker functions.
	* libmailutils/tests/lock.at: Test the external locker. 
	* libmailutils/base/spawnvp.c (mu_spawnvp): Restore the default
	SIGCHLD handler while waiting for the process to terminate. 
	* dotlock/dotlock.c: Use new locker functions.
	* lib/manlock.c: Likewise.
	* libmailutils/base/amd.c: Likewise.
	* libmu_dbm/berkeley.c: Likewise.
	* libmu_sieve/extensions/vacation.c: Likewise.
	* libproto/dotmail/dotmail.c: Likewise.
	* libproto/mbox/mboxrd.c: Likewise.
	* mail/copy.c: Likewise. 
	* mda/lmtpd/lmtpd.c: Modify mu_locker_defaults instead of using
	deprecated functions.
	* mda/mda/mda.c: Likewise.
	* mda/putmail/putmail.c: Likewise. 
	* NEWS: Document changes.
	* configure.ac: Version 3.12.90.
	* doc/texinfo/Makefile.am: Add programs/dotlock.texi
	* doc/texinfo/programs.texi: Rewrite the locking section. New
	section: dotlock.
	* doc/texinfo/programs/dotlock.texi: New file.

2021-04-29  Sergey Poznyakoff  <gray@gnu.org>

	mail: accept attachments from FIFOs.

	* mail/send.c: Use mu_file_stream_create for FIFOs.

2021-04-29  Sergey Poznyakoff  <gray@gnu.org>

	mh: fix extra doc formatting.

	* mh/mh_getopt.c (mh_extra_help_hook): Use number of leading
	whitespace as left margin for output.

2021-04-29  Sergey Poznyakoff  <gray@gnu.org>

	libopt: don't show hidden options in the --usage output.

	* libmailutils/opt/help.c (option_summary): Skip options with
	MU_OPTION_HIDDEN bit set.
	(mu_option_describe_options): Reset margin to 0 so that
	eventual extra_doc is formatted correctly.

2021-04-29  Sergey Poznyakoff  <gray@gnu.org>

	Further improvements of the locker interface.

	This fixes a bug that prevented previous versions of mailutils
	to retry aquiring the lock.

	Locking configuration (the "locking" section) is improved.

	* dotlock/dotlock.c: New options: --retry (-r), --delay (-t),
	--pid-check (-p). Use the "locking" capability.
	* libmailutils/base/locker.c: Remove the uses of assert().
	(mu_locker_lock_mode): Fix the retry loop.
	(lock_dotlock): Use mu_asprintf to create temporary lock name.
	Return EAGAIN on temporary error conditions.
	(lock_kernel): Fix typo (EACCES).
	* libmailutils/cli/stdcapa.c (cb_locker_flags): Locker flags
	are deprecated.
	(cb_locker_retry_timeout,cb_locker_retry_count): Clear the
	MU_LOCKER_RETRY flag, if supplied a zero value.
	(cb_locker_external): Clear the MU_LOCKER_EXTERNAL flag (revert
	to the dotlock locker type) if the value is a false boolean
	value.
	* libmailutils/tests/Makefile.am: Add new test.
	* libmailutils/tests/testsuite.at: Include new test,
	* libmailutils/tests/lck.c: New test program.
	* libmailutils/tests/lock.at: New test.

2021-04-27  Sergey Poznyakoff  <gray@gnu.org>

	Fix misattributed locker flags.

	* libmailutils/cli/stdcapa.c (cb_locker_expire_timeout)
	(cb_locker_external): Pass proper first argument to
	mu_locker_set_default_flags.

2021-04-18  Sergey Poznyakoff  <gray@gnu.org>

	Bugfix in the configuration file lexer.

	String values like the following caused failure:

	 "foo \
	 bar \
	 baz \
	 qux"

	The second and third physical lines would not be recognized by
	the scanner. The bug was due to a long-standing copy-paste
	error.

2021-04-18  Sergey Poznyakoff  <gray@gnu.org>

	SQL auth: supply backend-specific parameters via the "param"
	statement.

	For MySQL, backend-specific parameter is a list of
	keuword=value pairs delimited by semicolons. Valid keywords
	are:

	defaults_file - read configuration from the supplied file;
	group - if default_file is supplied, read configuration from
	this named group (default - "client"); ca - name of the
	certificate authority file;

	* include/mailutils/sql.h (mu_sql_module_config)<param>: New
	member.
	(mu_sql_connection)<param>: New member.
	(mu_sql_connection_init): Take additional argument (param). All
	uses changed.
	* libmu_auth/sql.c: New keyword: "param".
	* sql/mysql.c (mu_mysql_connect): Parse backend-specific
	parameters: defaults_file, group, and ca.
	* sql/sql.c (mu_sql_connection_init): Take additional argument.
	Initialize the connection param member.

2021-04-18  Sergey Poznyakoff  <gray@gnu.org>

	mbox,dotmail: fix the _message_unseen method.

	* libproto/dotmail/dotmail.c (dotmail_message_unseen): Set
	return value to 0 and return success if there are no unseen
	messages.
	* libproto/mbox/mboxrd.c (mboxrd_message_unseen): Likewise.

2021-04-15  Sergey Poznyakoff  <gray@gnu.org>

	Bugfix in mimeview testsuite.

	* mimeview/tests/bf.c (write_byte): Fix type of the character
	buffer.

2021-04-15  Sergey Poznyakoff  <gray@gnu.org>

	Minor fix.

	* include/mailutils/sys/streamtrans.h: Add missing #endif

2021-02-13  Sergey Poznyakoff  <gray@gnu.org>

	Version 3.12.

2021-02-13  Sergey Poznyakoff  <gray@gnu.org>

	Skip imap4d tests if home directory does not exist.

	* imap4d/tests/testsuite.at (IMAP4D_RUN): Skip test if home
	directory does not exist.

2021-02-10  Sergey Poznyakoff  <gray@gnu.org>

	inc: when updating the unseen sequence, translate message
	numbers to uids.

	* mh/inc.c (main): Ensure translation from ordinal to sequence
	numbers (uid).

2021-02-09  Sergey Poznyakoff  <gray@gnu.org>

	dotmail: synchronize with the recent changes to mbox.

	* libproto/dotmail/dotmail.c: Synchronize with the recent
	changes to mbox.
	* libproto/dotmail/tests/rospool.at: New test.
	* libproto/dotmail/tests/Makefile.am: Add new test.
	* libproto/dotmail/tests/testsuite.at: Add new test.

2021-02-09  Sergey Poznyakoff  <gray@gnu.org>

	mbox: use fstat etc. instead of stat etc.

	* libproto/mbox/mboxrd.c (mboxrd_stat,mboxrd_set_priv): New
	functions.
	(mboxrd_get_atime): Use mboxrd_stat instead of stat(2). Fix the
	return value.
	(mboxrd_flush_unlocked): Use mboxrd_stat to stat the mailbox
	and mboxrd_set_priv to set mode and ownership.
	* libproto/mbox/tests/rospool.at: Remove extra newline (typo).

2021-02-09  Sergey Poznyakoff  <gray@gnu.org>

	mbox: fix expunging in a read-only directory.

	This fixes debian bug 980042. Re:
	https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=980042#16

	* libproto/mbox/mboxrd.c (mboxrd_flush_unlocked): If temporary
	file cannot be created in the directory of the mailbox because
	of EACCES, create it elsewhere and copy back to the mailbox
	when ready. Also, make sure that the mode and ownership of the
	mailbox are preserved, no matter what temporary file was used.
	* libproto/mbox/tests/rospool.at: New test.
	* libproto/mbox/tests/Makefile.am: Add new test.
	* libproto/mbox/tests/testsuite.at: Add new test.

2021-01-12  Sergey Poznyakoff  <gray@gnu.org>

	Fix libmu_scm testsuite.

	This is a follow-up to a3bd653315.

	* libmu_scm/tests/testsuite.at (MU_GUILE_OUTPUT_FILTER): New
	macro.
	(MU_GUILE_CHECK): If MU_GUILE_OUTPUT_FILTER is not empty,
	filter the stdout through it.
	* libmu_scm/tests/mailbox-append-message.at: Filter out line
	and byte counts.
	* libmu_scm/tests/mailbox-expunge.at: Fix line and byte counts.
	* libmu_scm/tests/mailbox-get-message.at: Likewise.
	* libmu_scm/tests/mailbox-iterate.at: Likewise.

2021-01-12  Sergey Poznyakoff  <gray@gnu.org>

	Remove left-over mailutils.rc support.

	* libmailutils/cli/cli.c (MU_LEGACY_CONFIG_FILE): Remove.
	(mu_cli_ext): No handling for the pre-3.0 configuration file.

2021-01-11  Sergey Poznyakoff  <gray@gnu.org>

	Fix building mda utilities with mailbox quotas off.

2021-01-11  Sergey Poznyakoff  <gray@gnu.org>

	Fix architecture-dependent test failures.

	* configure.ac (MU_COND_MAILBOX_QUOTA): Fix test condition.
	* libproto/dotmail/tests/atlocal.in (x_imapbase_normalize): New
	function.
	* libproto/mbox/tests/atlocal.in: Likewise.
	* libproto/dotmail/tests/delete.at: Filter output through
	x_imapbase_normalize to avoid triggering false negative due to
	padding differences.
	* libproto/mbox/tests/delete.at: Likewise.

2021-01-11  Sergey Poznyakoff  <gray@gnu.org>

	Force character signedness in strout test.

2021-01-11  Sergey Poznyakoff  <gray@gnu.org>

	SMTP mailer: fix selection of the default port.

	* libproto/mailer/smtp.c (smtp_open): Use MU_SMTPS_PORT only if
	MAILER_TLS_ALWAYS is required.

2021-01-11  Sergey Poznyakoff  <gray@gnu.org>

	strout test: don't wait for the input forever.

	* libmailutils/tests/strout.c: Run no longer than 30 seconds.
	Standardize exit codes.

2021-01-05  Sergey Poznyakoff  <gray@gnu.org>

	Minor changes.

2021-01-05  Sergey Poznyakoff  <gray@gnu.org>

	Version 3.11.1.

2021-01-05  Sergey Poznyakoff  <gray@gnu.org>

	Fix version output.

	* include/mailutils/cli.h (mu_copyright_year): New extern.
	(mu_version_print): New proto.
	* libmailutils/cli/cli.c (mu_copyright_year): New variable.
	Should be updated once a year.
	(mu_version_print): New function.
	(mu_version_hook): Use mu_version_print.
	* mail/mail.c (mail_warranty): Use mu_version_print.

2021-01-05  Sergey Poznyakoff  <gray@gnu.org>

	Update copyright years.

2020-12-30  Sergey Poznyakoff  <gray@gnu.org>

	Fix coredump on NULL input to mu_url_create_hint.

	In particular, this caused inc to coredump when called without
	explicit -file option.

	* libmailutils/url/create.c (mu_url_create_hint): Return EINVAL
	if str is NULL.
	* mh/tests/inc.at: Add new test.

2020-12-30  Sergey Poznyakoff  <gray@gnu.org>

	Use well-known mboxrd format name everywhere.

2020-12-23  Sergey Poznyakoff  <gray@gnu.org>

	Version 3.11.

2020-12-21  Sergey Poznyakoff  <gray@gnu.org>

	MH: provide a mh_profile setting to control assignment of
	sequence numbers.

	The "Volatile-uidnext" setting controls how sequence numbers
	are allocated. By default they increase monotonically. If
	Volatile-uidnext is set to "true", each new incorporated
	message is assigned the sequence number equal to that of the
	last message increased by one. When the last message in the
	mailbox is deleted, the value of UIDNEXT is recalculated and
	UIDVALIDITY is increased. This follows the behavior of
	traditional MH implementations.

	* doc/texinfo/mu-mh.texi: Document chnges.
	* include/mailutils/sys/amd.h (MU_AMD_VOLATILE_UIDNEXT): New
	constant.
	* libmailutils/base/amd.c (amd_expunge): Reset uidvalidity and
	uidnext if MU_AMD_VOLATILE_UIDNEXT capability is set and the
	last message was removed.
	* libproto/mh/mh.c (_mailbox_mh_init): New mh_profile setting
	"Volatile-uidnext". If set to true, it instructs mailutils to
	mimic the traditional MH behavior when assigning sequence
	number to the new message. 
	* testsuite/mbop.c (main): Use MBOP_PRE_OPEN_HOOK (if defined)
	as the name of the function to call before opening the mailbox.
	* libproto/mh/tests/mbop.c (mbop_pre_open_hook): New function.
	If the MH environment variable is set, take its value as the
	name of the mh_profile and read settings from it. 
	* libproto/mh/tests/Makefile.am: Add uidvol.at
	* libproto/mh/tests/atlocal.in: Unset MH.
	* libproto/mh/tests/testsuite.at: Include uidvol.at
	* libproto/mh/tests/uidvol.at: New file.

2020-12-04  Sergey Poznyakoff  <gray@gnu.org>

	amd: reset the UIDNEXT after resetting the uidvalidity.

	This happens automatically for plaintext mailboxes, but needs
	to be done explicitly for directory-based ones.

	* libmailutils/base/amd.c (amd_set_uidvalidity): Reset the
	UIDNEXT
	* testsuite/mbop.c: New command: uidvalidity_reset

2020-12-04  Sergey Poznyakoff  <gray@gnu.org>

	Explicitly reset uidvalidity after folder -pick.

	(See also 6e0fb32ec8)

2020-11-30  Sergey Poznyakoff  <gray@gnu.org>

	Version 3.10.91.

2020-11-30  Sergey Poznyakoff  <gray@gnu.org>

	New functions for closing all fds and daemonizing.

	* configure.ac: Select a suitable interface for closing all
	file descriptors greater than or equal to a chosen one.
	* include/mailutils/daemon.h (mu_daemon): New proto.
	* include/mailutils/util.h (mu_close_fds): New proto. 
	* lib/daemon.c: Removed.
	* lib/Makefile.am: Remove daemon.c 
	* libmailutils/base/Makefile.am: Add closefds.c
	* libmailutils/base/closefds.c: New file.
	* libmailutils/base/daemon.c: Rename to
	libmailutils/base/pidfile.c
	* libmailutils/base/daemon.c: New file. 
	* libmailutils/diag/bt.c: Use mu_close_fds.
	* libmailutils/server/acl.c: Likewise.
	* mh/mh_whatnow.c: Likewise.
	* libmailutils/stream/prog_stream.c: Likewise. 
	* libmailutils/server/msrv.c: Use mu_daemon.
	* mh/send.c: Likewise. 
	* mda/lib/util.c (mda_close_fds): Remove.

2020-11-29  Sergey Poznyakoff  <gray@gnu.org>

	Optimize the observable interface.

	A bitmask of all requested event types is stored in the
	observable structure. When an event is reported,
	mu_observable_notify first check if the event type bit is set
	in that bitmap. If so, it starts iterating over observers. That
	should allow us to avoid the loop in most cases.

	* include/mailutils/observer.h (mu_observable_wants): New
	proto.
	* include/mailutils/sys/observer.h (_mu_observable): New
	member: types.
	* libmailutils/base/observer.c (mu_observable_attach): Compute
	bitmask of all types requested by attached observers.
	(mu_observable_detach): Likewise.
	(mu_observable_notify): Check if the event type is marked in
	the bitmap, skip iteration if it is not.
	(mu_observable_wants): New function.

2020-11-29  Sergey Poznyakoff  <gray@gnu.org>

	Avoid using VPATH in libproto testsuites.

	* libproto/dotmail/tests/Makefile.am: Build mbop from local
	source.
	* libproto/maildir/tests/Makefile.am: Likewise.
	* libproto/mbox/tests/Makefile.am: Likewise.
	* libproto/mh/tests/Makefile.am: Likewise. 
	* libproto/dotmail/tests/mbop.c: New file.
	* libproto/maildir/tests/mbop.c: New file.
	* libproto/mbox/tests/mbop.c: New file.
	* libproto/mh/tests/mbop.c: New file.

	Rename mbox.c files in libproto libraries to avoid confusion
	with the eponymous format. 
	* libproto/imap/mbox.c: Rename to mailbox.c.
	* libproto/imap/Makefile.am: Update.
	* libproto/maildir/mbox.c: Rename to maildir.c
	* libproto/maildir/Makefile.am: Update.
	* libproto/mailer/mbox.c: Rename to mailbox.c
	* libproto/mailer/Makefile.am: Update.
	* libproto/mh/mbox.c: Rename to mh.c.
	* libproto/mh/Makefile.am: Update.
	* libproto/pop/mbox.c: Rename to mailbox.c
	* libproto/pop/Makefile.am: Update.

2020-11-27  Sergey Poznyakoff  <gray@gnu.org>

	Improve mbox data/time handling.

	* libproto/mbox/mboxrb.c (scan_message_begin): Use a single
	scan format for parsing all possible variants of the date/time.

2020-11-27  Sergey Poznyakoff  <gray@gnu.org>

	Don't use __FILE__ and __LINE__ in mu_debug.

	This is spurious as it can be enabled by the debug.line-info
	configuration directive.

2020-11-27  Sergey Poznyakoff  <gray@gnu.org>

	mu_scan_datetime: Fix error recovery.  %Z handles both
	time-zone forms.

	The value stored in the memory location pointed to by the endp
	argument has changed. On the MU_ERR_PARSE error, it is (as
	earlier) the position in input where conversion stopped. On the
	MU_ERR_FORMAT, however, it is the character in fmt where the
	format error was detected.

	* libmailutils/datetime/scantime.c (peek_state): Return
	MU_ERR_FORMAT if mu_list_tail fails (the list is empty). This
	reflects unbalanced closing parenthesis or bracket.
	(scan_recovery): fix algorithm.
	(mu_scan_datetime): %Z handles both abbreviated time-zones and
	time-zones as hour offset from GMT. Improve error handling. On
	MU_ERR_PARSE error, point *endp to the character in input where
	conversion stopped. On MU_ERR_FORMAT error, point it to the
	character in fmt, where the format error was detected.
	* libmailutils/tests/scantime.c: Improve error handling.
	* libmailutils/tests/scantime.at: More testcases.

2020-11-26  Sergey Poznyakoff  <gray@gnu.org>

	dotmail: re-implement tracker along the lines of mboxrb.

	* include/mailutils/sys/dotmail.h (mu_dotmail_message): New
	member: mark.
	(mu_dotmail_message_reconstruct): Change signature.
	* libproto/dotmail/dotmail.c (mu_dotmail_flush_tracker): Change
	type of the ref member.
	(tracker_next_ref): Rewrite.
	(dotmail_tracker_sync): Rewrite.
	(dotmail_mailbox_copy_unchanged): Rewrite.
	* libproto/dotmail/message.c (dotmail_message_copy_with_uid)
	(mu_dotmail_message_reconstruct): Rewrite.
	* libproto/dotmail/tests/delete.at: Rewrite.

2020-11-26  Sergey Poznyakoff  <gray@gnu.org>

	mboxrb: Keep timestamps in normalized form.

	* include/mailutils/datetime.h (mu_timezone_offset): New proto.
	* libmailutils/datetime/scantime.c: New conversion: %Z
	(timezone abbreviation).
	* libmailutils/datetime/parsedate.y (mu_timezone_offset): New
	function. Returns time offset in seconds corresponding to the
	given timezone abbreviation. 
	* include/mailutils/sys/mboxrb.h (mu_mboxrb_hdr): Remove
	unneeded enum.
	(mu_mboxrb_message): Remove env_date_start, New member "date"
	holds the string representation of the envelope timestamp in
	normalized form - ctime(3), UTC.
	* libproto/mbox/mboxrb.c (scan_message_finalize): New function.
	(scan_message_begin): New function. When initializing the
	message, timestamps in obsolete forms are converted to
	normalized representation.
	(mboxrb_rescan_unlocked): Use scan_message_finalize and
	scan_message_begin.
	* libproto/mbox/message.c (mboxrb_envelope_date): Get
	normalized timestamp from the date member,
	* libproto/mbox/tests/env.at: Reflect the above changes.

2020-11-25  Sergey Poznyakoff  <gray@gnu.org>

	Improve mboxrb scanner.

	* libproto/mbox/mboxrb.c: Request that the From_line be
	preceded by an empty line.

2020-11-25  Sergey Poznyakoff  <gray@gnu.org>

	Replace mbox format driver with mboxrb.

	* NEWS: update 
	* configure.ac: Revert 9763fd4a.
	* include/mailutils/registrar.h: Likewise.
	* libproto/Makefile.am: Likewise. 
	* libmailutils/stream/stream.c (mu_stream_size): Fix size
	calculation in case of line and full buffering scheme.
	* libmailutils/stream/streamcpy.c (mu_stream_copy_nl): Change
	semantics. Ensure that the copied data ends with two newline
	characters. Append them if necessary. 
	* testsuite/mbop.c: New commands: message_lines and
	message_size. 
	* libproto/mbox/mboxrb.c (mboxrb_mailbox_init_stream): Always
	add MU_STREAM_READ permission. Use the same flags for
	mu_mapfile_stream_create and mu_file_stream_create.
	(mboxrb_rescan_unlocked): Count terminating newline as part of
	the message.
	(mailbox_append_message): Make sure each message ends with an
	empty line.
	(mboxrb_tracker_sync): Update mailbox mesg_count.
	(mboxrb_flush_temp): Truncate the temporary stream to the new
	size.
	(mboxrb_flush_unlocked): Clear all modifications only in
	FLUSH_UIDVALIDITY mode.
	(mboxrb_message_copy_with_uid): Fix message_end computation.
	Use mu_stream_copy_nl to copy message body.
	(mu_mboxrb_message_reconstruct): Update ref on return.
	* po/POTFILES.in: Update. 
	* mail/copy.c (append_to_file): Use mu_stream_stat_buffer to
	compute statistics.
	* mail/mail.c: Allow for opening read-only mailboxes. 
	* libproto/mbox/tests/body.at: Fix the expected byte count.
	* libproto/mbox/tests/qget.at: Likewise.
	* libproto/mbox/tests/delete.at: Add more tests. 
	* mail/tests/align.at: Fix the expected byte and line count.
	* mail/tests/hold.at: Likewise.
	* mail/testsuite/mail/read.exp: Likewise.
	* mail/testsuite/mail/tag.exp: Likewise.
	* mail/testsuite/mail/z.exp: Likewise.
	* mail/tests/copy04.at: Don't use line count and size in
	comparison.
	* mail/testsuite/mail/write.exp: Use regexps instead of exact
	strings for the same reason. 
	* pop3d/testsuite/pop3d/read.exp: Fix the expected byte count. 
	* readmsg/tests/all.at: Expect extra newline in output.
	* readmsg/tests/hdr.at: Likewise.
	* readmsg/tests/nohdr.at: Likewise.
	* readmsg/tests/twomsg.at: Likewise.
	* readmsg/tests/weed.at: Likewise. 
	* sieve/tests/redirect.at: Fix the expected byte count.
	* sieve/tests/reject.at: Expect extra newline in output. 
	* mh/inc.c (incmbx): Parse truncate and nomoveto URL parameters
	prior to opening the mailbox. If notruncate is requested, open
	the mailbox read-only.
	* mh/mh_format.c (str_compress_ws): Fix copying between
	overlapping memory regions. 
	* libtests/Makefile.am: Remove lstuid tests.
	* libtests/testsuite.at: Likewise.
	* libtests/lstuid.c: Remove.
	* libtests/lstuid00.at: Remove.
	* libtests/lstuid01.at: Remove.
	* libtests/lstuid02.at: Remove.
	* libtests/mime.at: Fix the expected byte count. 
	* imap4d/tests/IDEF0956.at: Fix the expected byte count.
	* map4d/tests/fetch.at: Likewise.
	* imap4d/tests/append00.at: Remove X-* headers and Status from
	the mbox prior to comparison.
	* imap4d/tests/append01.at: Likewise. 
	* libproto/mbox: Remove old code. Replace it with mboxrb.
	* mail/tests/nohome.at: Update lines/sizes.
	* mail/testsuite/mail/folder.exp: Likewise.
	* mail/testsuite/mail/tag.exp: Likewise.
	* mail/testsuite/mail/z.exp: Likewise. 
	* mda/mda/tests/mda.at: Fix shell quoting.
	* mda/putmail/tests/putmail.at: Remove extra newline from the
	expectation. Eliminate X-IMAPbase and X-UID from the resulting
	mailbox.
	* mda/tests/mda.sh: Eliminate X-IMAPbase and X-UID from the
	output. 
	* pop3d/testsuite/pop3d/read.exp: Fix expected lines/sizes
	* readmsg/tests/hdr.at: Fix extra whitespace. 
	* sieve/tests/action.at: Eliminate X-IMAPbase and X-UID. Fix
	extra whitespace in the expected From_ line.
	* sieve/tests/addheader.at: Likewise.
	* sieve/tests/pipeact.at: Likewise.

2020-11-23  Sergey Poznyakoff  <gray@gnu.org>

	Two bugfixes.

	* libproto/mboxrb/mboxrb.c (mboxrb_open): Propagate failure to
	open the stream to the return code.
	* libproto/mboxrb/tests/notify.at: Use cat to create test inbox

2020-11-23  Sergey Poznyakoff  <gray@gnu.org>

	Add two more mboxrb tests.

2020-11-23  Sergey Poznyakoff  <gray@gnu.org>

	mboxrb: rewrite tracker.

	* include/mailutils/sys/mboxrb.h (mu_mboxrb_message_ref):
	Remove.
	(mu_mboxrb_message_reconstruct): Change prototype.
	* libproto/mboxrb/mboxrb.c (mu_mboxrb_flush_tracker) <ref>:
	Change type to size_t *.
	(tracker_next_ref): Return the refereced message.
	(mboxrb_tracker_sync): Rewrite.
	(mboxrb_mailbox_copy_unchanged): Update.
	(mailbox_append_message): Place exactly one empty line between
	two messages.
	* libproto/mboxrb/message.c (mboxrb_message_copy_with_uid): Ref
	argument is struct mu_mboxrb_message *.
	(mu_mboxrb_message_reconstruct): Likewise.
	* libproto/mboxrb/tests/delete.at: Check number of messages
	after deletion.
	* libproto/mboxrb/tests/append.at: Expect extra newline.

2020-11-23  Sergey Poznyakoff  <gray@gnu.org>

	Fix deletes.  Add new tests.

	* include/mailutils/sys/mboxrb.h (mu_mboxrb_message): New
	member: mark
	* libproto/mboxrb/mboxrb.c (mu_mboxrb_message_ref): New
	members: from_length, env_sender_len, env_date_start.
	* libproto/mboxrb/message.c (mboxrb_rescan_unlocked): Update
	dmp->scan. Fix NULL dereference.
	(mboxrb_rescan): Don't update dmp->scan, see above.
	(mailbox_append_message): Write out envelope; use FROMRB
	filter.
	(mboxrb_tracker_sync): Rewrite using mark/sweep technique. 
	* libproto/mboxrb/tests/Makefile.am: Add new tests.
	* libproto/mboxrb/tests/testsuite.at: Include new tests.
	* libproto/mboxrb/tests/append.at: New test.
	* libproto/mboxrb/tests/delete.at: New test.
	* libproto/mboxrb/tests/qget.at: New test.
	* libproto/mboxrb/tests/uidnext.at: New test.
	* libproto/mboxrb/tests/uidvalidity.at: New test.

2020-11-23  Sergey Poznyakoff  <gray@gnu.org>

	Implement mboxrb format (a replacement for the mbox used
	currently)

	* configure.ac: New format: mboxrb
	* include/mailutils/filter.h (mu_fromrb_filter): New extern.
	* include/mailutils/registrar.h (mu_mboxrb_record): New extern.
	(mu_register_all_mbox_formats)
	(mu_register_local_mbox_formats): Add mu_mboxrb_record.
	* libmailutils/filter/filter.c (mu_filter_get_list): Add
	mu_fromrb_filter
	* libproto/Makefile.am [MU_COND_SUPPORT_MBOXRB]: Add mboxrb 
	* bootstrap.conf: Remove special handling for testsuite/maildir
	(fixes 1d846d2d92).
	* testsuite/mbop.c: Implement the -r (--read-only) option.
	* include/mailutils/sys/Makefile.am: Add mboxrb.h
	* include/mailutils/sys/mboxrb.h: New file.
	* libmailutils/filter/Makefile.am (libfilter_la_SOURCES): Add
	fromrb.c
	* libmailutils/filter/fromrb.c: New file.
	* libmailutils/tests/Makefile.am: New file.
	* libmailutils/tests/fromrb.at: New file.
	* libmailutils/tests/testsuite.at: New file.
	* libproto/mboxrb/Makefile.am: New file.
	* libproto/mboxrb/mboxrb.c: New file.
	* libproto/mboxrb/message.c: New file.
	* libproto/mboxrb/tests/.gitignore: New file.
	* libproto/mboxrb/tests/Makefile.am: New file.
	* libproto/mboxrb/tests/atlocal.in: New file.
	* libproto/mboxrb/tests/attr.at: New file.
	* libproto/mboxrb/tests/autodetect.at: New file.
	* libproto/mboxrb/tests/body.at: New file.
	* libproto/mboxrb/tests/count.at: New file.
	* libproto/mboxrb/tests/env.at: New file.
	* libproto/mboxrb/tests/header.at: New file.
	* libproto/mboxrb/tests/testsuite.at: New file.

2020-11-20  Sergey Poznyakoff  <gray@gnu.org>

	dotmail: update uids in append mode as well.

	* include/mailutils/sys/dotmail.h (mu_dotmail_mailbox): New
	member stream_flags.
	* libproto/dotmail/dotmail.c (dotmail_mailbox_init_stream):
	Translate MU_STREAM_APPEND to MU_STREAM_RDWR.
	(dotmail_rescan_unlocked,dotmail_rescan): Check actual stream
	flags, not the mailbox ones.
	(dotmail_flush_unlocked): Remove check for MU_STREAM_APPEND.
	* libproto/dotmail/tests/append.at: Test appends in append
	mode. 
	* testsuite/mbop.c: New option -a (--append).

2020-11-20  Sergey Poznyakoff  <gray@gnu.org>

	dotmail: optimize appends.

	* include/mailutils/sys/dotmail.h (mu_dotmail_mailbox): New
	members: x_imapbase_off and x_imapbase_len.
	* libproto/dotmail/dotmail.c: Format X-IMAPbase header with
	fixed width to avoid rewriting entire mailbox only to make the
	new header fit to its place in the first message.

2020-11-19  Sergey Poznyakoff  <gray@gnu.org>

	Make sure UIDs are monotonically increased in dotmail, mh, and
	maildir.

	* include/mailutils/sys/amd.h (_MU_AMD_PROP_UIDNEXT): New
	define.
	(MU_AMD_PROP): Remove.
	(MU_AMD_F_PROP): New flag.
	(_amd_data): New member: flags. Remove next_uid
	(amd_reset_uidvalidity): Change return type.
	(amd_update_uidnext,amd_alloc_uid): New protos.
	* include/mailutils/sys/dotmail.h (mu_dotmail_mailbox): New
	member uidvalidity_changed.
	* libmailutils/base/amd.c (_amd_prop_create): Set MU_AMD_F_PROP
	flag if the prop file exists.
	(amd_initial_scan): New function. (amd_get_uidvalidity,
	amd_set_uidvalidity)
	(amd_uidnext): Rewrite using amd_initial_scan.
	(amd_reset_uidvalidity): Return int.
	(amd_update_uidnext,amd_alloc_uid): New functions. 
	* libproto/dotmail/dotmail.c (dotmail_close): Flush UID
	parameters if uidvalidity_changed is set.
	(dotmail_flush): Take three-state mode as its third argument.
	(dotmail_flush_unlocked): Likewise. If operating in
	FLUSH_UIDVALIDITY mode, clear all other modifications to the
	messages in the mailbox. Clear uidvalidity_changed on success.
	(dotmail_expunge, dotmail_sync): Update call to dotmail_flush.
	(dotmail_alloc_next_uid): Set uidvalidity_changed.
	(dotmail_rescan_unlocked): Check if the assigned UID is greater
	than the previously assigned one and less than the UIDNEXT
	value. Raise uidvalidity_changed if UIDs were re-allocated.
	(mu_dotmail_mailbox_uid_setup): Set uidvalidity_scanned.
	* libproto/dotmail/tests/Makefile.am: Add new test.
	* libproto/dotmail/tests/testsuite.at: Likewise.
	* libproto/dotmail/tests/uidnext.at: New test.
	* libproto/maildir/mbox.c: Use amd_update_uidnext to
	synchronize the computed and predicted uidnext value.
	(maildir_next_uid): Remove. 
	* libproto/maildir/tests/Makefile.am: Add new test.
	* libproto/maildir/tests/testsuite.at: Likewise.
	* libproto/maildir/tests/uidnext.at: New test. 
	* libproto/mh/mbox.c (_mh_next_seq): Remove function.
	(mh_scan0): Use amd_update_uidnext to synchronize the computed
	and predicted uidnext value.
	* libproto/mh/tests/Makefile.am: Add new test.
	* libproto/mh/tests/testsuite.at: Likewise.
	* libproto/mh/tests/uidnext.at: New test.

2020-11-18  Sergey Poznyakoff  <gray@gnu.org>

	imap4d: SEARCH: don't bail out if unexistent UID is given as
	criterion.

	* imap4d/search.c (node_false): New constant.
	(parse_simple_key): Report error only if mu_msgset_parse_imap
	returns MU_ERR_PARSE. Otherwise, add node_false to the tree.
	(evaluate_node): Handle node_false.

2020-11-18  Sergey Poznyakoff  <gray@gnu.org>

	maildir: assign UID to the message file before moving it from
	new to cur.

	* libproto/maildir/mbox.c (maildir_scan_unlocked): Assign next
	UID to the message before moving it from new to cur.
	* libproto/maildir/tests/new.at: New test.
	* libproto/maildir/tests/Makefile.am: Add nre test.
	* libproto/maildir/tests/testsuite.at: Likewise.

2020-11-17  Sergey Poznyakoff  <gray@gnu.org>

	maildir_fixup: don't bail out if unable to open the mailbox.

2020-11-17  Sergey Poznyakoff  <gray@gnu.org>

	Fix mda (lmtpd) testsuite: don't assume mbox as the default
	format.

2020-11-17  Sergey Poznyakoff  <gray@gnu.org>

	Minor changes.

	* libproto/mh/mbox.c: Include limits.h
	* testsuite/mbox2dir.c (next_name_from_file): *scanf %m
	modifier isn't common enough yet. Rewrite using fgets +
	realloc.

2020-11-17  Sergey Poznyakoff  <gray@gnu.org>

	New mailutils subcommand: maildir_fixup.

	The subcommand converts names in maildirs created by earlier
	versions of mailutils to the new format.

	* NEWS: Update.
	* doc/texinfo/programs/mailutils.texi: Document maildir_fixup
	* mu/libexec/Makefile.am: Build maildir_fixup subcommand.
	* mu/libexec/maildir_fixup.c: New file.
	* mu/libexec/mu.h (common_options): New extern. 
	* include/mailutils/cli.h (MU_CLI_OPTION_CONF_PROGNAME): New
	constant.
	* libmailutils/cli/simple.c (MU_CLI_OPTION_PROG_NAME)
	(MU_CLI_OPTION_PROG_NAME) (MU_CLI_OPTION_PROG_DOC)
	(MU_CLI_OPTION_BUG_ADDRESS) (MU_CLI_OPTION_PACKAGE_URL)
	(MU_CLI_OPTION_EXTRA_INFO) (MU_CLI_OPTION_HELP_HOOK)
	(MU_CLI_OPTION_VERSION_HOOK) (MU_CLI_OPTION_PROG_DOC_HOOK)
	(MU_CLI_OPTION_NEGATION)
	(MU_CLI_OPTION_SPECIAL_ARGS): Allow for NULL argument.
	(MU_CLI_OPTION_CONF_PROGNAME): New code

2020-11-17  Sergey Poznyakoff  <gray@gnu.org>

	sortm: reset the uidvalidity of the modified mailbox.

	* include/mailutils/mailbox.h (mu_mailbox_uidvalidity_reset):
	New proto.
	* include/mailutils/sys/mailbox.h (_mu_mailbox): Replace the
	_uidvalidity member with two function pointers:
	_get_uidvalidity and _set_uidvalidity.
	* libmailutils/mailbox/mailbox.c
	(mu_mailbox_uidvalidity_reset): New function. 
	* libmailutils/base/amd.c: Initialize the two methods.
	* libproto/dotmail/dotmail.c: Likewise.
	* libproto/mbox/mbox.c: Likewise.
	* libproto/imap/mbox.c: Initialize the _get_uidvalidity field. 
	* mh/sortm.c: Reset the uidvalidity on success.
	* mh/tests/sortm.at: Check that the uidvalidity changed after
	sorting

2020-11-16  Sergey Poznyakoff  <gray@gnu.org>

	Remove mh and maildir sample mailboxes from the distribution.

	Testsuites use mbox2dir to create the requested directory-based
	mailbox from the mbox source.

2020-11-16  Sergey Poznyakoff  <gray@gnu.org>

	Fix message append notifications for maildir, mh, and dotmail.

	* testsuite/mbop.c: Implement notification mode.
	* comsat/tests/testsuite.at: Fix mh qid. 
	* libproto/dotmail/dotmail.c (dotmail_append_message): Lock the
	monitor before and unlock it after the operation.
	* libproto/dotmail/tests/notify.at: New file.
	* libproto/dotmail/tests/Makefile.am: Add notify.at
	* libproto/dotmail/tests/testsuite.at: Include notify.at. 
	* include/mailutils/sys/amd.h (cur_msg_file_name): Change
	signature.
	* libmailutils/base/amd.c: Use amd->cur_msg_file_name with 0 as
	its second argument to get qid. 
	* libproto/maildir/mbox.c (maildir_cur_message_name): Take
	three argument, second one specifying whether an absolute or
	relative filename is requested. All uses changed.
	* libproto/maildir/tests/notify.at: New file.
	* libproto/maildir/tests/Makefile.am: Add notify.at
	* libproto/maildir/tests/testsuite.at: Include notify.at 
	* libproto/mh/mbox.c (_mh_cur_message_name): Take three
	argument, second one specifying whether an absolute or relative
	filename is requested. All uses changed.
	* libproto/mh/tests/notify.at: New file.
	* libproto/mh/tests/Makefile.am: Add notify.at
	* libproto/mh/tests/testsuite.at: Include notify.at

2020-11-16  Sergey Poznyakoff  <gray@gnu.org>

	Write testsuite for mh mailbox library.

	* libmailutils/base/amd.c (amd_get_attr_flags): Scan the
	message if AMD does not report MU_AMD_STATUS capability.
	* libproto/mh/mbox.c (mh_qfetch): Fix, 
	* libproto/mh/Makefile.am (SUBDIRS): Add tests.
	* libproto/mh/tests/.gitignore: New file.
	* libproto/mh/tests/Makefile.am: New file.
	* libproto/mh/tests/append.at: New file.
	* libproto/mh/tests/atlocal.in: New file.
	* libproto/mh/tests/attr.at: New file.
	* libproto/mh/tests/autodetect.at: New file.
	* libproto/mh/tests/body.at: New file.
	* libproto/mh/tests/count.at: New file.
	* libproto/mh/tests/delete.at: New file.
	* libproto/mh/tests/envelope.at: New file.
	* libproto/mh/tests/header.at: New file.
	* libproto/mh/tests/qget.at: New file.
	* libproto/mh/tests/testsuite.at: New file.
	* libproto/mh/tests/uid.at: New file.
	* libproto/mh/tests/uidvalidity.at: New file.

2020-11-15  Sergey Poznyakoff  <gray@gnu.org>

	Encode all Mailutils attributes in maildir file names.

	The attributes that have no corresponding info letters are
	encoded in the 'a' name attribute as a string of mailutils
	status flags, e.g.:

	 1284628225.M17468P3883Q0.localhost,a=FO,u=1:2,S

	Meaning: MU_ATTRIBUTE_READ (from the info letter 'S'),
	MU_ATTRIBUTE_FLAGGED (attr. 'F') and MU_ATTRIBUTE_SEEN (attr.
	'O'). 
	* libproto/maildir/mbox.c (maildir_message_alloc): Parse the
	'a' attribute.
	(maildir_subdir_scan): Don't force MU_ATTRIBUTE_SEEN on
	existing messages.
	(maildir_message_fixup): Fixup the (original) MU_ATTRIBUTE_SEEN
	attribute.
	* libproto/maildir/tests/attfixup.at: Update.
	* libproto/maildir/tests/attr.at: Update.

2020-11-15  Sergey Poznyakoff  <gray@gnu.org>

	Rename mu_string_to_flags to mu_attribute_string_to_flags.

	* include/mailutils/attribute.h (mu_attribute_string_to_flags):
	New proto.
	(mu_string_to_flags): Mark as deprecated.
	(mu_attribute_flags_to_string): New proto. 
	* libmailutils/mailbox/attribute.c (mu_string_to_flags): Rename
	to mu_attribute_string_to_flags.
	(mu_attribute_flags_to_string): New function.
	* libmailutils/base/amd.c: Use mu_attribute_string_to_flags
	instead of mu_string_to_flags.
	* libmailutils/mailbox/msgscan.c: Likewise. *
	libproto/dotmail/message.c: Likewise.
	* libproto/pop/mbox.c: Likewise.

2020-11-15  Sergey Poznyakoff  <gray@gnu.org>

	Add maildir format detection test.

	* libproto/maildir/tests/Makefile.am: Add autodetect.at.
	* libproto/maildir/tests/testsuite.at: Include autodetect.at.
	* libproto/maildir/tests/autodetect.at: New file.
	* testsuite/mbop.c: Fix exit code for --detect.

2020-11-15  Sergey Poznyakoff  <gray@gnu.org>

	Convert dotmail testsuite to mbop.

	* libproto/dotmail/tests/.gitignore: Update.
	* libproto/dotmail/tests/Makefile.am: Remove dm_detect, dm_mesg
	and dm_qget, build mbop instead.
	* testsuite/mbop.c: Implement the detect mode.
	* libproto/dotmail/tests/dm_detect.c: Remove.
	* libproto/dotmail/tests/dm_mesg.c: Remove.
	* libproto/dotmail/tests/dm_qget.c: Remove.
	* libproto/dotmail/tests/append.at: Use mbop.
	* libproto/dotmail/tests/autodetect.at: Use mbop.
	* libproto/dotmail/tests/count.at: Use mbop.
	* libproto/dotmail/tests/delete.at: Use mbop.
	* libproto/dotmail/tests/qget.at: Use mbop.
	* libproto/dotmail/tests/recent.at: Use mbop.
	* libproto/dotmail/tests/testsuite.at: Use mbop.
	* libproto/dotmail/tests/uidvalidity.at: Use mbop.
	* libproto/dotmail/tests/unseen.at: Use mbop.

2020-11-15  Sergey Poznyakoff  <gray@gnu.org>

	Implement the MU_ATTRIBUTE_FORWARDED attribute flag.

	* include/mailutils/attribute.h (MU_ATTRIBUTE_FORWARDED): New
	constant. (mu_attribute_is_forwarded,
	mu_attribute_set_forwarded)
	(mu_attribute_unset_forwarded): New prototypes.
	(MU_STATUS_BUF_SIZE): Update definition.
	* libmailutils/mailbox/attribute.c (mu_attribute_is_forwarded)
	(mu_attribute_set_forwarded)
	(mu_attribute_unset_forwarded): New functions.
	* libproto/maildir/mbox.c (info_map): Implement the 'P' flag.

2020-11-15  Sergey Poznyakoff  <gray@gnu.org>

	AMD API: provide function for resetting the uidvalidity value.

	* include/mailutils/sys/amd.h (amd_reset_uidvalidity): New
	proto.
	* libmailutils/base/amd.c (amd_reset_uidvalidity): New
	function.
	* libproto/maildir/mbox.c (maildir_scan_unlocked): Use
	amd_reset_uidvalidity.

2020-11-15  Sergey Poznyakoff  <gray@gnu.org>

	Improve mbop interface.

	* testsuite/mbop.c: Use mu_cli_simple for option handling. Use
	the -m option to pass the mailbox file name (or URL). Mark qget
	as not requiring message selection.

2020-11-15  Sergey Poznyakoff  <gray@gnu.org>

	More maildir tests.

	* .gitignore: Update.
	* include/mailutils/sys/amd.h (MU_AMD_IMAPBASE): Remove.
	* libmailutils/base/amd.c (amd_scan_message): Remove obsolete
	code.
	* libproto/maildir/mbox.c (maildir_message_cmp): Bugfixes.
	* testsuite/Makefile.am: Add mbop.c to distribution.
	* testsuite/mbop.c: Implement qget.
	* testsuite/mbox2dir.c (maildir_generate_name): Fix typo.
	(main): Skip From_ line before copying. 
	* libmailutils/tests/Makefile.am (wsp_SOURCES): Remove.
	* libproto/maildir/tests/Makefile.am: Add new tests.
	* libproto/maildir/tests/append.at: New file.
	* libproto/maildir/tests/attr.at: New file.
	* libproto/maildir/tests/body.at: New file.
	* libproto/maildir/tests/count.at: Update.
	* libproto/maildir/tests/delete.at: New file.
	* libproto/maildir/tests/envelope.at: New file.
	* libproto/maildir/tests/header.at: New file.
	* libproto/maildir/tests/qget.at: New file.
	* libproto/maildir/tests/testsuite.at: Include new tests.
	* libproto/maildir/tests/uid.at: New file.
	* libproto/maildir/tests/uidvalidity.at: New file.

2020-11-14  Sergey Poznyakoff  <gray@gnu.org>

	Maildir testsuite core.

	* libmailutils/tests/tesh.c (mu_tesh_read_and_eval): Print
	fixed prompt if attached to a terminal.
	* libproto/maildir/Makefile.am (SUBDIRS): Add tests.
	* libproto/maildir/mbox.c (flags_to_info): Be sure to format
	each flag only once.
	(maildir_scan_unlocked): Save updated properties. 
	* testsuite/.gitignore: Add mbox2dir.
	* testsuite/Makefile.am: Build mbox2dir.
	* testsuite/mbop.c: New file.
	* testsuite/mbox2dir.c: New file. 
	* libproto/maildir/tests/.gitignore: New file.
	* libproto/maildir/tests/Makefile.am: New file.
	* libproto/maildir/tests/atlocal.in: New file.
	* libproto/maildir/tests/attfixup.at: New file.
	* libproto/maildir/tests/count.at: New file.
	* libproto/maildir/tests/testsuite.at: New file.
	* libproto/maildir/tests/uidfixup.at: New file.

2020-11-12  Sergey Poznyakoff  <gray@gnu.org>

	Full rewrite of maildir support.

	This rewrite aims to speed up maildir manipulations and to fix
	the problem with storing the uids and uidvalidity attributes.

	Uidvalidity value is stored in the .mu-prop file, as it was
	done previously. UID of each message is encoded in its file
	name between the unique prefix and the info part. Overall
	structure of the message file name is:

	 uniq [ ',' attrs ] ':2,' info

	where uniq is the unique prefix, info is the attribute flags,
	and attrs is a comma-delimited list of attribute=value pairs.
	The 'u' attribute holds the UID. Unrecognized attributes are
	ignored.

	To speed up the access and avoid unnecessary memory
	allocations, maildir access is reimplemented using the *at()
	function calls (openat instead of open, etc). 
	* libproto/maildir/folder.c: Rewrite.
	* libproto/maildir/maildir.h: Rewrite.
	* libproto/maildir/mbox.c: Rewrite.

2020-11-12  Sergey Poznyakoff  <gray@gnu.org>

	dotmail: reset uidvalidity if UIDs are reinitialized.

	* libproto/dotmail/dotmail.c (dotmail_rescan_unlocked): Reset
	uidvalidity if the UIDs are to be reinitialized.

2020-11-12  Sergey Poznyakoff  <gray@gnu.org>

	Don't assume any special meaning of the X-Imapbase header in
	the library.

	This starts a series of commits whose purpose is to clean up
	the mess with the uid and uidvalidity attributes.

	The way these attributes are stored depends on the mailbox
	type. The libmailutils library contained some historical
	left-overs that assumed that the X-Imapbase header of the first
	message in the mailbox contained the value of the uidvalidity
	and next uid. These left-overs are removed.

	* include/mailutils/message.h (mu_message_scan): Remove
	uidvalidity.
	* libmailutils/mailbox/msgscan.c: Remove special handling for
	the X-Imapbase header.
	* libmailutils/base/amd.c (_amd_message_save)
	(amd_scan_message): Remove special handling for X-Imapbase.

2020-11-10  Sergey Poznyakoff  <gray@gnu.org>

	Fix Savane bug #56428.

	* NEWS: Update.
	* configure.ac: Version 3.10.90 
	* include/mailutils/cstr.h (mu_version_string_parse)
	(mu_version_string_cmp): New protos.
	* libmailutils/string/Makefile.am (libstring_la_SOURCES): Add
	version.c.
	* libmailutils/string/version.c: New file. 
	* include/mailutils/sys/amd.h (_amd_message): Remove the
	orig_flags member. All uses changed.
	(MU_AMD_PROP): New capability.
	* include/mailutils/url.h (MU_AUTODETECT_ACCURACY_MAX): New
	constant.
	* libmailutils/base/amd.c (_amd_prop_create): Raise MU_AMD_PROP
	if the prop file exists.
	* libmailutils/base/schemeauto.c: New values for the
	MU_AUTODETECT_ACCURACY environment variable: default, fast, and
	max.
	* libmailutils/property/mhprop.c (_mh_prop_fill): Fix
	diagnostic message.
	* libproto/maildir/mbox.c: Fix incorrect letter to attribute
	mapping.
	* libproto/mh/mbox.c: Remove uses of orig_flags. 
	* libmailutils/base/registrar.c (mu_registrar_lookup_url): Fall
	back to the default registrar if the url doesn't contain
	explicit scheme, the file it references does not exist, and the
	default record is a local one.

2020-11-09  Sergey Poznyakoff  <gray@gnu.org>

	Fix mapping of the \Seen IMAP attribute.

	* include/mailutils/attribute.h: Document message attributes.
	* libmailutils/imapio/flags.c (_imap4_attrlist): \Seen
	corresponds to MU_ATTRIBUTE_READ.

2020-10-01  Sergey Poznyakoff  <gray@gnu.org>

	Improve message comparison routine for maildir.

	* libproto/maildir/mbox.c (maildir_message_cmp): Compare
	seconds, microseconds and number of deliveries, in that order.
	If all match (shouldn't happen), resort to lexicographical
	comparison.

2020-10-01  Sergey Poznyakoff  <gray@gnu.org>

	Rewrite amd_msg_bsearch without recursion.

2020-10-01  Sergey Poznyakoff  <gray@gnu.org>

	Bugfix.

	* libmailutils/base/amd.c (amd_msg_lookup): Always store the
	index of the memory slot, as described in the comment. This was
	broken in 1274d937 in a fit of overcorrectness.

2020-09-28  Sergey Poznyakoff  <gray@gnu.org>

	Fix last resort return for message_envelope_sender.

	* libmailutils/mailbox/msgenv.c (message_envelope_sender): Fix
	conditional. Use mu_get_user_email instead of tinkering with
	mu_auth_data.
	* sieve/tests/moderator.at: Fix expected output.

2020-09-13  Sergey Poznyakoff  <gray@gnu.org>

	Fix uninitialized variable in readmsg.

	* readmsg/readmsg.c (main): Initialize weedc.

2020-09-07  Sergey Poznyakoff  <gray@gnu.org>

	Include libtests/mbdel.at to the dist.

2020-09-06  Sergey Poznyakoff  <gray@gnu.org>

	Honor idle timeout settings in inetd mode.

	* imap4d/imap4d.c (main): For inetd mode, initialize
	idle_timeout from the server settings.
	* pop3d/pop3d.c: Likewise.

2020-09-05  Sergey Poznyakoff  <gray@gnu.org>

	Fix parsing of IMAP ranges with the lower value less than the
	actual message set minimum.

	* libmailutils/msgset/parse.c (get_msgnum): Make sure the
	returned is in the [minval,maxval] interval.

2020-08-19  Sergey Poznyakoff  <gray@gnu.org>

	libmailutils/tests: Use MU_CHECK for simple tests.

	* testsuite/testsuite.inc (MU_CHECK): Remove superfluous
	quoting.
	* libmailutils/tests/modmesg.at: New file.
	* libmailutils/tests/streams.at: New file.
	* libmailutils/tests/strin.at: Minor change. 
	* libmailutils/tests/modmesg02.at: Remove.
	* libmailutils/tests/streamshift.at: Remove.
	* libmailutils/tests/strtoc.at: Remove.
	* libmailutils/tests/t0-stream.at: Remove.
	* libmailutils/tests/t1-stream.at: Remove.
	* libmailutils/tests/getdelim.at: Remove.
	* libmailutils/tests/modmesg00.at: Remove.
	* libmailutils/tests/modmesg01.at: Remove.
	* libmailutils/tests/modmesg03.at: Remove. 
	* libmailutils/tests/testsuite.at: Update.
	* libmailutils/tests/Makefile.am: Update.

2020-08-18  Sergey Poznyakoff  <gray@gnu.org>

	libmailutils/tests tools: use mu_cli_simple for option
	handling.

2020-08-17  Sergey Poznyakoff  <gray@gnu.org>

	Bugfix (complements fd9a86d37b)

	* mda/lib/mailquota.c (sql_retrieve_quota): Fix a leftover use
	of get_size.

2020-08-14  Sergey Poznyakoff  <gray@gnu.org>

	Version 3.10.

	* NEWS: Update.
	* configure.ac: Raise version number and VI_CURRENT.

2020-08-14  Sergey Poznyakoff  <gray@gnu.org>

	Reorganize testsuite.

	The testsuite directory contains only data and programs that
	are used by other tests in the mailutils hierarchy. As such, it
	is moved to the top of the SUBDIRS list, so that the utilities
	on which another tests depend are tested first.

	The tests that depend on both libmailutils and libraries from
	libproto are moved to a separate directory libtests. These
	tests are run after tests in testsuite, libmailutils and
	libproto.

	* Makefile.am (SUBDIR): Move the testsuite directory before
	libmailutils.
	* configure.ac (libtests): New test directory.
	* libtests/.gitignore: New file.
	* libtests/Makefile.am: New file.
	* libtests/atlocal.in: New file.
	* testsuite/fldel.at: Move to libtests/
	* testsuite/fldel.c: Likewise.
	* testsuite/lstuid.c: Likewise.
	* testsuite/lstuid00.at: Likewise.
	* testsuite/lstuid01.at: Likewise.
	* testsuite/lstuid02.at: Likewise.
	* testsuite/mbdel.at: Likewise.
	* testsuite/mbdel.c: Likewise.
	* testsuite/mime.at: Likewise.
	* testsuite/mime01.at: Likewise.
	* testsuite/mimetest.c: Likewise.
	* libtests/testsuite.at: New file.
	* testsuite/Makefile.am: Remove all files that depend on
	mailutils components.
	* testsuite/testsuite.at: Likewise.
	* testsuite/bs.c: Remove.
	* testsuite/msgset.c: Remove.

2020-08-14  Sergey Poznyakoff  <gray@gnu.org>

	Fix race condition in mockmta.

	* testsuite/mockmta.c (mta_open): Call to listen before
	printing the port number. This ensures that the client will
	find port listening to its requests.

2020-08-14  Sergey Poznyakoff  <gray@gnu.org>

	Bugfixes.

	* libmailutils/stream/mapfile_stream.c (_mapfile_open): For
	MU_STREAM_WRITE set open flags to O_RDWR. This is required for
	the remapping code to work. Without it mmap with MAP_SHARED
	falls with EACCESS.
	* libmailutils/stream/stream.c (mu_stream_close): Improve error
	checking.

2020-08-11  Sergey Poznyakoff  <gray@gnu.org>

	decodemail: use append mode to reduce memory requirements.

	* decodemail/decodemail.c (main): Open output mailbox in append
	mode. If truncate is requested, open it rw for truncating, then
	close and reopen for appending. This speeds up operation
	considerably.
	* libproto/mbox/mbox.c (mbox_open): Change rules for selecting
	mmap vs file open.
	(mbox_close): Destroy the stream.
	(append_message_to_stream): Minor fix.
	(mbox_append_message): Unlock the stream on failure as well as
	on success.

2020-08-11  Sergey Poznyakoff  <gray@gnu.org>

	Allow the caller to unref messages obtained from the mailbox.

	* include/mailutils/sys/message.h (struct _mu_message): New
	member: _detach.
	* libmailutils/mailbox/msgref.c (_mu_message_free): Detach
	message from the owning object.
	* libmailutils/base/amd.c (_amd_attach_message): Provide the
	_detach method.
	* libproto/dotmail/message.c (mu_dotmail_message_get):
	Initialize the _detach member.
	* libproto/imap/mbox.c (_imap_mbx_get_message): Likewise.
	* libproto/mbox/mbox.c (new_message): Likewise.
	* libproto/pop/mbox.c (pop_create_message): Likewise. 
	* libmailutils/stream/temp_stream.c (temp_stream_write):
	Tempfile stream is created fully buffered. Free the buffer
	before reinitializing. 
	* lib/mdecode.c (message_body_stream): Change error message for
	MU_ERR_NOENT.
	* decodemail/decodemail.c (main): Unref the original message to
	decrease memory usage.

2020-08-10  Sergey Poznyakoff  <gray@gnu.org>

	Use mu_temp_stream_create instead of mu_temp_file_stream_create
	everywhere.

2020-08-10  Sergey Poznyakoff  <gray@gnu.org>

	Fix compilation without TLS.

	* testsuite/mockmta.c: Fix preprocessor conditionals regarding
	TLS.

2020-08-09  Sergey Poznyakoff  <gray@gnu.org>

	Implement temporary streams.

	A temporary stream functions as a memory stream until its size
	reaches a preconfigured threshold value. Once it is reached,
	the stream storage is automatically converted to a temporary
	file, and all data written so far are transferred to the new
	storage. If the temporary file cannot be created, the stream
	continues to operate in memory-based mode.

	This stream type is intended to decrease the number of used
	file descriptors.

	* include/mailutils/sys/Makefile.am: Add temp_stream.h
	* include/mailutils/sys/temp_stream.h: New file.
	* include/mailutils/stream.h (mu_temp_file_threshold_size): New
	extern.
	(mu_temp_stream_create): New proto.
	* libmailutils/stream/Makefile.am: Add temp_stream.c.
	* libmailutils/stream/temp_stream.c: New file.
	* libmailutils/string/Makefile.am: Add strtosize.c 
	* libmailutils/tests/.gitignore: Update.
	* libmailutils/tests/Makefile.am
	* libmailutils/tests/strtoc.c: Add tests for mu_c_hsize.
	* libmailutils/tests/temp_stream.c: New test program.
	* libmailutils/tests/testsuite.at: Test the temp_stream
	functionality.
	* testsuite/testsuite.inc (MU_CHECK): New macro. 
	* libmailutils/mailbox/body.c (body_get_transport): Use
	mu_temp_stream_create.

2020-08-08  Sergey Poznyakoff  <gray@gnu.org>

	New function: mu_strtosize.

	* include/mailutils/cstr.h (mu_strtosize): New proto.
	* libmailutils/string/strtosize.c: New file.
	* libmailutils/string/Makefile.am: Add strtosize.c
	* libmailutils/string/str_to_c.c: Implement conversions for
	mu_c_hsize.
	* include/mailutils/util.h (mu_c_hsize): New mu_c_type,
	* libmailutils/tests/strtoc.c: Add tests for mu_c_hsize. 
	* libmu_auth/ldap.c: Use mu_strtosize to parse quota.
	* mda/lib/mailquota.c: Likewise.

2020-08-08  Sergey Poznyakoff  <gray@gnu.org>

	Bugfix in MIME parser.

	* libmailutils/mime/mime.c: Rewrite boundary matcher as a
	separate function.

2020-08-08  Sergey Poznyakoff  <gray@gnu.org>

	Fix referencing uninitialized value.

	* decodemail/decodemail.c (message_decode_mime): Don't
	dereference newmsg prior to creating it.

2020-08-07  Sergey Poznyakoff  <gray@gnu.org>

	stream API: remove the readdelim method.

	The method is superfluous as the API itself provides the
	necessary functionality. Besides, it interacted poorly with
	positioning in buffered streams.

	* include/mailutils/sys/stream.h (struct _mu_stream): Remove
	the readdelim method.
	* libmailutils/stream/stream.c (mu_stream_readdelim)
	(mu_stream_getdelim): Remove uses of the readdelim method. 
	* libmailutils/tests/.gitignore: Update.
	* libmailutils/tests/Makefile.am: Add new test.
	* libmailutils/tests/testsuite.at: Likewise.
	* libmailutils/tests/getdelim.at: New test.
	* libmailutils/tests/stream-getdelim.c: New test program. 
	* libmailutils/base/amd.c: Remove readdelim implementation.
	* libmailutils/mailbox/msgstream.c: Likewise.
	* libmailutils/stream/iostream.c: Likewise.
	* libmailutils/stream/streamref.c: Likewise.
	* libmailutils/stream/xscript-stream.c: Likewise.
	* libproto/pop/pop3_stream.c: Likewise. 
	* mail/decode.c (mime_descend): Handle errors from
	mu_message_unencapsulate graciously. On failure, treat
	message/rfc822 as text/plain.

2020-08-07  Sergey Poznyakoff  <gray@gnu.org>

	decodemail: if run out of fds report the number of fds needed.

	* decodemail/decodemail.c: Special handling for EMFILE.

2020-08-07  Sergey Poznyakoff  <gray@gnu.org>

	Bugfixes.

	* libmailutils/stream/temp_file_stream.c
	(mu_temp_file_stream_create): Fix return value.
	* decodemail/decodemail.c (message_decode): Split to two
	subfunctions to improve error recovery.
	* include/mailutils/sys/body.h: Fix typo.

2020-08-06  Sergey Poznyakoff  <gray@gnu.org>

	decodemail: make sure each message has the final newline on its
	own.

	* include/mailutils/stream.h (mu_stream_copy_wcb)
	(mu_stream_copy_nl): New protos.
	* libmailutils/stream/streamcpy.c (mu_stream_copy_wcb)
	(mu_stream_copy_nl): New functions.
	* libproto/mbox/mbox.c (append_message_to_stream): Use
	mu_stream_copy_nl.
	* decodemail/decodemail.c (hdr_print, body_print): Remove.
	(message_store_stdout): Use message stream instead of piping
	header and body separately. Use mu_stream_copy_nl to ensure the
	message has a final newline.

2020-08-06  Sergey Poznyakoff  <gray@gnu.org>

	Fix in scm testsuite.

	* libmu_scm/tests/message-get-envelope-date.at: Expected time
	zone is UTC (compensates for the change introduced in
	50d7ea1d1b).

2020-08-05  Sergey Poznyakoff  <gray@gnu.org>

	logstream: introduce optional prefix.

	The prefix, if set, is output at the beginning of each line,
	after the location and before the severity. It can be used to
	provide additional information about the diagnostics, such as,
	e.g. the number or UID of the message.

	The decodemail utility makes use of the new feature.

	* include/mailutils/log.h (MU_LOGMODE_PREFIX): New define.
	* include/mailutils/stream.h
	(MU_IOCTL_LOGSTREAM_SET_LOCUS_RANGE)
	(MU_IOCTL_LOGSTREAM_SET_PREFIX): New defines.
	* include/mailutils/sys/logstream.h (_mu_log_stream): New
	member: prefix.
	* libmailutils/stream/logstream.c (_log_write): Output the
	prefix.
	(_log_done): Dereference the prefix.
	(_log_ctl): Handle MU_IOCTL_LOGSTREAM_SET_LOCUS_RANGE and
	MU_IOCTL_LOGSTREAM_SET_PREFIX. 
	* libmailutils/tests/logstr.c: New test: prefix.
	* libmailutils/tests/logstr.at: Test log prefix functionality. 
	* decodemail/decodemail.c: Remove crd_error. Use logstream
	prefix to display message part locations.

2020-08-05  Sergey Poznyakoff  <gray@gnu.org>

	Add two manpages.

2020-08-05  Sergey Poznyakoff  <gray@gnu.org>

	Assorted fixes.

	* libmailutils/mailbox/body.c (mu_body_size): Don't unref the
	transport stream. This fixes a bug introduced in 45d54031f4.
	* decodemail/decodemail.c (message_decode): Additional
	error-checking.
	* libmailutils/cfg/parser.y (split_cfg_path): Free the
	mu_wordsplit object on error.
	* libmu_sieve/extensions/spamd.c (spamd_read_line): Fix the
	argument to free. 
	* doc/texinfo/programs/decodemail.texi: Remove a techically
	incorrect passage.
	* examples/sa.c: Initialize the urlstr variable.
	* libmailutils/base/amd.c (amd_msg_lookup): Store the value in
	*pret only if returning success.
	(amd_body_stream_seek): Check the return value from
	amd_body_size.
	* libmailutils/base/permstr.c (mu_readlink): Fix the
	uninitialized variable.
	* libmailutils/base/symlink.c (mu_readlink) Store the value in
	*plen only on success.

2020-08-03  Sergey Poznyakoff  <gray@gnu.org>

	Housekeeping.

2020-08-02  Sergey Poznyakoff  <gray@gnu.org>

	Provide fallback methods for restoring the envelope date.

	* libmailutils/mailbox/msgenv.c (message_envelope_date): Try
	Received, X-Envelope-Date, and Date headers, in that order.
	* libmailutils/datetime/scantime.c (mu_scan_datetime): Timezone
	defaults to UTC.

2020-08-01  Sergey Poznyakoff  <gray@gnu.org>

	New function to reconstruct message envelope from the headers.

	* include/mailutils/sys/message_stream.h (_mu_message_stream):
	Reorganize structure.
	* libmailutils/base/amd.c: Use mu_message_reconstruct_envelope
	instead of the amd-specific envelope functions.
	* libmailutils/stream/message_stream.c: Likewise.
	* libmailutils/tests/readmesg.at: New test case.
	* libmailutils/tests/readmesg.c: New test program.
	* libmailutils/tests/Makefile.am: Add new tests.
	* libmailutils/tests/testsuite.at: Likewise.
	* mh/tests/mhl.at: Update expected output.
	* mh/tests/mhn.at: Likewise.
	* testsuite/mh/mbox1/: Fix timestamps in X-Envelope-Date
	* testsuite/mh/teaparty/: Likewise.

2020-08-01  Sergey Poznyakoff  <gray@gnu.org>

	New function for reconstructing the message envelope from its
	headers.

	* libmailutils/address/parse822.c (mu_parse822_route_addr):
	Accept <local-part-only> if the default domain is set. 
	* include/mailutils/message.h
	(mu_message_reconstruct_envelope): New prototype.
	* libmailutils/mailbox/msgenv.c (message_envelope_sender): Try
	each candidate header in turn until a valid email is extracted
	or run out of headers. In the latter case, use the current user
	login name as the email.
	(mu_message_reconstruct_envelope): New function. 
	* libmailutils/tests/Makefile.am: Add new test.
	* libmailutils/tests/testsuite.at: Likewise.
	* libmailutils/tests/recenv.c: Test program for the
	mu_message_reconstruct_envelope function
	* libmailutils/tests/recenv.at: New test.

2020-08-01  Sergey Poznyakoff  <gray@gnu.org>

	MIME-related fices in decodemail.

	* decodemail/decodemail.c (message_decode): Initialize ismime
	to 0.
	* libmailutils/mime/mimehdr.c (parse_param): Silently ignore
	duplicated parameters.

2020-07-31  Sergey Poznyakoff  <gray@gnu.org>

	decodemail: Fix storing the envelope.

	Copying the envelope was broken in f111a7ad. This fixes it and
	improves the diagnostics in message_store_mbox.

	* decodemail/decodemail.c (message_store_mbox)
	(message_store_stdout): Take mu_coord_t as 3rd argument.
	Improve diagnostics.
	(message_store_mbox): Don't exit on address family errors.
	(message_decode): Decrement dim.

2020-07-30  Sergey Poznyakoff  <gray@gnu.org>

	Bugfixes.

	* libmailutils/base/ctparse.c (content_type_parse): Initialize
	rc.
	* decodemail/decodemail.c (message_decode): Use the
	MU_CONTENT_TYPE_PARAM flag.
	* lib/mdecode.c: Likewise.

2020-07-29  Sergey Poznyakoff  <gray@gnu.org>

	Bugfix.

	* mda/lib/script.c: Restore the message-id-header configuration
	statement.

2020-07-29  Sergey Poznyakoff  <gray@gnu.org>

	Relax syntax rules for parsing Content-Type headers.

	* decodemail/decodemail.c (qstring_format): Account for s==NULL
	(message_decode): Use MU_CONTENT_TYPE_RELAXED when parsing
	content types.
	* doc/texinfo/programs/decodemail.texi: Document handling of
	partial content types.
	* include/mailutils/util.h (MU_CONTENT_TYPE_STRICT)
	(MU_CONTENT_TYPE_RELAXED)
	(MU_CONTENT_TYPE_PARAM): New constants.
	(mu_content_type_parse_ext): New function.
	* lib/mdecode.c (text_mime_cmp): Implement comparison of
	partial content types (missing subtype).
	(message_body_stream): Use MU_CONTENT_TYPE_RELAXED.
	* libmailutils/base/ctparse.c (content_type_parse): Take
	additional argument (flags). Modify parsing algorithm depending
	on its value.
	(mu_content_type_parse_ext): New function.
	(mu_content_type_parse): Rewrite as a wrapper over
	mu_content_type_parse_ext.
	(mu_content_type_destroy): Account for subtype==NULL.

2020-07-27  Sergey Poznyakoff  <gray@gnu.org>

	decodemail: quote personal part of an address header only if
	necessary.

	* decodemail/decodemail.c (is_address_header): Add "From:".
	(qstring_format): Format as a quoted string only if really
	necessary.
	(message_decode): Fix improper use of address_decode.

2020-07-27  Sergey Poznyakoff  <gray@gnu.org>

	Bugfix.

	* imap4d/namespace.c (prefix_translate_name): The name "INBOX"
	is special only without prefix.

2020-07-25  Sergey Poznyakoff  <gray@gnu.org>

	decodemail: double-quote decoded personal parts of email
	addresses.

	* decodemail/decodemail.c: Take care to double-quote decoded
	personal parts of email addresses.
	* libmailutils/address/parse822.c (mu_parse822_quoted_string):
	Don't skip 8-bit characters.

2020-07-25  Sergey Poznyakoff  <gray@gnu.org>

	Improve error tolerance when parsing MIME structured headers.

	* include/mailutils/assoc.h (mu_assoc_set_mark)
	(mu_assoc_head_set_mark, mu_assoc_tail_set_mark) (mu_assoc_pop,
	mu_assoc_shift)
	(mu_assoc_sweep_unset, mu_assoc_pull): New protos.
	* libmailutils/base/assoc.c: New functions (see above).
	* libmailutils/mime/mimehdr.c (parse_param): Mark last
	installed element for sweeping. When seeing a semicolon, unmark
	it. Return MU_ERR_PARSE on errors. On success, install the
	created parameter in the assoc array.
	(_mime_header_parse): Change type of the subset parameter.
	Attempt error recovery on parse errors. If it succeeds, sweep
	out the last installed parameter. If subset is specified, use
	mu_assoc_pull to populate it from the created assoc.
	(mu_mime_header_parse_subset)
	(mu_mime_param_assoc_create): Update invocations of
	_mime_header_parse.
	* libmailutils/tests/mimehdr.at: Test error tolerance.
	* libmailutils/tests/mimehdr.c: Use mu_cli_simple to parse
	command line. Treat positional arguments as names of the
	parameters to retain on output.

2020-07-24  Sergey Poznyakoff  <gray@gnu.org>

	decodemail: print error location (message.part) with
	diagnostics.

	* decodemail/decodemail.c (message_decode): Take three
	arguments: the message(part), its location as a pointer to
	mu_coord_t object and dimension, meaning number of slots used
	in the latter. Use crd_error for diagnostics.
	(crd_error): New function. Display error message prefixed with
	the location of the message part it belongs to.
	* libmailutils/base/coord.c (mu_coord_realloc): Update the
	stored dimension.

2020-07-23  Sergey Poznyakoff  <gray@gnu.org>

	* decodemail/decodemail.c (message_decode): Don't stop on copy
	errors.  Instead, issue an error message and mark the part in
	the output message where copying failed with an explicit error
	statement.

2020-07-23  Sergey Poznyakoff  <gray@gnu.org>

	Minor fixes in base64 and inline-comment filters.

	* libmailutils/diag/errors (MU_ERR_BASE64): New error code.
	* libmailutils/filter/base64.c (_base64_decoder): Stop decoding
	and return failure if padding length gets greater than 3
	* libmailutils/filter/inline-comment.c (_ilcmt_decoder): Make
	sure proper error code is set.

2020-07-23  Sergey Poznyakoff  <gray@gnu.org>

	decodemail: better error tolerance.

	* decodemail/decodemail.c (message_decode): Don't bail out if
	unable to get the Content-Type header or copy the message
	envelope.

2020-07-23  Sergey Poznyakoff  <gray@gnu.org>

	Relax sytnax requirements for MIME structured headers.

	* libmailutils/base/ctparse.c (content_type_parse): Rewrite the
	value splitting on type and subtype. Allow for optional
	whitespace at both sides of "/". Both type and subtype can
	contain arbitrary characters (except for "/"). This is not
	right according to RFC 2045, but reportedly such cases exist in
	old mails.
	* libmailutils/mailbox/bodystruct.c (bodystructure_fill): Fix
	parsing of the Content-Type header. Fix storing the pointer to
	an automatic variable in assoc object. Unfold the
	Content-Disposition value.
	* libmailutils/mime/mimehdr.c (_mime_header_parse): Return in
	pvalue entire prefix part up to the first semicolon, with
	leading and trailing whitespace removed. Allow for both output
	parameters to be NULL.
	* libmailutils/tests/content-type.at: Add new test case.
	* libmailutils/tests/conttype.c: ignore empty lines in input.
	* libmailutils/tests/mimehdr.at: Change mimehdr16 and mimehdr17
	tests: this syntax is accepted by the relaxed rules of the
	modified parser.

2020-07-23  Sergey Poznyakoff  <gray@gnu.org>

	Fixes in MIME structured header parser.

	* libmailutils/mime/mimehdr.c (parse_param): Allow for
	whitespace surrounding =.
	* libmailutils/tests/mimehdr.at: More tests

2020-07-23  Sergey Poznyakoff  <gray@gnu.org>

	Add missing file.

	* libmailutils/tests/listsort.c: New file.

2020-07-22  Sergey Poznyakoff  <gray@gnu.org>

	Fix list sort.

	* include/mailutils/sys/list.h (_mu_list_null)
	(_mu_list_init): New functions.
	* libmailutils/list/sort.c (_list_qsort): Fix pivot selection
	and list merging.
	* libmailutils/tests/.gitignore: Add listsort.
	* libmailutils/tests/Makefile.am: Likewise.
	* libmailutils/tests/list.at: Check sorting large lists.

2020-07-22  Sergey Poznyakoff  <gray@gnu.org>

	Stricter parsing of structured MIME headers.

	The mu_content_type_parse function allowed for missing
	/subtype, which caused grief in case of blatantly invalid
	inputs.

	* decodemail/decodemail.c (message_decode): Handle
	mu_content_type_parse failures racefully: return a reference to
	the input message. Improve diagnostics.
	* lib/mdecode.c (message_body_stream): Improve diagnostics.
	* libmailutils/base/assoc.c (merge_sort): Bugfix: accept empty
	input list.
	* libmailutils/base/ctparse.c (content_type_parse): Require
	that both type and subtype be present.
	* libmailutils/mime/mimehdr.c (_mime_header_parse): Move
	parameter parsing to a separate function. Do better syntax
	checking. 
	* libmailutils/tests/Makefile.am: Add new tests.
	* libmailutils/tests/testsuite.at: Likewise.
	* libmailutils/tests/content-type.at: New tests.
	* libmailutils/tests/conttype.c: Return 1 if at least one parse
	fails.
	* libmailutils/tests/mimehdr.at: Add tests for invalid inputs.
	* libmailutils/tests/mimehdr.c: Better diagnostics.

2020-07-21  Sergey Poznyakoff  <gray@gnu.org>

	decodemail: always copy the envelope.

	* decodemail/decodemail.c (message_decode): When processing the
	top-level message, always copy the original envelope to it.

2020-07-20  Sergey Poznyakoff  <gray@gnu.org>

	New simplified interface to command line option parser.

	* include/mailutils/cli.h (MU_CLI_OPTION_): New constants.
	(mu_cli_simple): New proto.
	* libmailutils/cli/simple.c: New file.
	* libmailutils/cli/Makefile.am: Add new source.
	* libmailutils/cli/cli.c (mu_cli_ext): Take into account
	po_special_flags in hints. Honor MU_PARSEOPT_HELP_HOOK and
	MU_PARSEOPT_EXIT_ERROR set in hints.
	* libmailutils/opt/opt.c (parseopt_init): Fix improper use of
	MU_PARSEOPT_PACKAGE_URL instead of MU_PARSEOPT_DATA.

2020-07-20  Sergey Poznyakoff  <gray@gnu.org>

	Fix memory leak in property code.

	The property API contains a serious flaw that leads to memory
	leaks. The property initialization function (set by
	mu_property_set_init or similiar functions) is supposed to
	initialize the supported methods in mu_property_t, in
	particular _prop_done, which is responsible for releasing the
	resources allocated for the initdata object upon invocation of
	mu_property_destroy.

	However, the initialization function gets called only upon a
	read/write manipulation on the property. This means that unless
	at least one such operation is performed the _prop_done method
	will not be initialized and the resources (if any) allocated
	for the initial data object will never be released. This is
	true, in particular for the MH properties and assoc properties
	with I/O stream.

	Until the API is revamped, the following solution is
	implemented. The function mu_property_create_init calls the
	mu_property_init function if called with a non-NULL third
	argument (initdata). This ensures that it will be properly
	freed upon destroying the object.

	The use of low-level functions mu_property_set_init and
	mu_property_set_init_data requires the caller to call
	mu_property_init explicitly, if needed.

	* include/mailutils/property.h (mu_property_init): New proto.
	* libmailutils/property/create.c (_mu_property_init): Rename to
	mu_property_init.
	(mu_property_create_init): Call mu_property_init if initdata is
	not NULL.
	* libmailutils/property/propinv.c: Update call to
	mu_property_init.

2020-07-20  Sergey Poznyakoff  <gray@gnu.org>

	Provide tests for auxiliary test utilities.

	* configure.ac: Initialize testsuite in libproto/mbox
	* libproto/mbox/Makefile.am (SUBDIRS): Declare.
	* libproto/mbox/tests/Makefile.am: New file.
	* libproto/mbox/tests/atlocal.in: New file.
	* libproto/mbox/tests/testsuite.at: New file.
	* testsuite/ufms.at: Rename to libproto/mbox/tests/ufms.at
	* testsuite/ufms.c: Rename to libproto/mbox/tests/ufms.c
	* testsuite/.gitignore: Update.
	* testsuite/mockmail.at: New file.
	* testsuite/mockmail.c (main): Fix the state machine.
	* testsuite/mockmta.at: New file.
	* testsuite/mockmta.c: Fix typo in the comment.
	* testsuite/testsuite.at: Add new tests
	* testsuite/Makefile.am: Add new tests

2020-07-19  Sergey Poznyakoff  <gray@gnu.org>

	Minor changes.

	* testsuite/Makefile.am (cwdrepl_LDADD): Remove mailutils
	dependencies
	* testsuite/cwdrepl.c: Replace with a mu-independent version
	from wydawca. (http://git.gnu.org.ua/cgit/wydawca.git)
	* testsuite/mockmail.c: Fix indentation
	* mh/tests/comp.at: Remove trailing whitespace from the output.
	* mh/tests/forw.at: Likewise.
	* mh/tests/repl.at: Likewise.

2020-07-17  Sergey Poznyakoff  <gray@gnu.org>

	New test tool: mockmail.

	* testsuite/mockmail.c: New auxiliary tool.
	* testsuite/.gitignore: Add mockmail.
	* testsuite/Makefile.am: Build mockmail.
	* testsuite/mockmta.c: Change docs. 
	* mail/testsuite/mail/send.exp: Use testsuite/mockmail to
	emulate Sendmail.
	* mda/mda/tests/forward.at: Likewise.
	* mh/tests/send.at: Likewise.
	* mh/tests/testsuite.at: Likewise.
	* sieve/tests/moderator.at: Likewise.
	* sieve/tests/redirect.at: Likewise.
	* sieve/tests/reject.at: Likewise.
	* sieve/tests/testsuite.at: Likewise.
	* sieve/tests/vacation.at: Likewise.

2020-07-17  Sergey Poznyakoff  <gray@gnu.org>

	Rewrite test suite for smtp mailer.

	* libproto/mailer/smtp.c: Fix mailer initialization (bug
	introduced in a0f754eb81). Initialization based on mailer URL
	cannot be run from _mailer_smtp_init, since at that stage URL
	is not yet known. Move it to smtp_open and make sure it is run
	only once. 
	* am/tls.m4: Make TLS_LIBS a subst variable. 
	* testsuite/mockmta.c: New test tool.
	* testsuite/.gitignore: Update.
	* testsuite/Makefile.am: Update.
	* libproto/mailer/tests/.gitignore: Update.
	* libproto/mailer/tests/Makefile.am: Add new tests.
	* libproto/mailer/tests/testsuite.at: Include new tests.
	* libproto/mailer/tests/seqsend.at: New test case.
	* libproto/mailer/tests/smtp-msg.at: New test case. Moved from
	testsuite/smtp-msg.at. Uses mockmta.
	* libproto/mailer/tests/smtp-str.at: New test case. Moved from
	testsuite/smtp-str.at. Uses mockmta.
	* libproto/mailer/tests/smtpsend.c: New program. Moved from
	testsuite/smtpsend.c.

2020-07-15  Sergey Poznyakoff  <gray@gnu.org>

	Test multiple transmissions over a single SMTP mailer.

	* configure.ac: Configure testsuite in libproto/mailer/tests.
	* examples/mta.c: New option -c (continuous reception).
	(mta_smtp): Continue accepting connections if -c is given.
	* libproto/mailer/Makefile.am: Add tests.
	* libproto/mailer/tests/.gitignore: New file.
	* libproto/mailer/tests/Makefile.am: New file.
	* libproto/mailer/tests/atlocal.in: New file.
	* libproto/mailer/tests/sendm.c: New file.
	* libproto/mailer/tests/sends.c: New file.
	* libproto/mailer/tests/seqsend.at: New file.
	* libproto/mailer/tests/testsuite.at: New file.

2020-07-15  Sergey Poznyakoff  <gray@gnu.org>

	smtp mailer: fix multiple open/close on the same mailer.

	This fixes the operation of the smtp(s) mailer in the following
	context

	 while (cond)
	 {
	 mu_mailer_open (mailer, ...);
	 mu_mailer_send_message (mailer, msg, ...);
	 mu_mailer_close (mailer);
	 } 
	* include/mailutils/mailer.h (mu_mailer_get_streamref)
	(mu_mailer_set_stream): Remove.
	* include/mailutils/sys/mailer.h (struct _mu_mailer): Remove
	stream.
	* libmailutils/mailer/mailer.c (mu_mailer_create): Don't
	reference stream.
	(mu_mailer_set_stream,mu_mailer_get_streamref): Remove.
	* libproto/mailer/smtp.c (struct _smtp_mailer): New members:
	tls and auth.
	(smtp_open): Open the stream and assign it.
	(_mailer_smtp_init): Create the struct _smtp_mailer object and
	save it in the mailer.
	(smtp_close): Close and destroy the carrier.
	* libproto/mailer/smtp_carrier.c (mu_smtp_set_carrier): Accept
	NULL as the carrier argument.

2020-07-15  Sergey Poznyakoff  <gray@gnu.org>

	Fix memory leaks.

	* libmailutils/sockaddr/free.c (mu_sockaddr_free): Free the
	address itself.
	* libmailutils/stream/message_stream.c
	(mu_message_from_stream_with_envelope): Envelope must be owned
	by the message. Change mu_envelope_create accordingly.
	(_env_msg_date, _env_msg_sender): Likewise.
	* libmailutils/url/destroy.c: Free url->portstr.

2020-07-15  Sergey Poznyakoff  <gray@gnu.org>

	Update decodemail.texi.

	Improved version from Karl Berry.

2020-07-14  Sergey Poznyakoff  <gray@gnu.org>

	Document the decodemail tool.

	* THANKS: Add Karl Berry
	* doc/texinfo/programs/decodemail.texi: New file.
	* doc/texinfo/Makefile.am (programs_TEXINFOS): Add new file.
	* doc/texinfo/mailutils.texi: Document the decodemail tool.
	* doc/texinfo/programs.texi: Document the mime configuration
	statement.
	* doc/texinfo/programs/readmsg.texi: Document new options.

2020-07-09  Sergey Poznyakoff  <gray@gnu.org>

	Fix https://savannah.gnu.org/bugs/index.php?57787.

2020-07-09  Sergey Poznyakoff  <gray@gnu.org>

	Fix memory leaks.

	* libmailutils/diag/debug.c (mu_debug_log): Free buf.
	* libmailutils/mailer/progmailer.c (mu_progmailer_send): Call
	mu_stream_destroy (fix copy-paste error).
	* libmailutils/string/expvar.c (mu_str_expand): Save word[0],
	free the rest.
	* mail/mail.c (main): Free the result of mu_argcv_string.
	* mail/mail.h (compose_header_get): Return const ptr.
	* mail/mailline.c (ml_readline_internal): Free the buffer on
	EOF.
	* mail/reply.c (reply0): compose_header_get returns const
	char*.
	* mail/send.c (add_body): Don't increase stream reference count
	(follow-up to 45d54031).
	(compose_header_get): Return const char* (use
	mu_header_sget_value).
	(mail_send0): Always free buf.
	* mail/source.c (source_readline): Free buf on EOF.
	* mail/util.c (util_header_expand): Free mu_wordsplit.

2020-07-07  Sergey Poznyakoff  <gray@gnu.org>

	Bugfixes.

	* libmailutils/stream/stream.c (_stream_read_unbuffered):
	Update pnread only on success.
	* libmailutils/string/muctype.c: Mark underscore as
	MU_CTYPE_HEADR

2020-07-06  Sergey Poznyakoff  <gray@gnu.org>

	Fix assoc operation in case-insensitive mode.

	* libmailutils/base/assoc.c (_mu_assoc): New member: hash.
	(mu_assoc_create): Set proper hashing function for
	case-insensitive operation.

2020-07-06  Sergey Poznyakoff  <gray@gnu.org>

	Implement mu_stream_shift function.

	* include/mailutils/stream.h (mu_stream_shift): New proto.
	* libmailutils/stream/Makefile.am: Add new source.
	* libmailutils/stream/streamshift.c: New file.
	* libmailutils/tests/.gitignore: Update.
	* libmailutils/tests/Makefile.am: Add new tests.
	* libmailutils/tests/streamshift.at: New file.
	* libmailutils/tests/t-streamshift.c: New file.
	* libmailutils/tests/testsuite.at: Include new test.

2020-07-05  Sergey Poznyakoff  <gray@gnu.org>

	Bugfix.

	* libmailutils/imapio/getline.c (mu_imapio_getline): Don't
	unquote literals.

2020-06-30  Sergey Poznyakoff  <gray@gnu.org>

	Fix static builds with libldap.

2020-06-29  Sergey Poznyakoff  <gray@gnu.org>

	Improve default content types for message_body_stream.

2020-06-27  Sergey Poznyakoff  <gray@gnu.org>

	sieve: quoted strings may span several lines.

	As per RFC 5228, quoted strings may span several lines and are
	allowed to contain special characters. Backslash and
	double-quotes appearing within a quoted string must be escaped
	by a backslash. A backslash followed by any other character is
	silently removed.

	* libmu_sieve/sieve-lex.l (line_addz, str_unescape): Remove.
	Allow for \n in quoted strings. Escape only " and \ with
	backslash. Replace unrecognized escapes with the character
	after \.
	* sieve/examples/exn-5.4.sv: envelope should not be required.
	* sieve/tests/compile.at: Add more tests.

2020-06-27  Sergey Poznyakoff  <gray@gnu.org>

	Replace AM_LEXFLAGS in Makefile.ams with AM_LFLAGS.

2020-06-26  Sergey Poznyakoff  <gray@gnu.org>

	Minor fix in configure.

	* configure.ac (check_bdb): Add library to DBMLIBS when it is
	confirmed that the header and library versions match.

2020-06-26  Sergey Poznyakoff  <gray@gnu.org>

	Use mailutils instead of mailutils-config in AM_GNU_MAILUTILS.

	* mu-aux/mailutils.m4: Rewrite using the mailutils tool.

2020-06-26  Sergey Poznyakoff  <gray@gnu.org>

	Restore mailutils-config (partial revert of e1e7e02cf932)

	It was premature to remove that script, since some existing
	packages still rely on it.

	* mu/mailutils-config: Restore. Put installation directory
	before other PATH components, not after them.

2020-06-25  Sergey Poznyakoff  <gray@gnu.org>

	configure: make sure python-config version matches that of
	python.

2020-06-23  Sergey Poznyakoff  <gray@gnu.org>

	Specify additional content-type parameters when creating
	multipart MIME objects.

	Preserve original parameters (excepting boundary) when
	processing multipart messages by decodemail.

	* decodemail/decodemail.c (message_decode): copy parameters
	from the original Content-Type.
	* include/mailutils/mime.h (mu_mime_create_multipart): Add
	third parameter: an assoc table of additional content-type
	parameters.
	(mu_mime_content_type_param): Rename to
	mu_mime_content_type_get_param.
	(mu_mime_content_type_set_param): New proto.
	* libmailutils/mime/mime.c: See above.
	(_mime_set_content_type): Preserve all parameters.

2020-06-22  Sergey Poznyakoff  <gray@gnu.org>

	decodemain: set 7bit or 8bit transfer encoding on decoded
	parts.

	* decodemail/decodemail.c (message_decode): Set 8bit or 7bit
	transfer encoding, depending on the character of the decoded
	stream.
	* include/mailutils/cstr.h (mu_mem_8bit_count): New proto.
	* include/mailutils/stream.h (MU_STREAM_STAT_IN8BIT)
	(MU_STREAM_STAT_OUT8BIT): New constants.
	* libmailutils/stream/stream.c (_stream_read,_stream_write):
	Set MU_STREAM_STAT_IN8BIT (MU_STREAM_STAT_OUT8BIT) if requested
	* libmailutils/string/strcount.c (mu_mem_8bit_count): New
	function.

2020-06-22  Sergey Poznyakoff  <gray@gnu.org>

	Fix default text mime types.

2020-06-21  Sergey Poznyakoff  <gray@gnu.org>

	Make the list of textual mime types configurable.

	* decodemail/decodemail.c: Request the "mime" configuration
	capability.
	* lib/mdecode.c: Make the list of textual mime types
	configurable via the mime.text-type configuration statement.
	* lib/muaux.h (mu_cli_capa_mime): New extern.

2020-06-17  Sergey Poznyakoff  <gray@gnu.org>

	Improve MIME parser and mime object creation.  Preserve
	original content-type in decodemail.

	* decodemail/decodemail.c: Preserve the content subtype of each
	message.
	* include/mailutils/mime.h (MU_MIME_CONTENT_TYPE_MULTIPART)
	(MU_MIME_CONTENT_SUBTYPE_MIXED)
	(MU_MIME_CONTENT_SUBTYPE_ALTERNATIVE)
	(MU_MIME_CONTENT_SUBTYPE_DIGEST): New defines.
	(mu_mime_create_multipart): New proto.
	(mu_mime_sget_content_type,mu_mime_aget_content_type)
	(mu_mime_sget_content_subtype,mu_mime_aget_content_subtype)
	(mu_mime_content_type_param): New protos.
	* include/mailutils/sys/mime.h (content_type): Change type.
	(boundary): Const now. Points to a string in
	content_type->param.
	* libmailutils/base/ctparse.c (format_param): Fix quoting.
	Insert additonal whitespace after each semicolon.
	* libmailutils/mime/mime.c: Use mu_content_type_t to represent
	the Content-Type header.
	(mu_mime_create_multipart): New function.
	(mu_mime_create): Use mu_mime_create_multipart to create new
	mime object.
	(mu_mime_sget_content_type,mu_mime_aget_content_type)
	(mu_mime_sget_content_subtype,mu_mime_aget_content_subtype)
	(mu_mime_content_type_param): New functions.

2020-06-16  Sergey Poznyakoff  <gray@gnu.org>

	Update NEWS.

2020-06-16  Sergey Poznyakoff  <gray@gnu.org>

	Drop support for Python 2.x.

2020-06-16  Sergey Poznyakoff  <gray@gnu.org>

	decodemail: don't recode charsets unless explicitly requested.

	* decodemail/decodemail.c: New options --charset and --recode
	(main): Recode messages only if requested from the command
	line. Don't add the Content-Disposition header.
	* include/mailutils/util.h (mu_content_type_format): New proto.
	* lib/mdecode.c (charset_setup): Return immediately if charset
	is NULL.
	* libmailutils/base/ctparse.c (mu_content_type_format): New
	function.

2020-06-15  Sergey Poznyakoff  <gray@gnu.org>

	Fix long-standing memory leak in body.c.

	* include/mailutils/body.h (mu_body_ref, mu_body_unref): New
	functions.
	* include/mailutils/sys/body.h (_mu_body): New member
	ref_count.
	* libmailutils/mailbox/body.c: Keep body and body stream
	objects alive for as long as their reference counters are not
	zero. Rewrite transport stream code.
	* libmailutils/tests/modmesg.c: Use MU_ASSERT.

2020-06-15  Sergey Poznyakoff  <gray@gnu.org>

	decodemail: copy original message envelope.

2020-06-14  Sergey Poznyakoff  <gray@gnu.org>

	Add missing files.

2020-06-14  Sergey Poznyakoff  <gray@gnu.org>

	Move decodemail to a separate directory and make it
	installable.

2020-06-14  Sergey Poznyakoff  <gray@gnu.org>

	Upgrade wordsplit.

2020-06-14  Sergey Poznyakoff  <gray@gnu.org>

	New utility: decodemail.

	* examples/decodemail.c: New source.
	* examples/.gitignore: Add decodemail.
	* examples/Makefile.am: Build decodemail.
	* lib/mdecode.c: New file.
	* lib/Makefile.am: Add mdecode.c
	* lib/muaux.h (message_body_stream): New proto.
	* readmsg/msglist.c (message_body_stream): Move to a separate
	source in lib.

2020-06-14  Sergey Poznyakoff  <gray@gnu.org>

	Rewrite mime message parser.

	* include/mailutils/sys/mime.h (MIME_STATE_BEGIN_LINE)
	(MIME_PARSER_HAVE_CR): Remove constants.
	(struct _mu_mime): Remove cur_buf and buf_size.
	* libmailutils/mime/mime.c (_mime_parse_mpart_message): Use
	mu_stream_getline instead of the handcrafted dual buffering
	scheme.

2020-06-14  Sergey Poznyakoff  <gray@gnu.org>

	mail: fix message list parser.

	* mail/msgset.y: Throw range error only if message number is
	greater than the number of available messages.

2020-06-14  Sergey Poznyakoff  <gray@gnu.org>

	Fix memory leaks.

	* libmailutils/base/amd.c (amd_message_stream_close): Use
	mu_stream_destroy instead of mu_stream_close.
	* libmailutils/base/ctparse.c (content_type_parse): Free value.
	* libmailutils/base/tilde.c (mu_tilde_expansion): Free proto.
	* libmailutils/cfg/driver.c (mu_config_destroy_container): Free
	refcount.
	* libmailutils/cfg/parser.y (mu_cfg_tree_postprocess): Destroy
	iterator.
	(mu_cfg_destroy_tree): Free the tree itself.
	* libmailutils/datetime/scantime.c (pop_input): Free the popped
	element.
	* libmailutils/mailer/mailer.c (send_fragments): Destroy mime
	after converting it to message.
	* libmailutils/mime/mimehdr.c (_mime_header_parse): Free ws
	after errors.

2020-06-06  Sergey Poznyakoff  <gray@gnu.org>

	Use mu_coord_t in mail.

	* include/mailutils/message.h (mu_coord_part_string): New
	proto.
	* libmailutils/base/coord.c (mu_coord_part_string): New
	function.
	* mail/mail.h (message_set): Remove npart and msg_part.
	Introduce mu_coord_t crd instead. All uses updated.

2020-06-05  Sergey Poznyakoff  <gray@gnu.org>

	Bugfix.

	* libmailutils/base/coord.c (mu_coord_alloc): Return the
	allocated memory.

2020-06-04  Sergey Poznyakoff  <gray@gnu.org>

	Remove placeholder (mapi) and dead (nntp) code.

2020-06-04  Sergey Poznyakoff  <gray@gnu.org>

	Fix compilation without libunistring.

	* lib/unistr_c.c (unistr_is_substring_dn): Add missing function

2020-06-02  Sergey Poznyakoff  <gray@gnu.org>

	Minor fixes.

2020-06-02  Sergey Poznyakoff  <gray@gnu.org.ua>

	Bugfix.

	* libmailutils/base/coord.c (mu_coord_string): Reverse the
	partially built coordinate string.
	* mail/msgset.y (msgset_part_str): Likewise.

2020-06-02  Sergey Poznyakoff  <gray@gnu.org>

	Improve message part iterator and readmsg output.

	* include/mailutils/message.h (mu_coord_t): New data type.
	(mu_coord_alloc, mu_coord_realloc)
	(mu_coord_dup, mu_coord_string): New protos.
	(mu_coord_length): New function.
	* libmailutils/base/Makefile.am: Add coord.c
	* libmailutils/base/coord.c: New file.
	* libmailutils/mime/mimeitr.c: Key returned by
	mu_iterator_current_kv is allocated in the struct mimeitr.
	Caller may not free it.
	(struct mimeitr): New member: coord.
	(getitem): Reallocate coord.
	(mimeitr_free): New function.
	(destroy): Use mimeitr_free.
	(itrdup): Duplicate coord
	(mu_message_get_iterator): Initialize coord.
	* libmailutils/tests/mimeitr.c: Use mu_coord_string to print
	the part coordinates.
	* readmsg/msglist.c (message_body_stream): New argument:
	unix_header. Install additional "FROM" encoding filter if it is
	set.
	(print_header): Special handling for "*" in the weedlist.
	(msgpart_str): Remove. Use mu_coord_string instead.
	(main): In mime decode mode, if -h (display all headers) is
	requested, ignore MIME headers, since after decoding they are
	no longer relevant.

2020-06-01  Sergey Poznyakoff  <gray@gnu.org>

	readmsg: Implement searches in MIME messages. Decode MIME on
	output.

	* configure.ac: Add UNISTRING_LIBS to MU_APP_LIBRARIES.
	* examples/Makefile.am: Link with $MU_APP_LIBRARIES instead of
	plain libmuaux.la.
	* mh/Makefile.am: Likewise.
	* imap4d/Makefile.am: Likewise.
	* imap4d/imap4d.h (unistr_downcase)
	(unistr_is_substring): Move prototypes to lib/muaux.h
	* imap4d/search.c (_scan_header): Use unistr_is_substring_dn
	instead of unistr_is_substring.
	* include/mailutils/message.h (mu_message_get_iterator): New
	prototype.
	* lib/Makefile.am: Add unistr_u8.c or unistr_c.c, depending on
	MU_COND_UNISTRING.
	* lib/muaux.h (unistr_downcase)
	(unistr_is_substring,unistr_is_substring_dn): New functions.
	* lib/unistr_c.c: New file (moved from /imap4d).
	* lib/unistr_u8.c: Likewise.
	* libmailutils/mime/Makefile.am: Add mimeitr.c
	* libmailutils/mime/mimeitr.c: New file.
	* libmailutils/tests/Makefile.am: Add mimeitr.c
	* libmailutils/tests/mimeitr.c: New file. 
	* readmsg/msglist.c: Rewrite search in messages.
	* readmsg/readmsg.c: New options --glob, --regex, --ignorecase
	control message matching.
	* readmsg/readmsg.h (pattern_init,pattern_match)
	(pattern_free): New protos.

2020-05-29  Sergey Poznyakoff  <gray@gnu.org>

	Fix stream buffer parameters on truncate.

	* configure.ac: Version 3.9.90
	* libmailutils/stream/stream.c (mu_stream_truncate): Update
	stream->offset, stream->level, and stream->pos, if needed.

2020-05-29  Sergey Poznyakoff  <gray@gnu.org>

	mail: write command operates on message parts as well as on
	messages.

	Messages or message parts are decoded before being written to a
	disk file.

	* include/mailutils/cstr.h (mu_mem_c_count): New proto.
	* include/mailutils/stream.h (MU_STREAM_STAT_INLN)
	(MU_STREAM_STAT_OUTLN): New constants.
	* libmailutils/stream/stream.c (_stream_stat_incr)
	(_stream_seek): Rewrite as inline functions.
	(_stream_read, _stream_write): Rewrite as inline functions.
	Optionally count number of lines read/written.
	* libmailutils/string/strcount.c (mu_mem_c_count): New
	function.
	* libmailutils/tests/fltst.c: Update. 
	* mail/decode.c (format_msgset): Remove. Use msgset_str
	instead.
	(print_message_body): New function.
	* mail/mail.h (msgset_part_str)
	(util_get_message_part): New protos.
	(msgset_str): New function.
	* mail/msgset.y: Change the message part syntax. Components are
	separated by dots, instead of being enclosed in brackets. Old
	syntax is still supported for compatibility.
	* mail/struct.c (show_part): Use msgset_str.
	* mail/testsuite/mail/read.exp: Fix expected strings.
	* mail/util.c (util_get_message_part): New function.
	* mail/write.c (mail_write): Write message part if requested.
	Decode the body if the Content-Transfer-Encoding header is set.

2020-05-29  Sergey Poznyakoff  <gray@gnu.org>

	libmailutils: fix error in full and line buffer mode.

	* libmailutils/stream/stream.c (_stream_buffer_full_p): Fix
	conditions for buffered streams. The buffer is full if current
	pointer (not level) equals the size. For line buffering, any
	newline appearing in the written portion of the buffer causes
	flushing.
	(mu_stream_write): Fix the free space calculation.
	* libmailutils/tests/t0-stream.at: New file.
	* libmailutils/tests/t0-stream.c: New file.
	* libmailutils/tests/t1-stream.at: New file.
	* libmailutils/tests/t1-stream.c: New file.
	* libmailutils/tests/Makefile.am: Add new testcase.
	* libmailutils/tests/testsuite.at: Likewise.

2020-05-28  Sergey Poznyakoff  <gray@gnu.org>

	Amend b8664765e1.

	The body_end member holds the offset of the first character
	that follows the message body. In a well-formed mailbox, it is
	the newline character of a blank line that delimits the
	message. However, there are mailboxes that lack this blank
	line. In such cases body_end points to the ^F of the next
	envelope line.

	When saving the mailbox, delimiting blank lines are always
	emitted.

	* libproto/mbox/mbox.c (mbox_expunge_unlocked): Revert size
	calculation. Always emit a blank line after the message.

2020-05-27  Sergey Poznyakoff  <gray@gnu.org>

	mail: fix INTR handling.

	The mail's signal handler is not called when using readline 6.0
	or newer. As a result pressing INTR no longer works as
	expected. To fix this, this change prevents libreadline from
	setting its own signal handlers.

	* mail/mailline.c (sig_handler): Call readline-specific signal
	handler.
	(ml_readline_init): Disable readline signal handling.

2020-04-28  Sergey Poznyakoff  <gray@gnu.org>

	Bugfix.

	* libmailutils/datetime/utcoff.c (mu_utc_offset): Fix a typo.

2020-04-20  Sergey Poznyakoff  <gray@gnu.org>

	Fix uid->seqno translation.

	* libmailutils/msgset/trans.c (_mu_msgset_translate_pair):
	Don't exclude end point of the range.

2020-03-31  Sergey Poznyakoff  <gray@gnu.org>

	mbox: fix a bug in expunge routine.

	The bug will manifest itself by removal of the trailing newline
	in the last message in a block of unchanged messages when
	expunging the mailbox after removal of one or more messages
	before that block.

	Bug reported by Ken Olum.

	* libproto/mbox/mbox.c (mbox_expunge_unlocked): Fix an
	off-by-one error in computation of the file chunk size.

2020-03-30  Sergey Poznyakoff  <gray@gnu.org>

	Fix improper handling of [TRYCREATE] and similar imap
	responses.

	* libproto/imap/resproc.c (parse_response_code): Fix an
	off-by-one index.

2020-03-27  Sergey Poznyakoff  <gray@gnu.org>

	Minor changes.

	* imap4d/io.c (io_setio): Unref subordinate streams.
	* pop3d/extra.c: Likewise.

2020-03-22  Jordi Mallach  <jordi@debian.org>

	Call $PYTHON_CONFIG instead of pyhon-config.

2020-03-22  Sergey Poznyakoff  <gray@gnu.org>

	imap4d: implement TLS in inetd mode.

	This is a follow-up to commit ddfa689bff. It also fixes
	possible bug in daemon mode: calls to auth_gssapi_init and
	auth_gsasl_init should appear after eventual demonization
	(mu_m_server_begin), since the latter may close file
	descriptors opened by them.

2020-03-18  Sergey Poznyakoff  <gray@gnu.org>

	Remove deprecated mailutils-config.  Other minor changes.

	* libmu_sieve/extensions/Makefile.am: Remove superfluous
	variables.
	* libmu_sieve/extensions/vacation.c: Remove unneeded include.
	* mu/mailutils-config: Remove.
	* mu/Makefile.am: Likewise.

2020-03-16  Sergey Poznyakoff  <gray@gnu.org>

	Fix a typo.

2020-03-13  Sergey Poznyakoff  <gray@gnu.org>

	Version 3.9.

2020-03-13  Sergey Poznyakoff  <gray@gnu.org>

	Distribute testsuite/package.m4.

2020-02-08  Sergey Poznyakoff  <gray@gnu.org>

	Update copyright years.

2020-02-08  Sergey Poznyakoff  <gray@gnu.org>

	Remove include/mailutils/sys/wordsplit.h.

	The file is a symlink created by configure. It was
	inadvertently added by 2ad00905.

2019-12-21  Sergey Poznyakoff  <gray@gnu.org>

	Fix build with Python 3.8
	(https://savannah.gnu.org/bugs/index.php?57318)

	* configure.ac: When setting PYTHON_LIBS, use the approach
	suggested in
	https://docs.python.org/dev/whatsnew/3.8.html#debug-build-uses-
	the-same-abi-as-release-build.

2019-12-21  Sergey Poznyakoff  <gray@gnu.org>

	Fix https://savannah.gnu.org/bugs/index.php?57431.

	* libmailutils/mime/attachment.c (at_hdr): Always use base file
	name without directory components for both filename and name.
	(mu_message_create_attachment): Update accordingly.
	* NEWS: Update.

2019-12-15  Sergey Poznyakoff  <gray@gnu.org>

	Update NEWS.

2019-12-15  Sergey Poznyakoff  <gray@gnu.org>

	mail: enforce inline disposition for message body.

	* mail/send.c (atchinfo) <disp_inline>: New member.
	(attlist_add): New argument: disp_inline.
	(saveatt): Split into two functions: saveatt and
	save_attachment. Make sure memory allocated for the MIME part
	is always freed. If disp_inline is set, enforce
	Content-Disposition: inline.
	(add_body): Set prominent identifier and request inline
	disposition.

2019-12-14  Sergey Poznyakoff  <gray@gnu.org>

	Fix several linking issues.

	* configure.ac: Require libtool version 2.4.6
	(MU_LINK_POSTFLAGS): Remove. Not needed with the patched
	version of ltmain.sh. Detect the presencecof GSSAPI. Fix
	displaying the status of GSSAPI support. Remove the hack
	introduced on 2010-02-19 (commit 35ac66f056).
	(MU_AUTHLIBS,SQLLIB)
	(SQL_LOADABLE_MODULES,SQL_LIBOBJS): Insert spaces only when
	needed. 
	* mu-aux/ltmain.sh: ltmain.sh from libtool 2.4.6 with fixes
	from http://gray.gnu.org.ua/public/ltbug installed.
	* bootstrap.conf (bootstrap_epilogue): Install the fixed
	ltmain.sh version. 
	* am/gssapi.m4: Allow for "yes" and "probe" argument values.

	Improve makefile style consistency 
	 . Uniformly use parentheses instead of curly braces in
	variable
	 referencing;
	 . Prefer to use Make variables over substitution variables,
	for
	 variables prefixed with MU_; 
	* comsat/Makefile.am
	* dotlock/Makefile.am
	* examples/Makefile.am
	* examples/cpp/Makefile.am
	* frm/Makefile.am
	* imap4d/Makefile.am
	* imap4d/tests/Makefile.am
	* lib/Makefile.am
	* libmailutils/Makefile.am
	* libmailutils/address/Makefile.am
	* libmailutils/auth/Makefile.am
	* libmailutils/base/Makefile.am
	* libmailutils/cfg/Makefile.am
	* libmailutils/cidr/Makefile.am
	* libmailutils/cli/Makefile.am
	* libmailutils/datetime/Makefile.am
	* libmailutils/diag/Makefile.am
	* libmailutils/filter/Makefile.am
	* libmailutils/imapio/Makefile.am
	* libmailutils/list/Makefile.am
	* libmailutils/locus/Makefile.am
	* libmailutils/mailbox/Makefile.am
	* libmailutils/mailcap/Makefile.am
	* libmailutils/mailer/Makefile.am
	* libmailutils/mime/Makefile.am
	* libmailutils/msgset/Makefile.am
	* libmailutils/opt/Makefile.am
	* libmailutils/property/Makefile.am
	* libmailutils/server/Makefile.am
	* libmailutils/sockaddr/Makefile.am
	* libmailutils/stdstream/Makefile.am
	* libmailutils/stream/Makefile.am
	* libmailutils/string/Makefile.am
	* libmailutils/tests/Makefile.am
	* libmailutils/url/Makefile.am
	* libmailutils/wicket/Makefile.am
	* libmu_auth/Makefile.am
	* libmu_cpp/Makefile.am
	* libmu_dbm/Makefile.am
	* libmu_scm/Makefile.am
	* libmu_scm/mailutils/Makefile.am
	* libmu_sieve/Makefile.am
	* libmu_sieve/extensions/Makefile.am
	* libproto/dotmail/Makefile.am
	* libproto/dotmail/tests/Makefile.am
	* libproto/imap/Makefile.am
	* libproto/imap/tests/Makefile.am
	* libproto/maildir/Makefile.am
	* libproto/mailer/Makefile.am
	* libproto/mbox/Makefile.am
	* libproto/mh/Makefile.am
	* libproto/nntp/Makefile.am
	* libproto/pop/Makefile.am
	* mail/Makefile.am
	* mapi/Makefile.am
	* mda/lib/Makefile.am
	* mda/lmtpd/Makefile.am
	* mda/mda/Makefile.am
	* mda/mda/tests/Makefile.am
	* mda/putmail/Makefile.am
	* messages/Makefile.am
	* mh/Makefile.am
	* mh/tests/Makefile.am
	* mimeview/Makefile.am
	* movemail/Makefile.am
	* mu/Makefile.am
	* mu/libexec/Makefile.am
	* pop3d/Makefile.am
	* python/2/libmu_py/Makefile.am
	* python/2/mailutils/Makefile.am
	* python/3/libmu_py/Makefile.am
	* python/3/mailutils/Makefile.am
	* readmsg/Makefile.am
	* sieve/Makefile.am
	* sql/Makefile.am
	* testsuite/Makefile.am

2019-12-14  Sergey Poznyakoff  <gray@gnu.org.ua>

	Make sure LD_LIBRARY_PATH overrides the DT_RPATH tag on
	FreeBSD.

	* testsuite/testsuite.inc: Set LD_LIBRARY_PATH_RPATH variable
	to "y" before running tests.

2019-12-14  Sergey Poznyakoff  <gray@gnu.org>

	Build package.m4 in Makefile.

	The decision to build package.m4 in config.status makes proper
	maintenance of the file problematic. It is reverted.

	This patch also uses colon-separated VPATH for compatibility
	with other make implementations.

	* configure.ac: Don't build package.m4
	* testsuite/Makefile.am: Do it here.
	* libmailutils/tests/Makefile.am: Use colon-separated VPATH for
	compatibility with BSD make.
	* testsuite/package.m4.in: Remove.

2019-11-30  Sergey Poznyakoff  <gray@gnu.org>

	Fix the cwdrepl auxiliary tool.

	Make sure the longest possible match is replaced.

	* testsuite/cwdrepl.c: Sort the translist by directory length,
	in descending order.
	* mail/tests/atlocal.in: Add $testsuitedir to $PATH
	* mail/tests/hold.at (MAIL_TEST): Use cwdrepl instead of sed
	rules. Correct expected outputs accordingly.

2019-11-29  Sergey Poznyakoff  <gray@gnu.org>

	Fix missing Makefile variables.

	* readmsg/tests/Makefile.am: Augment TESTSUITE_AT.
	Inadvertently broken in b666b297.

2019-11-26  Sergey Poznyakoff  <gray@gnu.org>

	Bugfix.

	* comsat/action.c (run_user_action): Fill env.locus.end with
	0s.

2019-11-23  Sergey Poznyakoff  <gray@gnu.org>

	Bugfix in libmailutils testsuite.

	* libmailutils/tests/decode2047.at: Deduce charset from the
	input.

2019-11-23  Sergey Poznyakoff  <gray@gnu.org>

	Restore two accidentally deleted lines.

2019-11-23  Sergey Poznyakoff  <gray@gnu.org>

	Fix uses of uninitialized variables.

	* libproto/mailer/smtp.c (_smtp_set_rcpt): Initialize header
	count to zero if no such header is provided.
	* mail/decode.c: Fix the util_get_hdr_value usage.
	* mail/mail.h (util_get_content_type)
	(util_get_hdr_value): Change return type.
	* mail/util.c (util_get_content_type): Change return to void.
	(util_get_hdr_value): Report error if necessary. Always
	initialize
	*value before return. Change return to void.

2019-11-17  Sergey Poznyakoff  <gray@gnu.org>

	Bugfix.

	* libmailutils/mailbox/msgenv.c (get_received_date): Fix
	possible NULL dereference.

2019-11-11  Sergey Poznyakoff  <gray@gnu.org.ua>

	Follow-up to the previous commit.

2019-11-11  Sergey Poznyakoff  <gray@gnu.org.ua>

	Get rid of the deprecated functions.

	Below I list the removed functions along with the recipes on
	how to replace them.

	. mu_body_get_stream . mu_message_get_stream .
	mu_mailer_get_stream . mu_header_get_stream

	 These functions should not be used at all.
	 They will reappear within a couple of releases as synonyms
	 for the corresponding _get_streamref functions, after which
	 the latter will be gradually removed. Thus, at the end of
	 the transition perion _get_streamref's will be replaced by
	 _get_stream.

	. mu_sieve_compile_buffer
	 Replaced by mu_sieve_compile_text.
	 Old code:
	 rc = mu_sieve_compile_buffer (mach, buf, bufsize, fname,
	line);
	 New code:
	 struct mu_locus_point loc = MU_LOCUS_POINT_INITIALIZER;
	 mu_locus_point_set_file (&loc, fname);
	 loc.mu_line = line;
	 rc = mu_sieve_compile_text (mach, buf, bufsize, &loc);
	 mu_locus_point_deinit (&loc);

	. mu_address_to_string
	 Use mu_address_get_printable instead.

	. mu_address_format_string
	 Use mu_stream_format_address instead. E.g. to print to a
	string: 
	 char buf[100];
	 stream_t str;
	 mu_fixed_memory_stream_create (&str, buf, sizeof(buf),
	MU_STREAM_WRITE);
	 rc = mu_stream_format_address (str, addr);

	. mu_registrar_get_list
	 Should not be used. Use mu_registrar_get_iterator if you need
	to
	 iterate over the list.

	. mu_mailbox_save_attributes
	 Replaced by mu_mailbox_sync.

	. mu_msgset_print
	 Use mu_stream_msgset_format.
	 Old code:
	 rc = mu_msgset_print (mu_stream_t str, mu_msgset_t mset);
	 New code:
	 rc = mu_stream_msgset_format (str, mu_msgset_fmt_imap, mset);

2019-11-10  Sergey Poznyakoff  <gray@gnu.org>

	Create types.h when configuring.

2019-11-10  Sergey Poznyakoff  <gray@gnu.org>

	Remove deprecated MU_IOCTL_LOGSTREAM_GET_LOCUS and
	MU_IOCTL_LOGSTREAM_SET_LOCUS.

2019-11-10  Sergey Poznyakoff  <gray@gnu.org>

	Bugfixes.

	* include/mailutils/Makefile.am: Don't distribute types.h
	* mda/tests/mda.sh: New file.
	* mda/Makefile.am: Distribute mda.sh
	* mda/lmtpd/tests/atlocal.in: Set MU_DEFAULT_SCHEME and source
	mda.sh
	* mda/mda/tests/atlocal.in: Likewise.
	* mda/putmail/tests/atlocal.in: Likewise.
	* mda/lmtpd/tests/lmtpd.at: Use dumpmail
	* mda/tests/mda.inc (MDA_OPTIONS): Remove MUT_DEFAULT_OPTIONS.
	(dumpmail): Remove macro.
	* testsuite/package.m4.in (MU_DEFAULT_SCHEME): Remove macro. 
	* maint/fullcheck.mk (fullcheck_tmpl): Make the source dir
	read-only.

2019-11-09  Sergey Poznyakoff  <gray@gnu.org>

	Reorganize testsuite.

	Simplify Makefile.am's in tests subdirectories by moving the
	common part in a separate file and including it where
	necessary. Build only one copy of package.m4. Both package.m4
	and include file testsuite.am reside in the testsuite
	directory.

	Also provide configure options for selecting mda components to
	build:

	 --disable-build-mda do not build mda
	 --disable-build-lmtpd do not build lmtpd
	 --disable-build-putmail do not build putmail 
	* .gitignore: Update.
	* Makefile.am [MU_COND_MDA]: Change to MU_COND_MDA_TOOLS
	* configure.ac: Provide a way to enable/disable building of
	mda, lmtpd and putmail separately. Build testsuite/package.m4 
	* testsuite/testsuite.am
	* testsuite/Makefile.am: Distribute both package.m4.in and
	package.m4. Include main part from testsuite.am
	* testsuite/package.m4.in: New file. 
	* comsat/tests/Makefile.am: Include main part from testsuite.am
	* frm/tests/Makefile.am: Likewise.
	* imap4d/tests/Makefile.am: Likewise.
	* libmailutils/tests/Makefile.am: Likewise.
	* libmu_scm/tests/Makefile.am: Likewise.
	* libproto/dotmail/tests/Makefile.am: Likewise.
	* mail/tests/Makefile.am: Likewise.
	* messages/tests/Makefile.am: Likewise.
	* mh/tests/Makefile.am: Likewise.
	* mimeview/tests/Makefile.am: Likewise.
	* readmsg/tests/Makefile.am: Likewise.
	* sieve/tests/Makefile.am: Likewise. 
	* mda/.gitignore: Remove.
	* mda/tests/Makefile.am: Remove.
	* mda/tests/testsuite.at: Remove.
	* mda/tests/.gitignore: Remove.
	* mda/tests/atlocal.in: Remove.
	* mda/tests/mda.inc: New file. 
	* mda/Makefile.am: Add extra directory level. Add subdirs
	depending on whether the corresponding component is selected
	for building.
	* mda/lmtpd/.gitignore: New file.
	* mda/lmtpd/Makefile.am: New file.
	* mda/lmtpd.c: Move to mda/lmtpd/lmtpd.c 
	* mda/lmtpd/tests/.gitignore: New file.
	* mda/lmtpd/tests/Makefile.am: New file.
	* mda/lmtpd/tests/atlocal.in: New file.
	* mda/tests/lmtpd.at: Move to mda/lmtpd/tests/lmtpd.at
	* mda/lmtpd/tests/testsuite.at: New file. 
	* mda/mda/.gitignore: New file.
	* mda/mda/Makefile.am: New file.
	* mda/mda.c: Move to mda/mda/mda.c
	* mda/mda/tests/.gitignore: New file.
	* mda/mda/tests/Makefile.am: New file.
	* mda/mda/tests/atlocal.in: New file.
	* mda/tests/forward.at: Move to mda/mda/tests/forward.at
	* mda/tests/mda.at: Move to mda/mda/tests/mda.at
	* mda/mda/tests/testsuite.at: New file. 
	* mda/putmail/.gitignore: New file.
	* mda/putmail/Makefile.am: New file.
	* mda/putmail.c: Move to mda/putmail/putmail.c
	* mda/putmail/tests/.gitignore: New file.
	* mda/putmail/tests/Makefile.am: New file.
	* mda/putmail/tests/atlocal.in: New file.
	* mda/tests/putmail.at: Move to mda/putmail/tests/putmail.at
	* mda/putmail/tests/testsuite.at: New file 
	* po/POTFILES.in: Update pathnames 
	* maint/fullcheck.mk: Minor fixes.

2019-11-09  Sergey Poznyakoff  <gray@gnu.org>

	New maintainer makefile for running tests for all default
	mailbox formats.

	* maint/fullcheck.mk: New file. Runs make check for all
	possible default mailbox formats.
	* GNUmakefile: Include new file. 
	* NEWS: Update.
	* configure.ac: Version 3.8.90

2019-11-09  Sergey Poznyakoff  <gray@gnu.org>

	Fix mda testsuite.

	The testsuite should work no matter what the selected default
	mailbox format.

	* mda/tests/atlocal.in (dumpmail): New function.
	* mda/tests/forward.at: Use dumpmail to read the mailbox.
	* mda/tests/mda.at: Likewise.

2019-11-09  Sergey Poznyakoff  <gray@gnu.org>

	Fix SUBDIRS ordering in Makefile.am's.

	* imap4d/Makefile.am: Build in source dir before tests.
	* mimeview/Makefile.am: Likewise.
	* pop3d/Makefile.am: Likewise.
	* mail/Makefile.am: Likewise.

2019-11-09  Sergey Poznyakoff  <gray@gnu.org>

	dotmail: fix opening in append-only mode.

	* libproto/dotmail/dotmail.c (dotmail_rescan_unlocked)
	(dotmail_rescan): Skip if mailbox is not opened for reading.

2019-11-07  Sergey Poznyakoff  <gray@gnu.org>

	Fix typos in help strings.

	* imap4d/imap4d.c: Fix typo in help string for tls-mode.
	* pop3d/pop3d.c: Likewise.

2019-11-06  Sergey Poznyakoff  <gray@gnu.org>

	Version 3.8.

	* configure.ac: Version 3.8
	* NEWS: Document changes.
	* THANKS: Update.

2019-10-16  Sergey Poznyakoff  <gray@gnu.org>

	Restore MDA debug flags.

2019-10-14  Sergey Poznyakoff  <gray@gnu.org>

	Restore mda tests.

	* mda/mda.c: Instrument for compilation for the testsuite.
	* mda/tests/.gitignore: Add testmda
	* mda/tests/Makefile.am: Build testmda. Add new tests.
	* mda/tests/forward.at: New test.
	* mda/tests/mda.at: New test.
	* mda/tests/testsuite.at: Include new tests.

2019-10-13  Sergey Poznyakoff  <gray@gnu.org>

	Minor fixes.

2019-10-13  Sergey Poznyakoff  <gray@gnu.org>

	Fix distcheck.

2019-10-12  Sergey Poznyakoff  <gray@gnu.org.ua>

	Split maidag into three single-purpose tools.

	Maidag operated in three modes: mda, url and lmtp. In mda mode
	it is normally started by sendmail with non-root privileges. In
	order to be able to write to other users' mailboxes, the binary
	must be setuid, which creates certain security threats. As
	these appear to be impossible to avoid in a single
	multi-purpose program, it has been decided to replace maidag
	with three single-purpose tools: mda, putmail, and lmtpd. The
	mda tool is a local mail delivery agent. It is the only one for
	which the setuid bit is required, so special measures have been
	taken to secure it. In particular, to avoid unverified user
	inputs it disallows to override any configuration settings from
	the command line.

	The two other tools provide the functionality of the url and
	lmtp mode.

	* Makefile.am (MAIDAG_DIR): Replace with MDA_DIR
	* configure.ac (MU_COND_MAILBOX_QUOTA): New conditional. Use
	names relative to ${top_builddir} instead of ".".
	* maidag: Remove.
	* mda/.gitignore: New file.
	* mda/Makefile.am: New file.
	* mda/lib/Makefile.am: New file.
	* mda/lib/deliver.c: New file.
	* mda/lib/forward.c: New file.
	* mda/lib/libmda.h: New file.
	* mda/lib/mailquota.c: New file.
	* mda/lib/script.c: New file.
	* mda/lib/util.c: New file.
	* mda/lmtpd.c: New file.
	* mda/mda.c: New file.
	* mda/putmail.c: New file.
	* mda/tests/.gitignore: New file.
	* mda/tests/Makefile.am: New file.
	* mda/tests/atlocal.in: New file.
	* mda/tests/input.msg: New file.
	* mda/tests/lmtpd.at: New file.
	* mda/tests/putmail.at: New file.
	* mda/tests/testsuite.at: New file. 
	* doc/texinfo/programs/maidag.texi: Remove.
	* doc/texinfo/programs/mda.texi: New file.
	* doc/texinfo/programs/lmtpd.texi: New file.

2019-10-12  Sergey Poznyakoff  <gray@gnu.org.ua>

	cli: implement a hint that disallows overriding configuration
	from the command line * include/mailutils/cfg.h
	(MU_CFHINT_NO_CONFIG_OVERRIDE): New hint. *
	libmailutils/cli/cli.c (init_options): Omit configuration
	override options if MU_CFHINT_NO_CONFIG_OVERRIDE is set.

2019-09-11  Sergey Poznyakoff  <gray@gnu.org.ua>

	Fix typo.

2019-09-11  Sergey Poznyakoff  <gray@gnu.org.ua>

	mail: revamp message type specification handling.

	* mail/mail.h (msgtype_generator): New proto.
	* mail/mailline.c (msgtype_generator): Remove.
	* mail/msgset.y (TYPE rule): Use find_type_selector to find the
	right selector.
	(select_type): Remove. Replaced with separate functions for
	each message type (select_type_n, select_type_d, etc.)
	(find_type_selector): New static function.
	(msgtype_generator): New function.

2019-09-11  Sergey Poznyakoff  <gray@gnu.org.ua>

	mail: new message specification :s.

	* NEWS: Update.
	* doc/texinfo/programs/mail.texi: Update.
	* mail/mailline.c (msgtype_generator): Recogize 's'
	* mail/msgset.y (select_type): Recognize 's'

2019-09-11  Sergey Poznyakoff  <gray@gnu.org.ua>

	Document how to set body content-type and encoding in multipart
	messages.

	This closes https://savannah.gnu.org/support/?109866

2019-09-11  Sergey Poznyakoff  <gray@gnu.org.ua>

	Document yesterday's changes.

2019-09-10  Sergey Poznyakoff  <gray@gnu.org.ua>

	Fix the semantics of the hold and keepsave variables in mail.

	* mail/delete.c (mail_delete_msg): Set
	MAIL_ATTRIBUTE_PRESERVED. This is not necessary, stricto sensu,
	because mail_mbox_close skips messages marked for deletion
	anyway. But it's good for clarity.
	* mail/quit.c (mailbox_classify): New function.
	(mail_mbox_commit): Rewrite 
	* mail/tests/Makefile.am: Add new test
	* mail/tests/testsuite.at: Include new tests.
	* mail/tests/atlocal.in (catmbox): New function.
	* mail/tests/hold.at: New test.

2019-09-05  Sergey Poznyakoff  <gray@gnu.org.ua>

	Fix guimb help message.

	* scheme/guimb.scmi: Format the usage and description lines
	consistently with other mailutils programs.

2019-09-03  Sergey Poznyakoff  <gray@gnu.org>

	comsatd: optional argument to the --test option supplies the
	name of the tty to use.

	* NEWS: Document changes.
	* comsat/action.c (open_default_tty): Remove.
	(open_tty): Examine the tty device (or file) and construct a
	suitable filter chain. Use append mode when opening it.
	* comsat/comsat.c: The --test option takes optional argument.
	* comsat/tests/testsuite.at: Use local file instead of the tty.
	* doc/texinfo/programs/comsatd.texi: Document changes.

2019-08-29  Sergey Poznyakoff  <gray@gnu.org.ua>

	pop3d: implement TLS in inetd mode.

	New global configuration statement "tls-mode" configures the
	TLS for use in inetd mode.

	The certificate and key files are configured by the global
	"tls" compound statement.

	Example configuration (pop3s server):

	 mode inetd;
	 tls-mode connection;
	 tls {
	 ssl-key-file /etc/ssl/key.pem;
	 ssl-certificate-file /etc/ssl/cert.pem;
	 }

	In daemon mode, global "tls-mode" sets the type of TLS
	encryption to use in all server blocks that lack the "tls-mode"
	statement. 
	* pop3d/cmd.c (global_tls_mode)
	(global_conf_status): New globals.
	(stls_server_check): New function.
	(stls_preflight): Use stls_server_check.
	* pop3d/pop3d.c (pop3d_cfg_param): New global statement:
	tls-mode
	(main): Set up TLS connection in inetd mode, if requested.
	* pop3d/pop3d.h (global_tls_mode): New global.
	(stls_server_check): New proto. 
	* NEWS: Document changes.
	* doc/texinfo/programs/pop3d.texi: Likewise.

2019-07-23  Sergey Poznyakoff  <gray@gnu.org>

	Fix mandatory locking.

	* lib/manlock.c (mailbox_open_and_lock): Force proper locker if
	a null locker is associated with the mailbox.

2019-07-23  Sergey Poznyakoff  <gray@gnu.org>

	Minor fix.

	Check return from mu_message_get_num_parts

2019-07-13  Sergey Poznyakoff  <gray@gnu.org>

	Fixes in the mail testsute.

	* mail/tests/copy00.at: Fix description. Skip test if
	/dev/stdout cannot be locked.
	* mail/tests/copy03.at: Rename MBOX to avoid name clashes on
	case-insensitive file systems.

2019-07-11  Sergey Poznyakoff  <gray@gnu.org>

	Bugfix.

	* include/mailutils/sys/dotmail.h: Remove stray variable
	declaration.

2019-07-11  Sergey Poznyakoff  <gray@gnu.org>

	Pull wordsplit from submodule.

	* .gitmodules: Add wordsplit.
	* configure.ac: Version 3.7.90
	* NEWS: Raise version number.
	* include/mailutils/sys/Makefile.am: Include wordsplit.h from
	the submodule.
	* include/mailutils/sys/wordsplit.h: New file.
	* include/mailutils/wordsplit.h: Rewrite as a wrapper over
	mailutils/sys/wordsplit.h
	* libmailutils/Makefile.am: Distribute files from wordsplit.
	* libmailutils/string/Makefile.am: Add libmailutils/wordsplit
	to the include path.
	* libmailutils/string/wordsplit.c: Replace with a wrapper over
	wordsplit/wordsplit.c
	* libmailutils/tests/.gitignore: Update.
	* libmailutils/tests/Makefile.am: Pull wordsplit testsuite from
	the submodule.
	* libmailutils/tests/wordsplit.at: Remove.
	* libmailutils/tests/wsp.c: Remove.

2019-06-22  Sergey Poznyakoff  <gray@gnu.org>

	Use defines for internal mail variable names.

2019-06-22  Sergey Poznyakoff  <gray@gnu.org>

	Fix typos and wording in some diagnostic messages.

2019-06-21  Sergey Poznyakoff  <gray@gnu.org>

	Version 3.7.

2019-06-21  Sergey Poznyakoff  <gray@gnu.org>

	Update NEWS.

2019-05-30  Sergey Poznyakoff  <gray@gnu.org>

	Fix conditional compilation; add dotmail support to libmu_scm.

	* configure.ac: Accept dotmail as a value for
	MU_DEFAULT_SCHEME. Display dotmail support status at the end of
	the run.
	* libmailutils/base/nullrec.c: Provide placeholder for disabled
	dotmail.
	* libmu_scm/mu_scm.c (format_table): Add dotmail.
	* libmu_scm/tests/testsuite.at: Don't assume mbox as the
	default. Load it explicitly.

2019-05-30  Sergey Poznyakoff  <gray@gnu.org>

	Minor change.

	* maint/flowgraph.mk: Pass --all to cflow.

2019-05-29  Sergey Poznyakoff  <gray@gnu.org>

	mh: fix folder +/absolute/name.

	* mh/folder.c (name_prefix_len): Remove global.
	(install_folder_info,_scan): Take additional argument: length
	of the name prefix to skip.
	(folder_scan): New function.
	(action_print): Don't impose name prefix unconditionally. Call
	folder_scan to set it up as necessary.

2019-05-22  Sergey Poznyakoff  <gray@gnu.org>

	Fix a bug in TLS read.

	This complements afda9ba4. Thanks to Rafael Fontenelle for
	helping locate the bug.

	* libmu_auth/tlsiostr.c (_tls_io_read): Handle GNUTLS_E_AGAIN
	and GNUTLS_E_INTERRUPTED.
	* libmailutils/stream/stream.c (mu_stream_seterr): EINTR is a
	transient error condition.
	* THANKS: Update.

2019-05-22  Sergey Poznyakoff  <gray@gnu.org>

	URL parser: use case-insensitive comparison for auth and host
	parts.

	* libmailutils/url/accessor.h: (URL_PART_CMP_ICASE)
	(URL_PART_CMP_ICASE): New defines.
	* libmailutils/url/get-auth.c: Request case-insensitive
	comparison.
	* libmailutils/url/get-host.c: Likewise.

2019-05-21  Sergey Poznyakoff  <gray@gnu.org>

	Describe maidag delivery-mode configuration variable.

2019-05-09  Sergey Poznyakoff  <gray@gnu.org>

	Maidag: fix coredump in daemon mode.

	* maidag/maidag.c (main): Pass pointer to the server as data
	parameter to mu_cli.

2019-05-03  Sergey Poznyakoff  <gray@gnu.org>

	movemail: make sure UIDLs are properly stored.

	* movemail/movemail.c (main): When using POP3 UIDLs for message
	identification, be sure to store them in the X-UIDL header.

2019-04-24  Sergey Poznyakoff  <gray@gnu.org>

	Bugfixes.

	* libmailutils/diag/diag.c (mu_diag_vprintf): Fix debug level
	formatting. It missed 's' after the escape character.
	* mu/libexec/ldflags.c (lib_descr): Add dotmail.

2019-03-29  Sergey Poznyakoff  <gray@gnu.org>

	Remove explicit _DEPENDENCIES variables from Makefiles.

	These might be needed only in rare cases during the development
	cycle. There is no use keeping them around.

	* configure.ac (MU_AUTHLIBS_DEPENDENCY)
	(DBMLIB_DEPENDENCY,SQLLIB_DEPENDENCY): Remove.
	* imap4d/Makefile.am: Remove explicit _DEPENDENCIES.
	* pop3d/Makefile.am: Likewise.
	* libmu_auth/Makefile.am: Likewise.
	* libmu_dbm/Makefile.am: Likewise.

2019-03-27  Sergey Poznyakoff  <gray@gnu.org>

	Use <prog>_LDADD to link in libmu_test.

	This helps automake discover dependency on this library.

2019-03-27  Sergey Poznyakoff  <gray@gnu.org>

	Minor fix (follow-up to 60c5545ba)

2019-03-27  Sergey Poznyakoff  <gray@gnu.org>

	Minor fixes in dot filters.

	The DOT decoder accepts input consisting of two characters
	".\n" and decodes it to empty output. When encoding empty
	input, ".\n" is produced

	Similarly, CRLFDOT handles ".\r\n" the same way.

	* libmailutils/filter/crlfdot.c (_crlfdot_encoder): Accept
	".\r\n" as input.
	* libmailutils/filter/dot.c: Accept ".\n" as input.
	* libmailutils/tests/crlfdot.at: Add new test.
	* libmailutils/tests/dot.at: Likewise.

2019-03-26  Sergey Poznyakoff  <gray@gnu.org>

	Use mu_folder_scan in imap4d.

	* imap4d/list.c (list_fun): Don't check if the returned record
	matches refinfo->pfx->record. This is done by mu_folder_scan.
	(list_ref): Use mu_folder_scan.

2019-03-26  Sergey Poznyakoff  <gray@gnu.org>

	Consistently use the term 'depth' when referring to directory
	nesting depth.

	* include/mailutils/folder.h (mu_list_response): Rename 'level'
	to 'depth'. All uses updated.

2019-03-26  Sergey Poznyakoff  <gray@gnu.org>

	Implement selection of requested mailbox formats in scanning
	the local file system folders.

	* include/mailutils/registrar.h (mu_record_match): New struct.
	(mu_registrar_match_records): New proto.
	* libmailutils/base/registrar.c (mu_registrar_match_records):
	New function.
	* libmailutils/mailbox/fsfolder.c (list_helper): Actually
	select the matching record from scn->records (if supplied).
	* libmailutils/tests/Makefile.am: Add new tests.
	* libmailutils/tests/fsfolder.c: Minor changes.
	* libmailutils/tests/testsuite.at: Add new tests.
	* libmailutils/tests/fsfolder03.at: New file.
	* libmailutils/tests/fsfolder04.at: New file.

2019-03-25  Sergey Poznyakoff  <gray@gnu.org>

	Bugfixes in fsfolder.

	* libmailutils/mailbox/fsfolder.c (list_helper): Fix depth cut
	off. Fix the lookup in scn->records.
	* libmailutils/tests/fsfolder.c: Implement two test records.
	New command: "scan".

2019-03-25  Sergey Poznyakoff  <gray@gnu.org>

	Implement test shell framework.

	* libmailutils/tests/tesh.c: New file.
	* libmailutils/tests/tesh.h: New file.
	* libmailutils/tests/Makefile.am: Add new files.
	* libmailutils/tests/fsfolder.c: Rewrite using test shell
	framework.
	* libmailutils/tests/fsfolder00.at: Use semicolons to delimit
	commands.
	* libmailutils/tests/fsfolder01.at: Likewise.
	* libmailutils/tests/linetrack.c: Rewrite using test shell
	framework.
	* libmailutils/tests/linetrack.at: Change command initial
	character to dot.
	* libmailutils/tests/listop.c: Rewrite using test shell
	framework.
	* libmailutils/tests/list.at: Minor changes.
	* libproto/dotmail/tests/dm_mesg.c: Rewrite using test shell
	framework.
	* libproto/dotmail/tests/Makefile.am: Link dm_mesg with
	libmu_tesh
	* libproto/dotmail/dotmail.c: Fix typo.

2019-03-23  Sergey Poznyakoff  <gray@gnu.org>

	Two new string functions.

	mu_string_prefix(A, B) returns true if B is the prefix of A.
	mu_string_suffix(A, B) returns true if B is the suffix of A.

	* include/mailutils/cstr.h (mu_string_prefix)
	(mu_string_suffix): protos.
	* libmailutils/string/Makefile.am: Add new files.
	* libmailutils/string/strpref.c: New file.
	* libmailutils/string/strsuf.c: New file.

2019-03-23  Sergey Poznyakoff  <gray@gnu.org>

	Rewrite folder listing interface.

	New function mu_folder_scan provides an improved scanning
	interface. In particular, it allows the user to abridge the
	scan to mailboxes of certain type (or types).

	Existing listing API functions are rewritten as alternative
	entry points to mu_folder_scan.

	* include/mailutils/folder.h (mu_folder_scanner): New struct.
	(mu_folder_scan): New function.
	* include/mailutils/registrar.h (mu_registrar_list_p): New
	function.
	* include/mailutils/sys/folder.h (_mu_folder._list): Change
	signature.
	* libmailutils/base/registrar.c (mu_registrar_list_p): New
	function.
	* libmailutils/mailbox/folder.c (mu_folder_scan): New function.
	(mu_folder_enumerate): Rewrite as entry point to
	mu_folder_scan.
	* libmailutils/mailbox/fsfolder.c: Use new API,
	* libmailutils/tests/fsfolder.c: Rewrite scheme matcher.
	* libmailutils/tests/fsfolder00.at: Fix test output.
	* libmailutils/tests/fsfolder02.at: Likewise.
	* libproto/imap/folder.c: Use new API.

2019-03-22  Sergey Poznyakoff  <gray@gnu.org>

	Fix MH format detection.

	* libproto/mh/folder.c (mh_dir_p): Check only regular files.
	(_mh_list_p): Ditto. All directories are eligible for listing.
	* libmailutils/base/registrar.c (mu_record_list_p): Remove
	useless check.

2019-03-13  Sergey Poznyakoff  <gray@gnu.org>

	mail: force mime mode if at least one attachment was given.

	This fixes
	https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=918806

	* mail/mail.c (cli_attach): Set mime_option.

2019-03-10  Sergey Poznyakoff  <gray@gnu.org>

	Fix encoding of empty input by DOT filter.

	* libmailutils/filter/dot.c (_dot_encoder): Don't emit
	additional empty line on empty input (i.e. if mu_filter_lastbuf
	arrives when dfa is in dot_encode_init state).
	* libmailutils/tests/dot.at: Test empty input.

2019-03-06  Sergey Poznyakoff  <gray@gnu.org>

	Simplify dotmail test environment.

	The dm_mbox tool is not needed after ff847bb1. Remove it.
	Modify dm_mesg to optionally take commands from the command
	line. Use it instead of dm_mbox in testcases.

2019-03-06  Sergey Poznyakoff  <gray@gnu.org>

	Minor change.

	* NEWS: Document the recent changes.
	* THANKS: Add Kurt Hackenberg.

2019-03-06  Sergey Poznyakoff  <gray@gnu.org>

	Bugfix.

	* libproto/mbox/mbox.c (restore_date): Fix possible
	uninitialized memory access.

2019-03-06  Sergey Poznyakoff  <gray@gnu.org>

	Revamp UID support in dotmail.

	* include/mailutils/stream.h (mu_stream_header_copy): New
	proto.
	* libmailutils/stream/hdrcpy.c: New file.
	* libmailutils/stream/Makefile.am: Add hdrcpy.c
	* libmailutils/tests/hdrcpy.c: New test program.
	* libmailutils/tests/hdrcpy.at: New testcase.
	* libmailutils/tests/Makefile.am: Add new test program and
	testcase.
	* libmailutils/tests/testsuite.at: Add new testcase.
	* libproto/dotmail/tests/append.at: Add new tests.
	* libmailutils/tests/.gitignore: Update. 
	* include/mailutils/sys/dotmail.h (mu_dotmail_message): Remove
	headers_scanned. New field: uid_modified.
	(mu_dotmail_mailbox): Change type for uidnext to unsigned long.
	Remove scanned_uids_count. (mu_dotmail_message_headers_prescan)
	(mu_dotmail_mailbox_scan_uids): Remove.
	(mu_dotmail_mailbox_uid_setup): New proto.
	* libproto/dotmail/dotmail.c: Revamp UID support. See "Notes"
	on line 251 for description.
	* libproto/dotmail/message.c (mu_dotmail_message_reconstruct):
	Optimize for the case where the message remains unchanged
	except for the UID information.
	* libproto/dotmail/tests/dm_mesg.c: Add mailbox inspection
	commands from dm_mbox. Perhaps the latter can be removed.

2019-03-03  Sergey Poznyakoff  <gray@gnu.org>

	Implement automatic dot-unstuffing in dotmail mailboxes.

	* include/mailutils/sys/dotmail.h (mu_dotmail_message): New
	members: body_size and body_dot_stuffed.
	* libproto/dotmail/dotmail.c (dotmail_rescan_unlocked): Count
	dot-unstuffed octets in the body. Set dmsg->body_dot_stuffed to
	1 if at least one byte was dot-stuffed.
	* libproto/dotmail/message.c (dotmail_body_size): Return
	unstuffed size.
	(_msg_body_setup): If the body was dot-stuffed, return rdcache
	stream built over the "DOT" decoder.
	* libproto/dotmail/tests/body.at: Check dot-unstuffing.

2019-03-02  Sergey Poznyakoff  <gray@gnu.org>

	Fix the dot filter decoding.

	* libmailutils/filter/dot.c (_dot_decoder): Don't emit extra
	newline at the "\n.\n" marker.
	* libmailutils/stream/stream.c (mu_stream_seterr): Don't treat
	ENOSYS as fatal error.
	* libmailutils/tests/dot.at: New file.
	* libmailutils/tests/testsuite.at: Include dot.at.
	* libmailutils/tests/Makefile.am: Add dot.at
	* testsuite/smtp-msg.at: Remove extra newline from the expected
	output.
	* testsuite/smtp-str.at: Likewise.

2019-03-02  Sergey Poznyakoff  <gray@gnu.org>

	Improve the dotmail testsuite.

	* libproto/dotmail/tests/dm_mesg.c: Rewrite to take commands
	from stdin.
	* libproto/dotmail/tests/Makefile.am: Add setattr.at
	* libproto/dotmail/tests/testsuite.at (DM_MESG): New macro.
	* libproto/dotmail/tests/setattr.at: New file.
	* libproto/dotmail/tests/append.at: Use DM_MESG.
	* libproto/dotmail/tests/attr.at: Likewise.
	* libproto/dotmail/tests/body.at: Likewise.
	* libproto/dotmail/tests/delete.at: Likewise.
	* libproto/dotmail/tests/env.at: Likewise.
	* libproto/dotmail/tests/header.at: Likewise.
	* libproto/dotmail/tests/uid.at: Likewise.

2019-03-02  Sergey Poznyakoff  <gray@gnu.org>

	Implement different accuracy levels for the mailbox format
	detection.

	Selecting the accuracy level allows the user to achieve the
	desired balance between the speed of the folder scan and
	accuracy of mailbox format detection.

	The accuracy level can be set either from the configuration
	file, using the mailbox.accuracy-level statement, or from the
	environment, using the MU_AUTODETECT_ACCURACY variable.

	The default accuracy level 1 discerns valid mbox and dotmail
	mailboxes providing reasonable scan speed. Level 0 (previous
	default) does not discern them, but provides maximal speed.
	Level 2 and higher provide better accuracy at the price of
	speed.

	* include/mailutils/url.h (MU_AUTODETECT_ACCURACY_AUTO)
	(MU_AUTODETECT_ACCURACY_FAST)
	(MU_AUTODETECT_ACCURACY_DEFAULT): New constants.
	(mu_scheme_autodetect_p): New proto, moved here from util.h
	(mu_set_autodetect_accuracy)
	(mu_autodetect_accuracy): New protos.
	* libmailutils/base/schemeauto.c (mu_set_autodetect_accuracy)
	mu_autodetect_accuracy): New functions.
	* libmailutils/cli/stdcapa.c: New configuration statement:
	mailbox.autodetect-accuracy.
	* libmailutils/url/create.c (_mu_url_create_internal): Assume
	the "file" scheme if the MU_URL_PARSE_LOCAL flag is set.
	* libproto/dotmail/folder.c: Implement format detection. Three
	accuracy levels: 0, 1, and >1
	* libproto/mbox/folder.c (_mbox_is_scheme): Implement default
	format detection.
	* libproto/dotmail/tests/Makefile.am: Add new test.
	* libproto/dotmail/tests/autodetect.at: New test.
	* libproto/dotmail/tests/dm_detect.c: New file.
	* libproto/dotmail/tests/testsuite.at: Add new test.

2019-03-01  Sergey Poznyakoff  <gray@gnu.org>

	Initial implementation of the dotfile format.

	* configure.ac: Enable new local format.
	* include/mailutils/registrar.h (mu_dotmail_record): New
	extern. (mu_register_all_mbox_formats)
	(mu_register_local_mbox_formats): Add mu_dotmail_record
	* include/mailutils/sys/dotmail.h: New file.
	* libproto/dotmail/Makefile.am: New file.
	* libproto/dotmail/dotmail.c: New file.
	* libproto/dotmail/message.c: New file.
	* libproto/dotmail/folder.c: New file.
	* libproto/dotmail/tests/.gitignore: New file.
	* libproto/dotmail/tests/Makefile.am: New file.
	* libproto/dotmail/tests/atlocal.in: New file.
	* libproto/dotmail/tests/count.at: New file.
	* libproto/dotmail/tests/dm_mbox.c: New file.
	* libproto/dotmail/tests/dm_mesg.c: New file.
	* libproto/dotmail/tests/env.at: New file.
	* libproto/dotmail/tests/header.at: New file.
	* libproto/dotmail/tests/recent.at: New file.
	* libproto/dotmail/tests/testsuite.at: New file.
	* libproto/dotmail/tests/attr.at: New file.
	* libproto/dotmail/tests/body.at: New file.
	* libproto/dotmail/tests/uid.at: New file.
	* libproto/dotmail/tests/dm_qget.c: New file.
	* libproto/dotmail/tests/qget.at: New file.
	* libproto/dotmail/tests/append.at: New file.
	* libproto/dotmail/tests/delete.at: New file. 
	* libmu_scm/mailutils/ancilla.scm: Fix regular expression to
	take into account changes introduced by 4bdc41ff90.

2019-02-26  Sergey Poznyakoff  <gray@gnu.org>

	Provide fallback mechanism for mu_mailbox_messages_recent and
	mu_mailbox_message_unseen.

	* libmailutils/mailbox/mailbox.c (mu_mailbox_messages_recent)
	(mu_mailbox_message_unseen): Fall back to iteration if no
	backend-specific method is provided.

2019-02-26  Sergey Poznyakoff  <gray@gnu.org>

	envelope: attempt to recover from trace information if not
	available otherwise.

	* libmailutils/mailbox/msgenv.c (message_envelope_date): Use
	timestamp from Received header.
	(message_envelope_sender): Give preference to Return-Path
	header

2019-02-26  Sergey Poznyakoff  <gray@gnu.org>

	New autoconf macro for activating mailbox format support.

	* am/enable.m4 (MU_ENABLE_SUPPORT)
	(MU_ENABLE_BUILD): Use m4_-prefixed directives.
	(MU_ENABLE_MAILBOX_FORMAT) (MU_ENABLE_LOCAL_MAILBOX_FORMAT_
	(MU_ENABLE_REMOTE_MAILBOX_FORMAT): New macros. (MU_LIB_MAILBOX)
	(MU_LIB_LOCAL_MAILBOX)
	(MU_LIB_REMOTE_MAILBOX): New substitution variables.
	* configure.ac: Use new macros to enable mailbox formats
	* libproto/Makefile.am: Augment SUBDIRS instead of using
	Makefile variables.
	* comsat/Makefile.am: Use MU_LIB_.*MAILBOX macros to link in
	the necessary libraries.
	* examples/Makefile.am: Likewise.
	* examples/cpp/Makefile.am: Likewise.
	* frm/Makefile.am: Likewise.
	* imap4d/Makefile.am: Likewise.
	* include/mailutils/sys/Makefile.am: Likewise.
	* libmu_scm/Makefile.am: Likewise.
	* libproto/Makefile.am: Likewise.
	* maidag/Makefile.am: Likewise.
	* mail/Makefile.am: Likewise.
	* messages/Makefile.am: Likewise.
	* mh/Makefile.am: Likewise.
	* movemail/Makefile.am: Likewise.
	* mu/libexec/Makefile.am: Likewise.
	* pop3d/Makefile.am: Likewise.
	* python/2/libmu_py/Makefile.am: Likewise.
	* python/3/libmu_py/Makefile.am: Likewise.
	* readmsg/Makefile.am: Likewise.
	* sieve/Makefile.am: Likewise.
	* testsuite/Makefile.am: Likewise.

2019-02-24  Sergey Poznyakoff  <gray@gnu.org>

	Bugfix.

	* python/3/libmu_py/mailcap.c: Fix leftover uses of
	PyString_FromString and PyInt_FromLong.

2019-02-23  Sergey Poznyakoff  <gray@gnu.org>

	Version 3.6.

	* NEWS: Update.
	* configure.ac: Raise version number Raise VI_CURRENT and clear
	VI_REVISION (due to 18e23d6e).
	* libproto/imap/close.c: Add missing include.

2019-02-03  Sergey Poznyakoff  <gray@gnu.org>

	Update NEWS.

2019-02-03  Sergey Poznyakoff  <gray@gnu.org>

	Rewrite the mailcap support.

	* configure.ac: Build libmailutils/mailcap/Makefile 
	* include/mailutils/mailcap.h: Rewrite
	* include/mailutils/sys/Makefile.am: Add mailcap.h
	* include/mailutils/sys/mailcap.h: New file.
	* include/mailutils/util.h: Add missing include.
	* lib/mailcap.c: Rewrite using new API.
	* libmailutils/Makefile.am: Build in mailcap
	* libmailutils/base/Makefile.am: Remove mailcap.c
	* libmailutils/base/mailcap.c: Remove. 
	* libmailutils/mailcap/Makefile.am: New file.
	* libmailutils/mailcap/ctmatch.c: New file.
	* libmailutils/mailcap/deferrclos.c: New file.
	* libmailutils/mailcap/mcp_creat.c: New file.
	* libmailutils/mailcap/mcp_destr.c: New file.
	* libmailutils/mailcap/mcp_err.c: New file.
	* libmailutils/mailcap/mcp_flags.c: New file.
	* libmailutils/mailcap/mcp_get.c: New file.
	* libmailutils/mailcap/mcp_sel.c: New file.
	* libmailutils/mailcap/mcp_count.c: New file.
	* libmailutils/mailcap/mcp_find.c: New file.
	* libmailutils/mailcap/ent_cmd.c: New file.
	* libmailutils/mailcap/ent_creat.c: New file.
	* libmailutils/mailcap/ent_destr.c: New file.
	* libmailutils/mailcap/ent_locus.c: New file.
	* libmailutils/mailcap/ent_type.c: New file.
	* libmailutils/mailcap/fieldacc.c: New file.
	* libmailutils/mailcap/fields.c: New file.
	* libmailutils/mailcap/finder.c: New file.
	* libmailutils/mailcap/parse.c: New file.
	* libmailutils/mailcap/parsefile.c: New file. 
	* libmailutils/tests/mailcap.c: Rewrite using new API. Improve
	cli
	* libmailutils/tests/mcf.c: New file.
	* libmailutils/tests/ctm.c: New file.
	* libmailutils/tests/ctm.at: New file.
	* libmu_cpp/mailcap.cc: Rewrite using new API.
	* python/2/libmu_py/mailcap.c: Rewrite using new API.
	* python/3/libmu_py/mailcap.c: Rewrite using new API.
	* examples/python/2/mailcap.py: Minor change. This example is
	broken with the new API. Should be fixed.
	* include/mailutils/cpp/mailcap.h: Update
	* include/mailutils/cpp/pop3.h: Update

2019-02-02  Sergey Poznyakoff  <gray@gnu.org>

	New iterator functions: mu_iterator_skip_while and
	mu_iterator_skip_until.

	The mu_iterator_skip_while function continues iteration while
	the supplied predicate function returns true. The
	mu_iterator_skip_until function continues iteration until the
	supplied predicate function returns true.

	* include/mailutils/iterator.h: Add new prototypes.
	* libmailutils/base/iterator.c: Implement new functions.

2019-01-31  Sergey Poznyakoff  <gray@gnu.org>

	Rewrite the transcript stream.

	The new implementation consists of two independent state
	machines for each transcript channel (input and output). The
	MU_XSCRIPT_PAYLOAD state can be turned on for a predefined
	number of bytes on each channel. After that many bytes pass
	through, the state will return back to MU_XSCRIPT_NUMBER. This
	allows, in particular, to improve logging of client commands
	containing literals in imap4d.

	* include/mailutils/stream.h (MU_IOCTL_XSCRIPTSTREAM_CHANNEL):
	New ioctl subcode.
	(mu_xscript_channel): New struct. (MU_XSCRIPT_LEVEL_IS_PACKED)
	(MU_XSCRIPT_LEVEL_MASK,MU_XSCRIPT_LEVEL_UNMASK)
	(MU_XSCRIPT_LEVEL_PACK): New macros.
	* include/mailutils/sys/xscript-stream.h (_mu_xscript_channel):
	New struct.
	(_mu_xscript_stream): Keep independent state for each channel.
	* libmailutils/stream/xscript-stream.c: Rewrite as a state
	machine with independent states for input and output channels.
	* libmailutils/tests/xscript.at: Test packed channel levels and
	MU_IOCTL_XSCRIPTSTREAM_CHANNEL ioctl.
	* libmailutils/tests/xscript.c: Rewrite command parser. 
	* imap4d/imap4d.h (xscript_declare_client_payload): New proto.
	* imap4d/util.c (xscript_declare_client_payload): New function.
	* imap4d/io.c (imap4d_readline): Use
	xscript_declare_client_payload after literals.

2019-01-29  Sergey Poznyakoff  <gray@gnu.org>

	imap4d: Proper case-insensitive searches over multibyte
	strings.

	This requires libunistring.

	* NEWS: Update.
	* README: Update.
	* configure.ac: Check for libunistring.
	* libmailutils/base/version.c: Reflect libunistring usage.
	* imap4d/Makefile.am: Link with libunistring, if available.
	* imap4d/imap4d.h (unistr_downcase)
	(unistr_is_substring): New protos.
	* imap4d/search.c (_scan_header)
	(_scan_header_all,_match_text): Use unistr_is_substring for
	searches.
	* imap4d/unistr_c.c: New file.
	* imap4d/unistr_u8.c: New file.
	* imap4d/tests/search.at: Add new test.

2019-01-28  Sergey Poznyakoff  <gray@gnu.org>

	Revert 3aeec0dcc151b836cb09d756ad41598c95201446.

	Adding 1 to the buffer size is necessary, because
	_stream_scandelim requires buffer to provide enough space to
	accomodate the trailing 0. Consequently, the minimal acceptable
	buffer size is 2.

2019-01-27  Sergey Poznyakoff  <gray@gnu.org>

	Minor fix.

	* search.c (_match_multipart): Initialize result.

2019-01-26  Sergey Poznyakoff  <gray@gnu.org>

	Minor fix.

	* imap4d/search.c (parse_search_key): Fix eventual NULL pointer
	dereference.

2019-01-26  Sergey Poznyakoff  <gray@gnu.org>

	Add tests for imap4d SEARCH BODY, TEXT, and CHARSET.

	* imap4d/tests/.gitignore: New file.
	* imap4d/tests/ckiconv.c: New file.
	* imap4d/tests/Makefile.am: Build ckiconv.c
	* imap4d/tests/search.at: Add tests for BODY, TEXT and CHARSET
	* imap4d/tests/testsuite.at (IMAP4D_WITH_PREREQ): New macro
	(IMAP4D_CHECK): Skip test if the supplied prerequisite is not
	satisfied. 
	* testsuite/spool/search2.mbox: New file.
	* testsuite/spool/DISTFILES: Add search2.mbox. 
	* mail/decode.c (mime_descend): Fix handling of message/rfc822.

2019-01-26  Sergey Poznyakoff  <gray@gnu.org>

	Remove misguiding comment.

2019-01-26  Sergey Poznyakoff  <gray@gnu.org>

	imap4d: implement SEARCH CHARSET; fix BODY and TEXT searches.

	* imap4d/search.c: Implement proper BODY searches. Implement
	CHARSET.
	* imap4d/util.c (util_strcasestr): Remove. Use mu_c_strcasestr
	instead.
	* imap4d/imap4d.h: Likewise.
	* NEWS: Document changes.

2019-01-25  Sergey Poznyakoff  <gray@gnu.org>

	Improve error checking in stream writing functions.

	* libmailutils/stream/stream.c (mu_stream_write): Return EIO on
	short writes if pnwritten is NULL.
	* libmailutils/stream/streamcpy.c (mu_stream_copy): Likewise
	(if source stream size is known.

2019-01-24  Sergey Poznyakoff  <gray@gnu.org>

	Fix stream reference implementation.

	Do not propagate streamref's error and eof state upstream.

	* libmailutils/stream/streamref.c (streamref_return): Remove
	function. All uses updated.

2019-01-23  Sergey Poznyakoff  <gray@gnu.org>

	mail: fix completion of set, unset, and variable.

2019-01-23  Sergey Poznyakoff  <gray@gnu.org>

	mail: implement variable and command expansion in echo command.

	* mail/echo.c: Implement variable and command expansion.
	* mail/mail.c (main): Set PID mailvar.
	* mail/mailvar.c (mailvar_tab): New variable PID (to help in
	debugging).
	(set_folder): Expand initial ~
	* mail/set.c: Remove misguiding comment.

2019-01-23  Sergey Poznyakoff  <gray@gnu.org>

	Fix in IMAP wildcard matcher.

	* libmailutils/imapio/wildmatch.c (_wild_match): Handle % at
	the end of input same way as *.

2019-01-23  Sergey Poznyakoff  <gray@gnu.org>

	mail: fixes in completion routines.

2019-01-23  Sergey Poznyakoff  <gray@gnu.org>

	mail: improve message set parser.

	* mail/from.c (sender_string): New function.
	* mail/mail.h: Likewise.
	* mail/msgset.y: Fix memory management and error reporting.
	Implement sender address matching.
	* mail/util.c (util_outfolder_name): Always return allocated
	value.
	* mail/copy.c (mail_copy0): Add typecast.

2019-01-23  Sergey Poznyakoff  <gray@gnu.org>

	mail: new notation @, for the mailbox given with the -f option.

	* doc/texinfo/programs/mail.texi: Document the @ notation.
	* NEWS: Likewise.
	* mail/copy.c (mail_copy0): Rewrite. Use mailbox URLs instead
	of filenames.
	* mail/file.c (mail_expand_name): Return integer code. On
	success, convert the expanded name to URL and return it in the
	memory location supplied by the second argument. Use new
	shorthand notation @, for the name of the file given with the
	-f option. All uses changed.
	* mail/mail.c (secondary_url): New global.
	(main): Save the URL of the file given with the -f option in
	secondary_url. Use it, instead of the file variable, to decide
	what kind of summary message to display for empty mailbox (see
	commit 99b6b6f02c3cf94ebe1daf7233a702c743d6a2b5).
	* mail/mail.h (secondary_url): New global.
	(mail_expand_name): Change prototype.
	* mail/mailline.c: Minor changes. 
	* libmailutils/wicket/noauth.c (noauth_ticket_get_cred): Return
	MU_ERR_AUTH_NO_CRED.

2019-01-22  Sergey Poznyakoff  <gray@gnu.org>

	Summarize recent changes in NEWS.

2019-01-22  Sergey Poznyakoff  <gray@gnu.org>

	Improve mail folder completion.

	* mail/mailline.c (filegen_init): Check if the mail folder is
	the same as the one used by the current mailbox, and reuse it
	if so.

2019-01-22  Sergey Poznyakoff  <gray@gnu.org>

	Add missing prototype.

	* include/mailutils/url.h (mu_url_is_same_portstr): New proto.

2019-01-22  Sergey Poznyakoff  <gray@gnu.org>

	Remove central registry of created folders.

	The way it is implemented now, it creates more problems than
	offers solutions. In particular, it makes it impossible to open
	two mailboxes in the same IMAP account.

	* libmailutils/mailbox/folder.c (known_folder_list)
	(folder_lock): Remove variable.
	(is_known_folder): Remove function.
	(mu_folder_create_from_record): Don't use static folder list.

2019-01-22  Sergey Poznyakoff  <gray@gnu.org>

	fix in mail completion.

	* mail/mailline.c (filegen_init): Append tailing delimiter to
	folders only on exact match.

2019-01-22  Sergey Poznyakoff  <gray@gnu.org>

	Minor fix in imap client.

	* libproto/imap/close.c (_mu_close_handler): Free mbox_name.

2019-01-21  Sergey Poznyakoff  <gray@gnu.org>

	Fixes in imap client: handle EXPUNGE response, fix
	incorporation of new messages.

	Certain servers do not issue EXISTS unsolicited response after
	expunging. Use EXPUNGE responses to keep track of the deleted
	messages.

	Internal structure of imap mailbox object did not interact well
	with incorporating new messages. It is fixed.

	* include/mailutils/imap.h (MU_IMAP_CB_EXPUNGE): New callback
	code.
	* include/mailutils/sys/imap.h (_mu_imap_message): New member:
	msgno.
	(_mu_imap_mailbox): Change type of msgs to struct
	_mu_imap_message **. Each _mu_imap_message * is registered as
	owner for various MU objects, so it is important it does not
	change during reallocations.
	* libproto/imap/mbox.c (_imap_msg_free): Free the message
	itself.
	(_imap_attr_clr_flags): Fix bitwise op.
	(_imap_mbx_get_message,_imap_realloc_messages)
	(aggregate_attributes,_imap_mbx_gensync)
	(_imap_fetch_callback): Reflect change in the type of msgs
	array.
	(_imap_expunge_callback): New callback.
	(_imap_mbx_open): Register _imap_expunge_callback.
	* libproto/imap/resproc.c (_process_unsolicited_response):
	handle the EXPUNGE response.

2019-01-21  Sergey Poznyakoff  <gray@gnu.org>

	Fix page invalidation in mail.

2019-01-21  Sergey Poznyakoff  <gray@gnu.org>

	Improve folder handling and expansion in mail. Add convenience
	functions to the library.

	* configure.ac: Build libmailutils/wicket
	* libmailutils/Makefile.am: Likewise.
	* libmailutils/base/wicket.c: Move file wicket stuff to ...
	* libmailutils/wicket/file.c: ... here
	* libmailutils/wicket/noauth.c: New file.
	* libmailutils/wicket/Makefile.am: New file. 
	* include/mailutils/auth.h (mu_noauth_ticket_create)
	(mu_noauth_wicket_create): New protos.
	* include/mailutils/folder.h (mu_folder_attach_ticket)
	(mu_folder_is_local): New protos.
	* include/mailutils/mailbox.h (mu_mailbox_attach_ticket): New
	proto.
	* include/mailutils/sys/folder.h (_mu_folder): Remove flags.
	Add new member: is_local.
	* libmailutils/mailbox/folder.c (mu_folder_create_from_record):
	Set is_local.
	(mu_folder_attach_ticket): New function.
	(mu_folder_is_local): New function.
	* libmailutils/mailbox/mbx_default.c
	(mu_mailbox_attach_ticket): New function.
	* libmailutils/url/create.c: Allow for trailing / in url. 
	* libproto/imap/mbox.c (_imap_mbx_open): Do initial scan.
	(__imap_msg_get_stream): Initialize clos.size.
	* libproto/imap/tests/imapfolder.c: Attach ticket to the
	folder. 
	* mail/cd.c (mail_cd): Expand directory name (~, %, +
	notations) prior to use.
	* mail/file.c (mail_file): Attach ticket to the mailbox.
	* mail/copy.c (append_to_mailbox): Likewise.
	* mail/mailline.c: Rewrite directory expansion. Implement fully
	functional folder expansion.
	* mail/util.c (util_folder_path)
	(util_outfolder_name): Rewrite using mu_mailbox_expand_name.

2019-01-18  Sergey Poznyakoff  <gray@gnu.org>

	Read message headers during initial scan of an imap mailbox.

	This considerably speeds up the operation of such tools as mail
	(initial loading), frm or from.

	* include/mailutils/sys/imap.h (_mu_imap_message): New member:
	header_stream.
	* libproto/imap/mbox.c (_imap_msg_free): Destroy header_stream.
	(_imap_hdr_fill): Rewrite.
	(fetch_response_parser): Handle MU_IMAP_FETCH_BODY.
	(_imap_mbx_scan): Fetch BODY.PEEK[HEADER].

2019-01-18  Sergey Poznyakoff  <gray@gnu.org>

	Don't reveal file name with the '0 messages' summary message.

	Rationale: file name can contain password.

	* mail/mail.c (main): Make sure file is always allocated. Fill
	it with 0's and free when no longer needed. Use mail_summary to
	display the summary for empty mailbox.

2019-01-18  Sergey Poznyakoff  <gray@gnu.org>

	Minor change.

	* mail/testsuite/lib/mail.exp (default_mail_start): Join
	arguments into a string.

2019-01-18  Sergey Poznyakoff  <gray@gnu.org>

	mail: implement msglist completion.

	* mail/mailline.c (msglist_closure_compl): Make the matches
	argument optional.
	(msglist_compl): Implement using msglist_closure_compl.

2019-01-17  Sergey Poznyakoff  <gray@gnu.org>

	Improve completion in mail.

	This affects the following commands: pipe, file, write, store.

	* mail/mail.h (shell_compl): New function.
	* mail/mailline.c (ml_command_completion): Change the meaning
	of the last argument to command_completion function. All
	functions updated.
	(msgtype_generator): Take into account '/' that can follow ':'.
	Prefix returned values with :.
	(header_generator): Append ':/' to the returned strings.
	(compl_concat): New function.
	(file_compl): Rewrite.
	(msglist_closure_compl): New function.
	(file_compl_matches,msglist_file_compl,exec_compl): Rewrite.
	(shell_compl): New function.
	* mail/table.c: Implement completion for pipe and shell
	commands.

2019-01-16  Sergey Poznyakoff  <gray@gnu.org>

	Edit docs.

	* doc/texinfo/programs/mail.texi: Reorder material. Document
	message states. Rewrite description of message lists. Describe
	mailbox argument in file, save, write, etc.
	* doc/texinfo/mailutils.texi: Regenerate detailed menu

2019-01-16  Sergey Poznyakoff  <gray@gnu.org>

	Bugfix.

	* libmailutils/base/amd.c (amd_body_stream_readdelim): Fix line
	length calculation.

2019-01-16  Sergey Poznyakoff  <gray@gnu.org>

	mail: fix / and :/ searches in message sets.

	* mail/mail.h (msgset_remove): New proto.
	* mail/msgset.y (yylex): Make sure to never move cur_p past the
	terminating 0 character.
	(msgset_append): Eliminated duplicates.
	(select_body): Read entire lines. Fix the conditional: return
	true if the matching line was found.

2019-01-16  Sergey Poznyakoff  <gray@gnu.org>

	Split programs.texi into manageable parts.

	* NEWS: Update.
	* configure.ac: Version 3.5.90
	* doc/texinfo/Makefile.am (mailutils_TEXINFOS): Add new files.
	* doc/texinfo/programs.texi: Include sections from
	programs/*.texi
	* doc/texinfo/programs/comsatd.texi: New file.
	* doc/texinfo/programs/frm.texi: New file.
	* doc/texinfo/programs/guimb.texi: New file.
	* doc/texinfo/programs/imap4d.texi: New file.
	* doc/texinfo/programs/maidag.texi: New file.
	* doc/texinfo/programs/mail.texi: New file.
	* doc/texinfo/programs/mailutils.texi: New file.
	* doc/texinfo/programs/messages.texi: New file.
	* doc/texinfo/programs/mimeview.texi: New file.
	* doc/texinfo/programs/movemail.texi: New file.
	* doc/texinfo/programs/pop3d.texi: New file.
	* doc/texinfo/programs/readmsg.texi: New file.
	* doc/texinfo/programs/sieve.texi: New file.

2019-01-15  Sergey Poznyakoff  <gray@gnu.org>

	Fix the pipe command (mail)

	* mail/pipe.c: Always treat last argument as the name of the
	command to use.

2019-01-15  Sergey Poznyakoff  <gray@gnu.org>

	Improve mail documentation.

2019-01-15  Sergey Poznyakoff  <gray@gnu.org>

	Minor change.

	* libmailutils/cli/cli.c: Update copyright year.

2019-01-03  Sergey Poznyakoff  <gray@gnu.org>

	Update copyright years.

2018-12-25  Sergey Poznyakoff  <gray@gnu.org>

	Fix typos and improve wording in the docs.

	Reported by Dan Jacobson.

2018-12-25  Sergey Poznyakoff  <gray@gnu.org>

	Fix showenvelope.

	* mail/envelope.c (print_stream_envelope): New function. End
	output with a newline.
	* mail/mail.h: Likewise.
	* mail/print.c (mail_print_msg): Print envelope to the created
	output stream, instead of mu_strout.

2018-11-09  Sergey Poznyakoff  <gray@gnu.org>

	Fix obsolete docstring.

	* libmailutils/cli/stdcapa.c: Fix description of the argument
	syntax for the "debug" statement.

2018-10-27  Sergey Poznyakoff  <gray@gnu.org>

	Version 3.5.

2018-10-24  Sergey Poznyakoff  <gray@gnu.org>

	Add missing prototype.

2018-10-24  Sergey Poznyakoff  <gray@gnu.org>

	sieve: set variables from command line.

	The new command line option --variable initializes the RFC 5229
	variable.

	* NEWS: Update.
	* doc/texinfo/programs.texi: Fix description of sieve command
	line options.
	* include/mailutils/sieve.h (mu_sieve_variable_initialize): New
	proto.
	* libmu_sieve/runtime.c (sieve_run): Call
	mu_i_sv_init_variables to clear and initialize the table of
	variables.
	* libmu_sieve/sieve-gram.y (mu_sieve_machine_dup): Copy
	variables.
	(mu_sieve_machine_destroy): Destroy table of variables and
	initializer list.
	* libmu_sieve/sieve-priv.h (mu_sieve_machine) <init_var>: New
	member.
	(mu_sieve_variable_initializer): New type.
	(mu_i_sv_init_variables): New proto.
	* libmu_sieve/variables.c (mu_sieve_variable_initialize): New
	function.
	(mu_i_sv_copy_variables): Copy initializers as well.
	(mu_i_sv_init_variables): New function.
	* sieve/sieve.c: New command line option --variable.
	* sieve/tests/variables.at: Test the --variable option.

2018-10-23  Sergey Poznyakoff  <gray@gnu.org>

	Fix static linkage.

	* libmailutils/datetime/scantime.c (get_num): static
	* mu/libexec/ldflags.c: Make sure libmailutils is linked after
	all libmu_ libraries that rely on it.

2018-10-22  Sergey Poznyakoff  <gray@gnu.org>

	Fix wordsplit command expansion and related tests.

	* include/mailutils/wordsplit.h (MU_WRDSO_ARGV): Remove.
	* libmailutils/string/wordsplit.c (expcmd): Always split
	command line into arguments. This fixes
	https://savannah.gnu.org/bugs/?54830
	* libmailutils/tests/wordsplit.at: Rewrite command expansion
	tests.
	* libmailutils/tests/wsp.c: Implement internal commands,
	instead of calling shell ones. This fixes
	https://savannah.gnu.org/bugs/?54829.
	* libmailutils/string/expvar.c: Remove the use of
	MU_WRDSO_ARGV.

2018-10-04  Sergey Poznyakoff  <gray@gnu.org>

	Fix imap client behavior when opening empty mailboxes.

	According to RFC 3501 (page 89):

	 The server should respond with a tagged BAD
	 response to a command that uses a message
	 sequence number greater than the number of
	 messages in the selected mailbox. This
	 includes "*" if the selected mailbox is empty. 
	* include/mailutils/sys/imap.h (_mu_imap_mailbox)<total_size>:
	Remove unnecessary field.
	* libproto/imap/mbox.c (_imap_fetch_callback): Fix array size
	calculation.
	(_imap_mbx_scan): Don't issue FETCH command if the mailbox is
	empty.

2018-08-26  Sergey Poznyakoff  <gray@gnu.org>

	Implement SCM interface to mailutils filters.

	* include/mailutils/guile.h (mu_port_make_from_stream): Remove
	unused msg argument. All uses updated.
	* libmu_scm/mu_filter.c: New file.
	* libmu_scm/Makefile.am: Add mu_filter.c
	* libmu_scm/mu_message.c (mu-message-get-port): Add missing
	anchor to the docstring.
	* libmu_scm/mu_port.c (mu_port): Remove msg.
	* libmu_scm/mu_scm.c (mu_scm_init): Call mu_scm_filter_init. 
	* NEWS: Updated.

2018-08-25  Sergey Poznyakoff  <gray@gnu.org>

	Bugfix in base64 encoder.

	* libmailutils/filter/base64.c (_base64_encoder): Don't return
	immediately on eof. The encoder can have some more characters
	for output, left over from the previous call.

2018-08-16  Ivan A. Melnikov  <iv@altlinux.org>

	Force terminating \0 in mh_format result.

	Apparently, mu_stream_read is not required to put the
	terminating zero into the buffer, so we need to do it in its
	caller.

	Signed-off-by: Ivan A. Melnikov <iv@altlinux.org>

2018-08-13  Sergey Poznyakoff  <gray@gnu.org>

	Bugfix in python configuration code.

	* configure.ac: Use $PYTHON_CONFIG instead of the hardcoded
	python-config name.

2018-07-30  Sergey Poznyakoff  <gray@gnu.org>

	Version 3.4.91.

	* NEWS: Update version number.
	* configure.ac: Likewise.

2018-07-30  Sergey Poznyakoff  <gray@gnu.org>

	Support for Python 3.

	Support for v2 is retained for a while. Both the API and the
	syntax of the two versions differ considerably enough to keep
	both versions apart in parallel directory subtrees, instead of
	fiddling with CPP directives and Automake conditionals. So,
	instead of prior 'python/' and 'examples/python' we now have
	'python/2', 'python/3', and 'examples/python/2' with
	'examples/python/3'. The customized loader is modified to
	insert the appropriate path to the sys.path.

	When Python 2 is definitely gone, the directory structures will
	be flattened again, by removing additional version number
	subdirectory.

	* Makefile.am (SUBDIRS): Add python unconditionally
	* configure.ac (PYTHON_MAJOR): New substvar.
	(MU_LIB_PY): Change path
	(MU_COND_PYTHON2,MU_COND_PYTHON3): New conditionals.
	* examples/python/*: Rename to examples/python/2/*
	* examples/python/3/Makefile.am: New file.
	* examples/python/3/addr.py: New file.
	* examples/python/3/auth.py: New file.
	* examples/python/3/iconv.py: New file.
	* examples/python/3/lsf.py: New file.
	* examples/python/3/mailcap.py: New file.
	* examples/python/3/mimetest.py: New file.
	* examples/python/3/msg-send.py: New file.
	* examples/python/3/sfrom.py: New file.
	* examples/python/3/url-parse.py: New file.
	* include/mailutils/python.h: Remove inclusion of Python.h. It
	must included before all other files.
	* lib/python.c: Include Python.h
	* python/*: Rename to python/2/*
	* python/usercustomize.py: Insert path to the appropriate
	Python version implementation to the sys.path
	* python/3/Makefile.am: New file.
	* python/3/libmu_py/Makefile.am: New file.
	* python/3/libmu_py/address.c: New file.
	* python/3/libmu_py/attribute.c: New file.
	* python/3/libmu_py/auth.c: New file.
	* python/3/libmu_py/body.c: New file.
	* python/3/libmu_py/envelope.c: New file.
	* python/3/libmu_py/errno.c: New file.
	* python/3/libmu_py/error.c: New file.
	* python/3/libmu_py/filter.c: New file.
	* python/3/libmu_py/folder.c: New file.
	* python/3/libmu_py/header.c: New file.
	* python/3/libmu_py/libmu_py.c: New file.
	* python/3/libmu_py/libmu_py.h: New file.
	* python/3/libmu_py/list.c: New file.
	* python/3/libmu_py/mailbox.c: New file.
	* python/3/libmu_py/mailcap.c: New file.
	* python/3/libmu_py/mailer.c: New file.
	* python/3/libmu_py/message.c: New file.
	* python/3/libmu_py/mime.c: New file.
	* python/3/libmu_py/nls.c: New file.
	* python/3/libmu_py/registrar.c: New file.
	* python/3/libmu_py/script.c: New file.
	* python/3/libmu_py/secret.c: New file.
	* python/3/libmu_py/sieve.c: New file.
	* python/3/libmu_py/stream.c: New file.
	* python/3/libmu_py/url.c: New file.
	* python/3/libmu_py/util.c: New file.
	* python/3/mailutils/Makefile.am: New file.
	* python/3/mailutils/__init__.py: New file.
	* python/3/mailutils/address.py: New file.
	* python/3/mailutils/attribute.py: New file.
	* python/3/mailutils/auth.py: New file.
	* python/3/mailutils/body.py: New file.
	* python/3/mailutils/c_api.c: New file.
	* python/3/mailutils/envelope.py: New file.
	* python/3/mailutils/error.py: New file.
	* python/3/mailutils/filter.py: New file.
	* python/3/mailutils/folder.py: New file.
	* python/3/mailutils/header.py: New file.
	* python/3/mailutils/mailbox.py: New file.
	* python/3/mailutils/mailcap.py: New file.
	* python/3/mailutils/mailer.py: New file.
	* python/3/mailutils/message.py: New file.
	* python/3/mailutils/mime.py: New file.
	* python/3/mailutils/nls.py: New file.
	* python/3/mailutils/registrar.py: New file.
	* python/3/mailutils/secret.py: New file.
	* python/3/mailutils/sieve.py: New file.
	* python/3/mailutils/stream.py: New file.
	* python/3/mailutils/url.py: New file.
	* python/3/mailutils/util.py: New file.

2018-07-27  Sergey Poznyakoff  <gray@gnu.org>

	Bugfix.

	* libmailutils/mime/mimehdr.c (_mime_header_parse): Initialize
	ws.ws_options prior to modifying it.

2018-07-25  Sergey Poznyakoff  <gray@gnu.org>

	Add maintainer's makefiles.

2018-07-23  Sergey Poznyakoff  <gray@gnu.org>

	Support for Berkeley DB versions 5 and 6.

	Drop the legacy configure option --with-db2

2018-07-20  Sergey Poznyakoff  <gray@gnu.org>

	Add test cases missing from the distribution.

	* readmsg/tests/Makefile.am (TESTSUITE_AT): Add missing
	testcases

2018-06-22  Sergey Poznyakoff  <gray@gnu.org>

	Minor documentation fix.

2018-06-22  Sergey Poznyakoff  <gray@gnu.org>

	Fix endianness bug in string to IP conversion.

	* libmailutils/cidr/fromsa.c (_mu_inaddr_to_bytes)
	(_mu_sockaddr_to_bytes): Fix improper endianness conversion.
	* libmailutils/cidr/tosa.c (mu_cidr_to_sockaddr): Simplify
	conversion.

2018-06-13  Sergey Poznyakoff  <gray@gnu.org>

	Fix eventual segmentation violation in imap4d.

	The coredump occurred if a recently started child received a
	termination signal before initializing iostream.

	* imap4d/bye.c (imap4d_bye0): Rename to imap4d_bye_command. All
	uses changed.
	* imap4d/io.c (io_untagged_response): Check if iostream is
	initialized.

2018-06-13  Sergey Poznyakoff  <gray@gnu.org>

	libmu_scm: fix docs.

2018-06-12  Sergey Poznyakoff  <gray@gnu.org>

	libmu_scm: add testcases for mu-mime functions (with bugfixes)

	* libmu_scm/mu_message.c (mu_scm_message_add_owner): Fix owner
	list construction.
	* libmu_scm/mu_mime.c (mu-mime-create): Fix a bug: both
	arguments are optional now.
	* libmu_scm/tests/Makefile.am: Add new tests.
	* libmu_scm/tests/testsuite.at: Likewise,

	New testcases: 
	* libmu_scm/tests/mime-add-part.at
	* libmu_scm/tests/mime-create.at
	* libmu_scm/tests/mime-get-num-parts.at
	* libmu_scm/tests/mime-get-part.at
	* libmu_scm/tests/mime-multipart-p.at
	* libmu_scm/tests/mime-p.at

2018-06-12  Sergey Poznyakoff  <gray@gnu.org>

	libmu_scm: more tests.

	* testsuite/spool/mbox2: New file. Same messages as in mbox1,
	but with Mailutils auxiliary headers added. Ideally,
	libmailutils should not add any headers to the messages, unless
	explicitly requested to do so. Hopefully, I'll fix this in
	future.
	* testsuite/spool/DISTFILES: Add mbox2 and mime.msg 
	* libmu_scm/tests/mailbox-append-message.at: New testcase.
	* libmu_scm/tests/mailbox-expunge.at: New testcase.
	* libmu_scm/tests/message-delete.at: New testcase.
	* libmu_scm/tests/message-get-flag.at: New testcase. 
	* libmu_scm/mu_message.c (mu_scm_message_print): Display flags.
	* libmu_scm/tests/Makefile.am: Add new files.
	* libmu_scm/tests/mailbox-print.at: Remove the now superfluous
	quoting.
	* libmu_scm/tests/message-get-part.at: Likewise.
	* libmu_scm/tests/testsuite.at (MU_GUILE_CHECK): Quote the
	argument to AT_DATA Include new tests.

	Changes missing from the previous commit: 
	* libmu_scm/mailutils/ancilla.scm
	* libmu_scm/mu_body.c
	* libmu_scm/mu_port.c

2018-06-10  Sergey Poznyakoff  <gray@gnu.org>

	libmu_scm: minor fixes; add more tests.

	* libmu_scm/mailutils/ancilla.scm (string->message)
	(file->message): Ise open- call instead of call-with-input to
	avoid premature closing of the input port. This has a drawbak
	that the port will be actually closed only after the returned
	message is destroyed (possibly by the gc).
	* libmu_scm/mu_body.c: Use scm_intprint when printing objects.
	* libmu_scm/mu_mailbox.c: Likewise.
	* libmu_scm/mu_port.c: Likewise.
	* libmu_scm/mu_message.c (mu_scm_message_free): Fix destroying
	of the underlying mu_message_t object. 
	* libmu_scm/tests/message-get-num-parts.at: New file.
	* libmu_scm/tests/message-get-part.at: New file.
	* libmu_scm/tests/message-multipart.at: New file.
	* testsuite/spool/mime.msg: New file.

2018-06-09  Sergey Poznyakoff  <gray@gnu.org>

	Upgrade gint.

	This suppresses spurious warnings when generating
	guile-procedures.txt

2018-06-09  Sergey Poznyakoff  <gray@gnu.org>

	Add more libmu_scm tests.

	* libmu_scm/Makefile.am (C_SRCS): Add portstream.c
	* libmu_scm/mailutils/Makefile.am (EXTRA_DIST): Add ancilla.scm
	* libmu_scm/mailutils/ancilla.scm: New file
	* libmu_scm/mu_message.c (mu-message-get-header-fields): Fix
	operation when called with three arguments.
	(mu-message-from-port): New function.
	* libmu_scm/portstream.c: New file.

2018-06-08  Sergey Poznyakoff  <gray@gnu.org>

	Further fixes in the scheme library. Add guile testsuite.

	* .gitignore: Ignore .gdbinit
	* README: Update.
	* configure.ac: Add guile testsuite
	* libmu_scm/Makefile.am (SUBDIRS): Add tests.
	* libmu_scm/mu_body.c: Update smob support.
	* libmu_scm/mu_dbgport.c (mu_scm_make_debug_port): Delegate
	buffering to mailutils streams layer.
	* libmu_scm/mu_mailbox.c: Update smob support.
	(mu-mailbox-more-messages?): Fix reversed return value.
	* libmu_scm/mu_message.c: Update smob support.
	* libmu_scm/mu_mime.c: Likewise.
	* libmu_scm/mu_port.c (mu_port_make_from_stream): Delegate
	buffering to mailutils streams layer. 
	* libmu_scm/tests/.gitignore: New file.
	* libmu_scm/tests/Makefile.am: New file.
	* libmu_scm/tests/atlocal.in: New file.
	* libmu_scm/tests/const.at: New file.
	* libmu_scm/tests/mailbox-get-message.at: New file.
	* libmu_scm/tests/mailbox-get-size.at: New file.
	* libmu_scm/tests/mailbox-get-url.at: New file.
	* libmu_scm/tests/mailbox-iterate.at: New file.
	* libmu_scm/tests/mailbox-messages-count.at: New file.
	* libmu_scm/tests/mailbox-open-exc.at: New file.
	* libmu_scm/tests/mailbox-open.at: New file.
	* libmu_scm/tests/mailbox-print.at: New file.
	* libmu_scm/tests/message-create.at: New file.
	* libmu_scm/tests/message-print.at: New file.
	* libmu_scm/tests/testsuite.at: New file.

2018-06-02  Sergey Poznyakoff  <gray@gnu.org.ua>

	Switch to Guile 2.2.0.

	* configure.ac" Set minimum supported Guile version to 2.2.0
	* libmu_scm/mu_body.c: Rewrite.
	* libmu_scm/mu_dbgport.c: Rewrite.
	* libmu_scm/mu_mailbox.c: Update types.
	* libmu_scm/mu_message.c: Likewise.
	* libmu_scm/mu_mime.c: Likewise.
	* libmu_scm/mu_port.c: Likewise.

2018-06-02  Sergey Poznyakoff  <gray@gnu.org>

	Fix absolute name of the "missing" utility.

	* am/bison.m4: Use $am_aux_dir. Take care to not expand $SHELL
	prematurely.
	* am/flex.m4: Likewise.

2018-05-16  Sergey Poznyakoff  <gray@gnu.org>

	Fix the use of uninitialized variable.

2018-04-18  Sergey Poznyakoff  <gray@gnu.org>

	Minor fixes in the mailutils-dbm utility.

	* mu/libexec/dbm.c (write_quoted_string): Fix expected return
	from mu_wordsplit_c_quote_char.
	(add_records): Don't break on empty lines.

2018-02-20  Sergey Poznyakoff  <gray@gnu.org.ua>

	Port wordsplit from grecs
	dae43f323db9578e656e3a6c53440e2365421af7.

	* libmailutils/string/wordsplit.c (expvar): Gracefully handle
	NULL values in an ENV_KV environment.
	* include/mailutils/wordsplit.h: Fix typos

2018-01-19  Sergey Poznyakoff  <gray@gnu.org.ua>

	Version 3.4.90; update copyright years.

2018-01-19  Sergey Poznyakoff  <gray@gnu.org.ua>

	Add new date/time specifier for headline variable in mail.

	The new %D specifier allows the user to supply arbitrary
	strftime(3) format string for outputting message date/time.
	E.g.:

	 set headline="%4m %20D{%Y-%m-%dT%H:%M:%S} %18f %s" 
	* mail/from.c (hdr_date): Take format from data, if supplied.
	(compile_headline): Handle the %D specifier
	* mail/util.c (util_do_command): Return immediately if command
	parsing failed. 
	* mail/tests/D.at: New testcase.
	* mail/tests/Makefile.am: Add new testcase.
	* mail/tests/testsuite.at: Likewise. 
	* NEWS: Document changes.
	* doc/texinfo/strftime.texi: New file.
	* doc/texinfo/Makefile.am: Add strftime.texi
	* doc/texinfo/mailutils.texi: Include strftime.texi
	* doc/texinfo/programs.texi: Document the %D format specifier.

2018-01-18  Sergey Poznyakoff  <gray@gnu.org>

	Fix header field alignment in header output of the mail
	command.

	* mail/from.c (compile_headline): Honor the alingment setting.
	* mail/tests/align.at: New testcase.
	* mail/tests/Makefile.am: Add new testcase.
	* mail/tests/testsuite.at: Include new testcase.

2018-01-18  Sergey Poznyakoff  <gray@gnu.org>

	Minor fixes.

	* doc/texinfo/mailutils.texi: Fix typos in the imap URL
	example.
	* libmailutils/locus/linetrack.c: Re-word the comment.
	* mimeview/grammar.y: Remove unnecessary assignment.

2017-12-29  Sergey Poznyakoff  <gray@gnu.org>

	Fix memory management in imap4d.

	* imap4d/io.c (imap4d_tokbuf_getline): Add missing index check.
	* imap4d/search.c (parse_simple_key): Don't free msgset (it
	will be freed later).

2017-12-17  Sergey Poznyakoff  <gray@gnu.org>

	Update ChangeLog.amend.

2017-12-16  Sergey Poznyakoff  <gray@gnu.org>

	Fix the operation of CRLF and CRLFDOT filters.

	When encoding, these filters used to retain any existing CRLF
	sequences untouched on output. As a result, it was not possible
	to predict the number of characters output having the number of
	characters and number of lines on input. Due to this imap4d
	fetch would produce invalid literal output on FETCH command if
	the requested stream (usually body), contained a mixture of LF
	and CRLF terminated lines. Moreover, encode + decode operations
	would not be idempotent in this case.

	To fix this, the default behavior of CRLF and CRLFDOT filter in
	encode mode is changed to translate each LF to CRLF, no matter
	what the prior character was. To invoke the former
	"normalizing" behavior, the "-n" option argument is provided
	for mu_filter_create_args.

	* imap4d/fetch.c (fetch_io): Use raw stream when possible. Use
	a temporary CRLF translator to ensure proper positioning if
